// WARNING - DO NOT EDIT THIS FILE:
// This file was automatically generated from scripts/ShPosition.hpp.py.
// If you wish to change it, edit that file instead.
//
// ---
//
// Sh: A GPU metaprogramming language.
//
// Copyright 2003-2006 Serious Hack Inc.
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
// MA  02110-1301, USA
//////////////////////////////////////////////////////////////////////////////

#ifndef SH_SHPOSITION_HPP
#define SH_SHPOSITION_HPP

#include "ShPoint.hpp"
namespace SH {

/** A vertex or fragment position.
 * 
 * This is semantically a point, but is bound preferentially to the position
 * input and output of the rasterizer or to the vertex position when
 * used in vertex and fragment shaders.
 * 
 *
 */

typedef ShAttrib<1, SH_INPUT, ShFracUShort, SH_POSITION> ShInputPosition1fus;
typedef ShAttrib<1, SH_OUTPUT, ShFracUShort, SH_POSITION> ShOutputPosition1fus;
typedef ShAttrib<1, SH_INOUT, ShFracUShort, SH_POSITION> ShInOutPosition1fus;
typedef ShAttrib<1, SH_TEMP, ShFracUShort, SH_POSITION> ShPosition1fus;
typedef ShAttrib<1, SH_CONST, ShFracUShort, SH_POSITION> ShConstPosition1fus;
typedef ShAttrib<2, SH_INPUT, ShFracUShort, SH_POSITION> ShInputPosition2fus;
typedef ShAttrib<2, SH_OUTPUT, ShFracUShort, SH_POSITION> ShOutputPosition2fus;
typedef ShAttrib<2, SH_INOUT, ShFracUShort, SH_POSITION> ShInOutPosition2fus;
typedef ShAttrib<2, SH_TEMP, ShFracUShort, SH_POSITION> ShPosition2fus;
typedef ShAttrib<2, SH_CONST, ShFracUShort, SH_POSITION> ShConstPosition2fus;
typedef ShAttrib<3, SH_INPUT, ShFracUShort, SH_POSITION> ShInputPosition3fus;
typedef ShAttrib<3, SH_OUTPUT, ShFracUShort, SH_POSITION> ShOutputPosition3fus;
typedef ShAttrib<3, SH_INOUT, ShFracUShort, SH_POSITION> ShInOutPosition3fus;
typedef ShAttrib<3, SH_TEMP, ShFracUShort, SH_POSITION> ShPosition3fus;
typedef ShAttrib<3, SH_CONST, ShFracUShort, SH_POSITION> ShConstPosition3fus;
typedef ShAttrib<4, SH_INPUT, ShFracUShort, SH_POSITION> ShInputPosition4fus;
typedef ShAttrib<4, SH_OUTPUT, ShFracUShort, SH_POSITION> ShOutputPosition4fus;
typedef ShAttrib<4, SH_INOUT, ShFracUShort, SH_POSITION> ShInOutPosition4fus;
typedef ShAttrib<4, SH_TEMP, ShFracUShort, SH_POSITION> ShPosition4fus;
typedef ShAttrib<4, SH_CONST, ShFracUShort, SH_POSITION> ShConstPosition4fus;


typedef ShAttrib<1, SH_INPUT, short, SH_POSITION> ShInputPosition1s;
typedef ShAttrib<1, SH_OUTPUT, short, SH_POSITION> ShOutputPosition1s;
typedef ShAttrib<1, SH_INOUT, short, SH_POSITION> ShInOutPosition1s;
typedef ShAttrib<1, SH_TEMP, short, SH_POSITION> ShPosition1s;
typedef ShAttrib<1, SH_CONST, short, SH_POSITION> ShConstPosition1s;
typedef ShAttrib<2, SH_INPUT, short, SH_POSITION> ShInputPosition2s;
typedef ShAttrib<2, SH_OUTPUT, short, SH_POSITION> ShOutputPosition2s;
typedef ShAttrib<2, SH_INOUT, short, SH_POSITION> ShInOutPosition2s;
typedef ShAttrib<2, SH_TEMP, short, SH_POSITION> ShPosition2s;
typedef ShAttrib<2, SH_CONST, short, SH_POSITION> ShConstPosition2s;
typedef ShAttrib<3, SH_INPUT, short, SH_POSITION> ShInputPosition3s;
typedef ShAttrib<3, SH_OUTPUT, short, SH_POSITION> ShOutputPosition3s;
typedef ShAttrib<3, SH_INOUT, short, SH_POSITION> ShInOutPosition3s;
typedef ShAttrib<3, SH_TEMP, short, SH_POSITION> ShPosition3s;
typedef ShAttrib<3, SH_CONST, short, SH_POSITION> ShConstPosition3s;
typedef ShAttrib<4, SH_INPUT, short, SH_POSITION> ShInputPosition4s;
typedef ShAttrib<4, SH_OUTPUT, short, SH_POSITION> ShOutputPosition4s;
typedef ShAttrib<4, SH_INOUT, short, SH_POSITION> ShInOutPosition4s;
typedef ShAttrib<4, SH_TEMP, short, SH_POSITION> ShPosition4s;
typedef ShAttrib<4, SH_CONST, short, SH_POSITION> ShConstPosition4s;


typedef ShAttrib<1, SH_INPUT, ShFracUInt, SH_POSITION> ShInputPosition1fui;
typedef ShAttrib<1, SH_OUTPUT, ShFracUInt, SH_POSITION> ShOutputPosition1fui;
typedef ShAttrib<1, SH_INOUT, ShFracUInt, SH_POSITION> ShInOutPosition1fui;
typedef ShAttrib<1, SH_TEMP, ShFracUInt, SH_POSITION> ShPosition1fui;
typedef ShAttrib<1, SH_CONST, ShFracUInt, SH_POSITION> ShConstPosition1fui;
typedef ShAttrib<2, SH_INPUT, ShFracUInt, SH_POSITION> ShInputPosition2fui;
typedef ShAttrib<2, SH_OUTPUT, ShFracUInt, SH_POSITION> ShOutputPosition2fui;
typedef ShAttrib<2, SH_INOUT, ShFracUInt, SH_POSITION> ShInOutPosition2fui;
typedef ShAttrib<2, SH_TEMP, ShFracUInt, SH_POSITION> ShPosition2fui;
typedef ShAttrib<2, SH_CONST, ShFracUInt, SH_POSITION> ShConstPosition2fui;
typedef ShAttrib<3, SH_INPUT, ShFracUInt, SH_POSITION> ShInputPosition3fui;
typedef ShAttrib<3, SH_OUTPUT, ShFracUInt, SH_POSITION> ShOutputPosition3fui;
typedef ShAttrib<3, SH_INOUT, ShFracUInt, SH_POSITION> ShInOutPosition3fui;
typedef ShAttrib<3, SH_TEMP, ShFracUInt, SH_POSITION> ShPosition3fui;
typedef ShAttrib<3, SH_CONST, ShFracUInt, SH_POSITION> ShConstPosition3fui;
typedef ShAttrib<4, SH_INPUT, ShFracUInt, SH_POSITION> ShInputPosition4fui;
typedef ShAttrib<4, SH_OUTPUT, ShFracUInt, SH_POSITION> ShOutputPosition4fui;
typedef ShAttrib<4, SH_INOUT, ShFracUInt, SH_POSITION> ShInOutPosition4fui;
typedef ShAttrib<4, SH_TEMP, ShFracUInt, SH_POSITION> ShPosition4fui;
typedef ShAttrib<4, SH_CONST, ShFracUInt, SH_POSITION> ShConstPosition4fui;


typedef ShAttrib<1, SH_INPUT, ShFracByte, SH_POSITION> ShInputPosition1fb;
typedef ShAttrib<1, SH_OUTPUT, ShFracByte, SH_POSITION> ShOutputPosition1fb;
typedef ShAttrib<1, SH_INOUT, ShFracByte, SH_POSITION> ShInOutPosition1fb;
typedef ShAttrib<1, SH_TEMP, ShFracByte, SH_POSITION> ShPosition1fb;
typedef ShAttrib<1, SH_CONST, ShFracByte, SH_POSITION> ShConstPosition1fb;
typedef ShAttrib<2, SH_INPUT, ShFracByte, SH_POSITION> ShInputPosition2fb;
typedef ShAttrib<2, SH_OUTPUT, ShFracByte, SH_POSITION> ShOutputPosition2fb;
typedef ShAttrib<2, SH_INOUT, ShFracByte, SH_POSITION> ShInOutPosition2fb;
typedef ShAttrib<2, SH_TEMP, ShFracByte, SH_POSITION> ShPosition2fb;
typedef ShAttrib<2, SH_CONST, ShFracByte, SH_POSITION> ShConstPosition2fb;
typedef ShAttrib<3, SH_INPUT, ShFracByte, SH_POSITION> ShInputPosition3fb;
typedef ShAttrib<3, SH_OUTPUT, ShFracByte, SH_POSITION> ShOutputPosition3fb;
typedef ShAttrib<3, SH_INOUT, ShFracByte, SH_POSITION> ShInOutPosition3fb;
typedef ShAttrib<3, SH_TEMP, ShFracByte, SH_POSITION> ShPosition3fb;
typedef ShAttrib<3, SH_CONST, ShFracByte, SH_POSITION> ShConstPosition3fb;
typedef ShAttrib<4, SH_INPUT, ShFracByte, SH_POSITION> ShInputPosition4fb;
typedef ShAttrib<4, SH_OUTPUT, ShFracByte, SH_POSITION> ShOutputPosition4fb;
typedef ShAttrib<4, SH_INOUT, ShFracByte, SH_POSITION> ShInOutPosition4fb;
typedef ShAttrib<4, SH_TEMP, ShFracByte, SH_POSITION> ShPosition4fb;
typedef ShAttrib<4, SH_CONST, ShFracByte, SH_POSITION> ShConstPosition4fb;


typedef ShAttrib<1, SH_INPUT, int, SH_POSITION> ShInputPosition1i;
typedef ShAttrib<1, SH_OUTPUT, int, SH_POSITION> ShOutputPosition1i;
typedef ShAttrib<1, SH_INOUT, int, SH_POSITION> ShInOutPosition1i;
typedef ShAttrib<1, SH_TEMP, int, SH_POSITION> ShPosition1i;
typedef ShAttrib<1, SH_CONST, int, SH_POSITION> ShConstPosition1i;
typedef ShAttrib<2, SH_INPUT, int, SH_POSITION> ShInputPosition2i;
typedef ShAttrib<2, SH_OUTPUT, int, SH_POSITION> ShOutputPosition2i;
typedef ShAttrib<2, SH_INOUT, int, SH_POSITION> ShInOutPosition2i;
typedef ShAttrib<2, SH_TEMP, int, SH_POSITION> ShPosition2i;
typedef ShAttrib<2, SH_CONST, int, SH_POSITION> ShConstPosition2i;
typedef ShAttrib<3, SH_INPUT, int, SH_POSITION> ShInputPosition3i;
typedef ShAttrib<3, SH_OUTPUT, int, SH_POSITION> ShOutputPosition3i;
typedef ShAttrib<3, SH_INOUT, int, SH_POSITION> ShInOutPosition3i;
typedef ShAttrib<3, SH_TEMP, int, SH_POSITION> ShPosition3i;
typedef ShAttrib<3, SH_CONST, int, SH_POSITION> ShConstPosition3i;
typedef ShAttrib<4, SH_INPUT, int, SH_POSITION> ShInputPosition4i;
typedef ShAttrib<4, SH_OUTPUT, int, SH_POSITION> ShOutputPosition4i;
typedef ShAttrib<4, SH_INOUT, int, SH_POSITION> ShInOutPosition4i;
typedef ShAttrib<4, SH_TEMP, int, SH_POSITION> ShPosition4i;
typedef ShAttrib<4, SH_CONST, int, SH_POSITION> ShConstPosition4i;


typedef ShAttrib<1, SH_INPUT, double, SH_POSITION> ShInputPosition1d;
typedef ShAttrib<1, SH_OUTPUT, double, SH_POSITION> ShOutputPosition1d;
typedef ShAttrib<1, SH_INOUT, double, SH_POSITION> ShInOutPosition1d;
typedef ShAttrib<1, SH_TEMP, double, SH_POSITION> ShPosition1d;
typedef ShAttrib<1, SH_CONST, double, SH_POSITION> ShConstPosition1d;
typedef ShAttrib<2, SH_INPUT, double, SH_POSITION> ShInputPosition2d;
typedef ShAttrib<2, SH_OUTPUT, double, SH_POSITION> ShOutputPosition2d;
typedef ShAttrib<2, SH_INOUT, double, SH_POSITION> ShInOutPosition2d;
typedef ShAttrib<2, SH_TEMP, double, SH_POSITION> ShPosition2d;
typedef ShAttrib<2, SH_CONST, double, SH_POSITION> ShConstPosition2d;
typedef ShAttrib<3, SH_INPUT, double, SH_POSITION> ShInputPosition3d;
typedef ShAttrib<3, SH_OUTPUT, double, SH_POSITION> ShOutputPosition3d;
typedef ShAttrib<3, SH_INOUT, double, SH_POSITION> ShInOutPosition3d;
typedef ShAttrib<3, SH_TEMP, double, SH_POSITION> ShPosition3d;
typedef ShAttrib<3, SH_CONST, double, SH_POSITION> ShConstPosition3d;
typedef ShAttrib<4, SH_INPUT, double, SH_POSITION> ShInputPosition4d;
typedef ShAttrib<4, SH_OUTPUT, double, SH_POSITION> ShOutputPosition4d;
typedef ShAttrib<4, SH_INOUT, double, SH_POSITION> ShInOutPosition4d;
typedef ShAttrib<4, SH_TEMP, double, SH_POSITION> ShPosition4d;
typedef ShAttrib<4, SH_CONST, double, SH_POSITION> ShConstPosition4d;


typedef ShAttrib<1, SH_INPUT, unsigned char, SH_POSITION> ShInputPosition1ub;
typedef ShAttrib<1, SH_OUTPUT, unsigned char, SH_POSITION> ShOutputPosition1ub;
typedef ShAttrib<1, SH_INOUT, unsigned char, SH_POSITION> ShInOutPosition1ub;
typedef ShAttrib<1, SH_TEMP, unsigned char, SH_POSITION> ShPosition1ub;
typedef ShAttrib<1, SH_CONST, unsigned char, SH_POSITION> ShConstPosition1ub;
typedef ShAttrib<2, SH_INPUT, unsigned char, SH_POSITION> ShInputPosition2ub;
typedef ShAttrib<2, SH_OUTPUT, unsigned char, SH_POSITION> ShOutputPosition2ub;
typedef ShAttrib<2, SH_INOUT, unsigned char, SH_POSITION> ShInOutPosition2ub;
typedef ShAttrib<2, SH_TEMP, unsigned char, SH_POSITION> ShPosition2ub;
typedef ShAttrib<2, SH_CONST, unsigned char, SH_POSITION> ShConstPosition2ub;
typedef ShAttrib<3, SH_INPUT, unsigned char, SH_POSITION> ShInputPosition3ub;
typedef ShAttrib<3, SH_OUTPUT, unsigned char, SH_POSITION> ShOutputPosition3ub;
typedef ShAttrib<3, SH_INOUT, unsigned char, SH_POSITION> ShInOutPosition3ub;
typedef ShAttrib<3, SH_TEMP, unsigned char, SH_POSITION> ShPosition3ub;
typedef ShAttrib<3, SH_CONST, unsigned char, SH_POSITION> ShConstPosition3ub;
typedef ShAttrib<4, SH_INPUT, unsigned char, SH_POSITION> ShInputPosition4ub;
typedef ShAttrib<4, SH_OUTPUT, unsigned char, SH_POSITION> ShOutputPosition4ub;
typedef ShAttrib<4, SH_INOUT, unsigned char, SH_POSITION> ShInOutPosition4ub;
typedef ShAttrib<4, SH_TEMP, unsigned char, SH_POSITION> ShPosition4ub;
typedef ShAttrib<4, SH_CONST, unsigned char, SH_POSITION> ShConstPosition4ub;


typedef ShAttrib<1, SH_INPUT, float, SH_POSITION> ShInputPosition1f;
typedef ShAttrib<1, SH_OUTPUT, float, SH_POSITION> ShOutputPosition1f;
typedef ShAttrib<1, SH_INOUT, float, SH_POSITION> ShInOutPosition1f;
typedef ShAttrib<1, SH_TEMP, float, SH_POSITION> ShPosition1f;
typedef ShAttrib<1, SH_CONST, float, SH_POSITION> ShConstPosition1f;
typedef ShAttrib<2, SH_INPUT, float, SH_POSITION> ShInputPosition2f;
typedef ShAttrib<2, SH_OUTPUT, float, SH_POSITION> ShOutputPosition2f;
typedef ShAttrib<2, SH_INOUT, float, SH_POSITION> ShInOutPosition2f;
typedef ShAttrib<2, SH_TEMP, float, SH_POSITION> ShPosition2f;
typedef ShAttrib<2, SH_CONST, float, SH_POSITION> ShConstPosition2f;
typedef ShAttrib<3, SH_INPUT, float, SH_POSITION> ShInputPosition3f;
typedef ShAttrib<3, SH_OUTPUT, float, SH_POSITION> ShOutputPosition3f;
typedef ShAttrib<3, SH_INOUT, float, SH_POSITION> ShInOutPosition3f;
typedef ShAttrib<3, SH_TEMP, float, SH_POSITION> ShPosition3f;
typedef ShAttrib<3, SH_CONST, float, SH_POSITION> ShConstPosition3f;
typedef ShAttrib<4, SH_INPUT, float, SH_POSITION> ShInputPosition4f;
typedef ShAttrib<4, SH_OUTPUT, float, SH_POSITION> ShOutputPosition4f;
typedef ShAttrib<4, SH_INOUT, float, SH_POSITION> ShInOutPosition4f;
typedef ShAttrib<4, SH_TEMP, float, SH_POSITION> ShPosition4f;
typedef ShAttrib<4, SH_CONST, float, SH_POSITION> ShConstPosition4f;


typedef ShAttrib<1, SH_INPUT, char, SH_POSITION> ShInputPosition1b;
typedef ShAttrib<1, SH_OUTPUT, char, SH_POSITION> ShOutputPosition1b;
typedef ShAttrib<1, SH_INOUT, char, SH_POSITION> ShInOutPosition1b;
typedef ShAttrib<1, SH_TEMP, char, SH_POSITION> ShPosition1b;
typedef ShAttrib<1, SH_CONST, char, SH_POSITION> ShConstPosition1b;
typedef ShAttrib<2, SH_INPUT, char, SH_POSITION> ShInputPosition2b;
typedef ShAttrib<2, SH_OUTPUT, char, SH_POSITION> ShOutputPosition2b;
typedef ShAttrib<2, SH_INOUT, char, SH_POSITION> ShInOutPosition2b;
typedef ShAttrib<2, SH_TEMP, char, SH_POSITION> ShPosition2b;
typedef ShAttrib<2, SH_CONST, char, SH_POSITION> ShConstPosition2b;
typedef ShAttrib<3, SH_INPUT, char, SH_POSITION> ShInputPosition3b;
typedef ShAttrib<3, SH_OUTPUT, char, SH_POSITION> ShOutputPosition3b;
typedef ShAttrib<3, SH_INOUT, char, SH_POSITION> ShInOutPosition3b;
typedef ShAttrib<3, SH_TEMP, char, SH_POSITION> ShPosition3b;
typedef ShAttrib<3, SH_CONST, char, SH_POSITION> ShConstPosition3b;
typedef ShAttrib<4, SH_INPUT, char, SH_POSITION> ShInputPosition4b;
typedef ShAttrib<4, SH_OUTPUT, char, SH_POSITION> ShOutputPosition4b;
typedef ShAttrib<4, SH_INOUT, char, SH_POSITION> ShInOutPosition4b;
typedef ShAttrib<4, SH_TEMP, char, SH_POSITION> ShPosition4b;
typedef ShAttrib<4, SH_CONST, char, SH_POSITION> ShConstPosition4b;


typedef ShAttrib<1, SH_INPUT, unsigned short, SH_POSITION> ShInputPosition1us;
typedef ShAttrib<1, SH_OUTPUT, unsigned short, SH_POSITION> ShOutputPosition1us;
typedef ShAttrib<1, SH_INOUT, unsigned short, SH_POSITION> ShInOutPosition1us;
typedef ShAttrib<1, SH_TEMP, unsigned short, SH_POSITION> ShPosition1us;
typedef ShAttrib<1, SH_CONST, unsigned short, SH_POSITION> ShConstPosition1us;
typedef ShAttrib<2, SH_INPUT, unsigned short, SH_POSITION> ShInputPosition2us;
typedef ShAttrib<2, SH_OUTPUT, unsigned short, SH_POSITION> ShOutputPosition2us;
typedef ShAttrib<2, SH_INOUT, unsigned short, SH_POSITION> ShInOutPosition2us;
typedef ShAttrib<2, SH_TEMP, unsigned short, SH_POSITION> ShPosition2us;
typedef ShAttrib<2, SH_CONST, unsigned short, SH_POSITION> ShConstPosition2us;
typedef ShAttrib<3, SH_INPUT, unsigned short, SH_POSITION> ShInputPosition3us;
typedef ShAttrib<3, SH_OUTPUT, unsigned short, SH_POSITION> ShOutputPosition3us;
typedef ShAttrib<3, SH_INOUT, unsigned short, SH_POSITION> ShInOutPosition3us;
typedef ShAttrib<3, SH_TEMP, unsigned short, SH_POSITION> ShPosition3us;
typedef ShAttrib<3, SH_CONST, unsigned short, SH_POSITION> ShConstPosition3us;
typedef ShAttrib<4, SH_INPUT, unsigned short, SH_POSITION> ShInputPosition4us;
typedef ShAttrib<4, SH_OUTPUT, unsigned short, SH_POSITION> ShOutputPosition4us;
typedef ShAttrib<4, SH_INOUT, unsigned short, SH_POSITION> ShInOutPosition4us;
typedef ShAttrib<4, SH_TEMP, unsigned short, SH_POSITION> ShPosition4us;
typedef ShAttrib<4, SH_CONST, unsigned short, SH_POSITION> ShConstPosition4us;


typedef ShAttrib<1, SH_INPUT, ShFracUByte, SH_POSITION> ShInputPosition1fub;
typedef ShAttrib<1, SH_OUTPUT, ShFracUByte, SH_POSITION> ShOutputPosition1fub;
typedef ShAttrib<1, SH_INOUT, ShFracUByte, SH_POSITION> ShInOutPosition1fub;
typedef ShAttrib<1, SH_TEMP, ShFracUByte, SH_POSITION> ShPosition1fub;
typedef ShAttrib<1, SH_CONST, ShFracUByte, SH_POSITION> ShConstPosition1fub;
typedef ShAttrib<2, SH_INPUT, ShFracUByte, SH_POSITION> ShInputPosition2fub;
typedef ShAttrib<2, SH_OUTPUT, ShFracUByte, SH_POSITION> ShOutputPosition2fub;
typedef ShAttrib<2, SH_INOUT, ShFracUByte, SH_POSITION> ShInOutPosition2fub;
typedef ShAttrib<2, SH_TEMP, ShFracUByte, SH_POSITION> ShPosition2fub;
typedef ShAttrib<2, SH_CONST, ShFracUByte, SH_POSITION> ShConstPosition2fub;
typedef ShAttrib<3, SH_INPUT, ShFracUByte, SH_POSITION> ShInputPosition3fub;
typedef ShAttrib<3, SH_OUTPUT, ShFracUByte, SH_POSITION> ShOutputPosition3fub;
typedef ShAttrib<3, SH_INOUT, ShFracUByte, SH_POSITION> ShInOutPosition3fub;
typedef ShAttrib<3, SH_TEMP, ShFracUByte, SH_POSITION> ShPosition3fub;
typedef ShAttrib<3, SH_CONST, ShFracUByte, SH_POSITION> ShConstPosition3fub;
typedef ShAttrib<4, SH_INPUT, ShFracUByte, SH_POSITION> ShInputPosition4fub;
typedef ShAttrib<4, SH_OUTPUT, ShFracUByte, SH_POSITION> ShOutputPosition4fub;
typedef ShAttrib<4, SH_INOUT, ShFracUByte, SH_POSITION> ShInOutPosition4fub;
typedef ShAttrib<4, SH_TEMP, ShFracUByte, SH_POSITION> ShPosition4fub;
typedef ShAttrib<4, SH_CONST, ShFracUByte, SH_POSITION> ShConstPosition4fub;


typedef ShAttrib<1, SH_INPUT, ShHalf, SH_POSITION> ShInputPosition1h;
typedef ShAttrib<1, SH_OUTPUT, ShHalf, SH_POSITION> ShOutputPosition1h;
typedef ShAttrib<1, SH_INOUT, ShHalf, SH_POSITION> ShInOutPosition1h;
typedef ShAttrib<1, SH_TEMP, ShHalf, SH_POSITION> ShPosition1h;
typedef ShAttrib<1, SH_CONST, ShHalf, SH_POSITION> ShConstPosition1h;
typedef ShAttrib<2, SH_INPUT, ShHalf, SH_POSITION> ShInputPosition2h;
typedef ShAttrib<2, SH_OUTPUT, ShHalf, SH_POSITION> ShOutputPosition2h;
typedef ShAttrib<2, SH_INOUT, ShHalf, SH_POSITION> ShInOutPosition2h;
typedef ShAttrib<2, SH_TEMP, ShHalf, SH_POSITION> ShPosition2h;
typedef ShAttrib<2, SH_CONST, ShHalf, SH_POSITION> ShConstPosition2h;
typedef ShAttrib<3, SH_INPUT, ShHalf, SH_POSITION> ShInputPosition3h;
typedef ShAttrib<3, SH_OUTPUT, ShHalf, SH_POSITION> ShOutputPosition3h;
typedef ShAttrib<3, SH_INOUT, ShHalf, SH_POSITION> ShInOutPosition3h;
typedef ShAttrib<3, SH_TEMP, ShHalf, SH_POSITION> ShPosition3h;
typedef ShAttrib<3, SH_CONST, ShHalf, SH_POSITION> ShConstPosition3h;
typedef ShAttrib<4, SH_INPUT, ShHalf, SH_POSITION> ShInputPosition4h;
typedef ShAttrib<4, SH_OUTPUT, ShHalf, SH_POSITION> ShOutputPosition4h;
typedef ShAttrib<4, SH_INOUT, ShHalf, SH_POSITION> ShInOutPosition4h;
typedef ShAttrib<4, SH_TEMP, ShHalf, SH_POSITION> ShPosition4h;
typedef ShAttrib<4, SH_CONST, ShHalf, SH_POSITION> ShConstPosition4h;


typedef ShAttrib<1, SH_INPUT, ShFracShort, SH_POSITION> ShInputPosition1fs;
typedef ShAttrib<1, SH_OUTPUT, ShFracShort, SH_POSITION> ShOutputPosition1fs;
typedef ShAttrib<1, SH_INOUT, ShFracShort, SH_POSITION> ShInOutPosition1fs;
typedef ShAttrib<1, SH_TEMP, ShFracShort, SH_POSITION> ShPosition1fs;
typedef ShAttrib<1, SH_CONST, ShFracShort, SH_POSITION> ShConstPosition1fs;
typedef ShAttrib<2, SH_INPUT, ShFracShort, SH_POSITION> ShInputPosition2fs;
typedef ShAttrib<2, SH_OUTPUT, ShFracShort, SH_POSITION> ShOutputPosition2fs;
typedef ShAttrib<2, SH_INOUT, ShFracShort, SH_POSITION> ShInOutPosition2fs;
typedef ShAttrib<2, SH_TEMP, ShFracShort, SH_POSITION> ShPosition2fs;
typedef ShAttrib<2, SH_CONST, ShFracShort, SH_POSITION> ShConstPosition2fs;
typedef ShAttrib<3, SH_INPUT, ShFracShort, SH_POSITION> ShInputPosition3fs;
typedef ShAttrib<3, SH_OUTPUT, ShFracShort, SH_POSITION> ShOutputPosition3fs;
typedef ShAttrib<3, SH_INOUT, ShFracShort, SH_POSITION> ShInOutPosition3fs;
typedef ShAttrib<3, SH_TEMP, ShFracShort, SH_POSITION> ShPosition3fs;
typedef ShAttrib<3, SH_CONST, ShFracShort, SH_POSITION> ShConstPosition3fs;
typedef ShAttrib<4, SH_INPUT, ShFracShort, SH_POSITION> ShInputPosition4fs;
typedef ShAttrib<4, SH_OUTPUT, ShFracShort, SH_POSITION> ShOutputPosition4fs;
typedef ShAttrib<4, SH_INOUT, ShFracShort, SH_POSITION> ShInOutPosition4fs;
typedef ShAttrib<4, SH_TEMP, ShFracShort, SH_POSITION> ShPosition4fs;
typedef ShAttrib<4, SH_CONST, ShFracShort, SH_POSITION> ShConstPosition4fs;


typedef ShAttrib<1, SH_INPUT, ShFracInt, SH_POSITION> ShInputPosition1fi;
typedef ShAttrib<1, SH_OUTPUT, ShFracInt, SH_POSITION> ShOutputPosition1fi;
typedef ShAttrib<1, SH_INOUT, ShFracInt, SH_POSITION> ShInOutPosition1fi;
typedef ShAttrib<1, SH_TEMP, ShFracInt, SH_POSITION> ShPosition1fi;
typedef ShAttrib<1, SH_CONST, ShFracInt, SH_POSITION> ShConstPosition1fi;
typedef ShAttrib<2, SH_INPUT, ShFracInt, SH_POSITION> ShInputPosition2fi;
typedef ShAttrib<2, SH_OUTPUT, ShFracInt, SH_POSITION> ShOutputPosition2fi;
typedef ShAttrib<2, SH_INOUT, ShFracInt, SH_POSITION> ShInOutPosition2fi;
typedef ShAttrib<2, SH_TEMP, ShFracInt, SH_POSITION> ShPosition2fi;
typedef ShAttrib<2, SH_CONST, ShFracInt, SH_POSITION> ShConstPosition2fi;
typedef ShAttrib<3, SH_INPUT, ShFracInt, SH_POSITION> ShInputPosition3fi;
typedef ShAttrib<3, SH_OUTPUT, ShFracInt, SH_POSITION> ShOutputPosition3fi;
typedef ShAttrib<3, SH_INOUT, ShFracInt, SH_POSITION> ShInOutPosition3fi;
typedef ShAttrib<3, SH_TEMP, ShFracInt, SH_POSITION> ShPosition3fi;
typedef ShAttrib<3, SH_CONST, ShFracInt, SH_POSITION> ShConstPosition3fi;
typedef ShAttrib<4, SH_INPUT, ShFracInt, SH_POSITION> ShInputPosition4fi;
typedef ShAttrib<4, SH_OUTPUT, ShFracInt, SH_POSITION> ShOutputPosition4fi;
typedef ShAttrib<4, SH_INOUT, ShFracInt, SH_POSITION> ShInOutPosition4fi;
typedef ShAttrib<4, SH_TEMP, ShFracInt, SH_POSITION> ShPosition4fi;
typedef ShAttrib<4, SH_CONST, ShFracInt, SH_POSITION> ShConstPosition4fi;


typedef ShAttrib<1, SH_INPUT, unsigned int, SH_POSITION> ShInputPosition1ui;
typedef ShAttrib<1, SH_OUTPUT, unsigned int, SH_POSITION> ShOutputPosition1ui;
typedef ShAttrib<1, SH_INOUT, unsigned int, SH_POSITION> ShInOutPosition1ui;
typedef ShAttrib<1, SH_TEMP, unsigned int, SH_POSITION> ShPosition1ui;
typedef ShAttrib<1, SH_CONST, unsigned int, SH_POSITION> ShConstPosition1ui;
typedef ShAttrib<2, SH_INPUT, unsigned int, SH_POSITION> ShInputPosition2ui;
typedef ShAttrib<2, SH_OUTPUT, unsigned int, SH_POSITION> ShOutputPosition2ui;
typedef ShAttrib<2, SH_INOUT, unsigned int, SH_POSITION> ShInOutPosition2ui;
typedef ShAttrib<2, SH_TEMP, unsigned int, SH_POSITION> ShPosition2ui;
typedef ShAttrib<2, SH_CONST, unsigned int, SH_POSITION> ShConstPosition2ui;
typedef ShAttrib<3, SH_INPUT, unsigned int, SH_POSITION> ShInputPosition3ui;
typedef ShAttrib<3, SH_OUTPUT, unsigned int, SH_POSITION> ShOutputPosition3ui;
typedef ShAttrib<3, SH_INOUT, unsigned int, SH_POSITION> ShInOutPosition3ui;
typedef ShAttrib<3, SH_TEMP, unsigned int, SH_POSITION> ShPosition3ui;
typedef ShAttrib<3, SH_CONST, unsigned int, SH_POSITION> ShConstPosition3ui;
typedef ShAttrib<4, SH_INPUT, unsigned int, SH_POSITION> ShInputPosition4ui;
typedef ShAttrib<4, SH_OUTPUT, unsigned int, SH_POSITION> ShOutputPosition4ui;
typedef ShAttrib<4, SH_INOUT, unsigned int, SH_POSITION> ShInOutPosition4ui;
typedef ShAttrib<4, SH_TEMP, unsigned int, SH_POSITION> ShPosition4ui;
typedef ShAttrib<4, SH_CONST, unsigned int, SH_POSITION> ShConstPosition4ui;



} // namespace SH

#endif // SH_SHPOSITION_HPP
