// WARNING - DO NOT EDIT THIS FILE:
// This file was automatically generated from scripts/ShVector.hpp.py.
// If you wish to change it, edit that file instead.
//
// ---
//
// Sh: A GPU metaprogramming language.
//
// Copyright 2003-2006 Serious Hack Inc.
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
// MA  02110-1301, USA
//////////////////////////////////////////////////////////////////////////////

#ifndef SH_SHVECTOR_HPP
#define SH_SHVECTOR_HPP

#include "ShAttrib.hpp"
namespace SH {

/** A (geometric) n-vector.
 * 
 * By "vector" we mean a geometric vector, not just a tuple or an
 * array (unlike the unfortunate terminology in the standard
 * library).
 *
 */

typedef ShAttrib<1, SH_INPUT, ShFracUShort, SH_VECTOR> ShInputVector1fus;
typedef ShAttrib<1, SH_OUTPUT, ShFracUShort, SH_VECTOR> ShOutputVector1fus;
typedef ShAttrib<1, SH_INOUT, ShFracUShort, SH_VECTOR> ShInOutVector1fus;
typedef ShAttrib<1, SH_TEMP, ShFracUShort, SH_VECTOR> ShVector1fus;
typedef ShAttrib<1, SH_CONST, ShFracUShort, SH_VECTOR> ShConstVector1fus;
typedef ShAttrib<2, SH_INPUT, ShFracUShort, SH_VECTOR> ShInputVector2fus;
typedef ShAttrib<2, SH_OUTPUT, ShFracUShort, SH_VECTOR> ShOutputVector2fus;
typedef ShAttrib<2, SH_INOUT, ShFracUShort, SH_VECTOR> ShInOutVector2fus;
typedef ShAttrib<2, SH_TEMP, ShFracUShort, SH_VECTOR> ShVector2fus;
typedef ShAttrib<2, SH_CONST, ShFracUShort, SH_VECTOR> ShConstVector2fus;
typedef ShAttrib<3, SH_INPUT, ShFracUShort, SH_VECTOR> ShInputVector3fus;
typedef ShAttrib<3, SH_OUTPUT, ShFracUShort, SH_VECTOR> ShOutputVector3fus;
typedef ShAttrib<3, SH_INOUT, ShFracUShort, SH_VECTOR> ShInOutVector3fus;
typedef ShAttrib<3, SH_TEMP, ShFracUShort, SH_VECTOR> ShVector3fus;
typedef ShAttrib<3, SH_CONST, ShFracUShort, SH_VECTOR> ShConstVector3fus;
typedef ShAttrib<4, SH_INPUT, ShFracUShort, SH_VECTOR> ShInputVector4fus;
typedef ShAttrib<4, SH_OUTPUT, ShFracUShort, SH_VECTOR> ShOutputVector4fus;
typedef ShAttrib<4, SH_INOUT, ShFracUShort, SH_VECTOR> ShInOutVector4fus;
typedef ShAttrib<4, SH_TEMP, ShFracUShort, SH_VECTOR> ShVector4fus;
typedef ShAttrib<4, SH_CONST, ShFracUShort, SH_VECTOR> ShConstVector4fus;


typedef ShAttrib<1, SH_INPUT, short, SH_VECTOR> ShInputVector1s;
typedef ShAttrib<1, SH_OUTPUT, short, SH_VECTOR> ShOutputVector1s;
typedef ShAttrib<1, SH_INOUT, short, SH_VECTOR> ShInOutVector1s;
typedef ShAttrib<1, SH_TEMP, short, SH_VECTOR> ShVector1s;
typedef ShAttrib<1, SH_CONST, short, SH_VECTOR> ShConstVector1s;
typedef ShAttrib<2, SH_INPUT, short, SH_VECTOR> ShInputVector2s;
typedef ShAttrib<2, SH_OUTPUT, short, SH_VECTOR> ShOutputVector2s;
typedef ShAttrib<2, SH_INOUT, short, SH_VECTOR> ShInOutVector2s;
typedef ShAttrib<2, SH_TEMP, short, SH_VECTOR> ShVector2s;
typedef ShAttrib<2, SH_CONST, short, SH_VECTOR> ShConstVector2s;
typedef ShAttrib<3, SH_INPUT, short, SH_VECTOR> ShInputVector3s;
typedef ShAttrib<3, SH_OUTPUT, short, SH_VECTOR> ShOutputVector3s;
typedef ShAttrib<3, SH_INOUT, short, SH_VECTOR> ShInOutVector3s;
typedef ShAttrib<3, SH_TEMP, short, SH_VECTOR> ShVector3s;
typedef ShAttrib<3, SH_CONST, short, SH_VECTOR> ShConstVector3s;
typedef ShAttrib<4, SH_INPUT, short, SH_VECTOR> ShInputVector4s;
typedef ShAttrib<4, SH_OUTPUT, short, SH_VECTOR> ShOutputVector4s;
typedef ShAttrib<4, SH_INOUT, short, SH_VECTOR> ShInOutVector4s;
typedef ShAttrib<4, SH_TEMP, short, SH_VECTOR> ShVector4s;
typedef ShAttrib<4, SH_CONST, short, SH_VECTOR> ShConstVector4s;


typedef ShAttrib<1, SH_INPUT, ShFracUInt, SH_VECTOR> ShInputVector1fui;
typedef ShAttrib<1, SH_OUTPUT, ShFracUInt, SH_VECTOR> ShOutputVector1fui;
typedef ShAttrib<1, SH_INOUT, ShFracUInt, SH_VECTOR> ShInOutVector1fui;
typedef ShAttrib<1, SH_TEMP, ShFracUInt, SH_VECTOR> ShVector1fui;
typedef ShAttrib<1, SH_CONST, ShFracUInt, SH_VECTOR> ShConstVector1fui;
typedef ShAttrib<2, SH_INPUT, ShFracUInt, SH_VECTOR> ShInputVector2fui;
typedef ShAttrib<2, SH_OUTPUT, ShFracUInt, SH_VECTOR> ShOutputVector2fui;
typedef ShAttrib<2, SH_INOUT, ShFracUInt, SH_VECTOR> ShInOutVector2fui;
typedef ShAttrib<2, SH_TEMP, ShFracUInt, SH_VECTOR> ShVector2fui;
typedef ShAttrib<2, SH_CONST, ShFracUInt, SH_VECTOR> ShConstVector2fui;
typedef ShAttrib<3, SH_INPUT, ShFracUInt, SH_VECTOR> ShInputVector3fui;
typedef ShAttrib<3, SH_OUTPUT, ShFracUInt, SH_VECTOR> ShOutputVector3fui;
typedef ShAttrib<3, SH_INOUT, ShFracUInt, SH_VECTOR> ShInOutVector3fui;
typedef ShAttrib<3, SH_TEMP, ShFracUInt, SH_VECTOR> ShVector3fui;
typedef ShAttrib<3, SH_CONST, ShFracUInt, SH_VECTOR> ShConstVector3fui;
typedef ShAttrib<4, SH_INPUT, ShFracUInt, SH_VECTOR> ShInputVector4fui;
typedef ShAttrib<4, SH_OUTPUT, ShFracUInt, SH_VECTOR> ShOutputVector4fui;
typedef ShAttrib<4, SH_INOUT, ShFracUInt, SH_VECTOR> ShInOutVector4fui;
typedef ShAttrib<4, SH_TEMP, ShFracUInt, SH_VECTOR> ShVector4fui;
typedef ShAttrib<4, SH_CONST, ShFracUInt, SH_VECTOR> ShConstVector4fui;


typedef ShAttrib<1, SH_INPUT, ShFracByte, SH_VECTOR> ShInputVector1fb;
typedef ShAttrib<1, SH_OUTPUT, ShFracByte, SH_VECTOR> ShOutputVector1fb;
typedef ShAttrib<1, SH_INOUT, ShFracByte, SH_VECTOR> ShInOutVector1fb;
typedef ShAttrib<1, SH_TEMP, ShFracByte, SH_VECTOR> ShVector1fb;
typedef ShAttrib<1, SH_CONST, ShFracByte, SH_VECTOR> ShConstVector1fb;
typedef ShAttrib<2, SH_INPUT, ShFracByte, SH_VECTOR> ShInputVector2fb;
typedef ShAttrib<2, SH_OUTPUT, ShFracByte, SH_VECTOR> ShOutputVector2fb;
typedef ShAttrib<2, SH_INOUT, ShFracByte, SH_VECTOR> ShInOutVector2fb;
typedef ShAttrib<2, SH_TEMP, ShFracByte, SH_VECTOR> ShVector2fb;
typedef ShAttrib<2, SH_CONST, ShFracByte, SH_VECTOR> ShConstVector2fb;
typedef ShAttrib<3, SH_INPUT, ShFracByte, SH_VECTOR> ShInputVector3fb;
typedef ShAttrib<3, SH_OUTPUT, ShFracByte, SH_VECTOR> ShOutputVector3fb;
typedef ShAttrib<3, SH_INOUT, ShFracByte, SH_VECTOR> ShInOutVector3fb;
typedef ShAttrib<3, SH_TEMP, ShFracByte, SH_VECTOR> ShVector3fb;
typedef ShAttrib<3, SH_CONST, ShFracByte, SH_VECTOR> ShConstVector3fb;
typedef ShAttrib<4, SH_INPUT, ShFracByte, SH_VECTOR> ShInputVector4fb;
typedef ShAttrib<4, SH_OUTPUT, ShFracByte, SH_VECTOR> ShOutputVector4fb;
typedef ShAttrib<4, SH_INOUT, ShFracByte, SH_VECTOR> ShInOutVector4fb;
typedef ShAttrib<4, SH_TEMP, ShFracByte, SH_VECTOR> ShVector4fb;
typedef ShAttrib<4, SH_CONST, ShFracByte, SH_VECTOR> ShConstVector4fb;


typedef ShAttrib<1, SH_INPUT, int, SH_VECTOR> ShInputVector1i;
typedef ShAttrib<1, SH_OUTPUT, int, SH_VECTOR> ShOutputVector1i;
typedef ShAttrib<1, SH_INOUT, int, SH_VECTOR> ShInOutVector1i;
typedef ShAttrib<1, SH_TEMP, int, SH_VECTOR> ShVector1i;
typedef ShAttrib<1, SH_CONST, int, SH_VECTOR> ShConstVector1i;
typedef ShAttrib<2, SH_INPUT, int, SH_VECTOR> ShInputVector2i;
typedef ShAttrib<2, SH_OUTPUT, int, SH_VECTOR> ShOutputVector2i;
typedef ShAttrib<2, SH_INOUT, int, SH_VECTOR> ShInOutVector2i;
typedef ShAttrib<2, SH_TEMP, int, SH_VECTOR> ShVector2i;
typedef ShAttrib<2, SH_CONST, int, SH_VECTOR> ShConstVector2i;
typedef ShAttrib<3, SH_INPUT, int, SH_VECTOR> ShInputVector3i;
typedef ShAttrib<3, SH_OUTPUT, int, SH_VECTOR> ShOutputVector3i;
typedef ShAttrib<3, SH_INOUT, int, SH_VECTOR> ShInOutVector3i;
typedef ShAttrib<3, SH_TEMP, int, SH_VECTOR> ShVector3i;
typedef ShAttrib<3, SH_CONST, int, SH_VECTOR> ShConstVector3i;
typedef ShAttrib<4, SH_INPUT, int, SH_VECTOR> ShInputVector4i;
typedef ShAttrib<4, SH_OUTPUT, int, SH_VECTOR> ShOutputVector4i;
typedef ShAttrib<4, SH_INOUT, int, SH_VECTOR> ShInOutVector4i;
typedef ShAttrib<4, SH_TEMP, int, SH_VECTOR> ShVector4i;
typedef ShAttrib<4, SH_CONST, int, SH_VECTOR> ShConstVector4i;


typedef ShAttrib<1, SH_INPUT, double, SH_VECTOR> ShInputVector1d;
typedef ShAttrib<1, SH_OUTPUT, double, SH_VECTOR> ShOutputVector1d;
typedef ShAttrib<1, SH_INOUT, double, SH_VECTOR> ShInOutVector1d;
typedef ShAttrib<1, SH_TEMP, double, SH_VECTOR> ShVector1d;
typedef ShAttrib<1, SH_CONST, double, SH_VECTOR> ShConstVector1d;
typedef ShAttrib<2, SH_INPUT, double, SH_VECTOR> ShInputVector2d;
typedef ShAttrib<2, SH_OUTPUT, double, SH_VECTOR> ShOutputVector2d;
typedef ShAttrib<2, SH_INOUT, double, SH_VECTOR> ShInOutVector2d;
typedef ShAttrib<2, SH_TEMP, double, SH_VECTOR> ShVector2d;
typedef ShAttrib<2, SH_CONST, double, SH_VECTOR> ShConstVector2d;
typedef ShAttrib<3, SH_INPUT, double, SH_VECTOR> ShInputVector3d;
typedef ShAttrib<3, SH_OUTPUT, double, SH_VECTOR> ShOutputVector3d;
typedef ShAttrib<3, SH_INOUT, double, SH_VECTOR> ShInOutVector3d;
typedef ShAttrib<3, SH_TEMP, double, SH_VECTOR> ShVector3d;
typedef ShAttrib<3, SH_CONST, double, SH_VECTOR> ShConstVector3d;
typedef ShAttrib<4, SH_INPUT, double, SH_VECTOR> ShInputVector4d;
typedef ShAttrib<4, SH_OUTPUT, double, SH_VECTOR> ShOutputVector4d;
typedef ShAttrib<4, SH_INOUT, double, SH_VECTOR> ShInOutVector4d;
typedef ShAttrib<4, SH_TEMP, double, SH_VECTOR> ShVector4d;
typedef ShAttrib<4, SH_CONST, double, SH_VECTOR> ShConstVector4d;


typedef ShAttrib<1, SH_INPUT, unsigned char, SH_VECTOR> ShInputVector1ub;
typedef ShAttrib<1, SH_OUTPUT, unsigned char, SH_VECTOR> ShOutputVector1ub;
typedef ShAttrib<1, SH_INOUT, unsigned char, SH_VECTOR> ShInOutVector1ub;
typedef ShAttrib<1, SH_TEMP, unsigned char, SH_VECTOR> ShVector1ub;
typedef ShAttrib<1, SH_CONST, unsigned char, SH_VECTOR> ShConstVector1ub;
typedef ShAttrib<2, SH_INPUT, unsigned char, SH_VECTOR> ShInputVector2ub;
typedef ShAttrib<2, SH_OUTPUT, unsigned char, SH_VECTOR> ShOutputVector2ub;
typedef ShAttrib<2, SH_INOUT, unsigned char, SH_VECTOR> ShInOutVector2ub;
typedef ShAttrib<2, SH_TEMP, unsigned char, SH_VECTOR> ShVector2ub;
typedef ShAttrib<2, SH_CONST, unsigned char, SH_VECTOR> ShConstVector2ub;
typedef ShAttrib<3, SH_INPUT, unsigned char, SH_VECTOR> ShInputVector3ub;
typedef ShAttrib<3, SH_OUTPUT, unsigned char, SH_VECTOR> ShOutputVector3ub;
typedef ShAttrib<3, SH_INOUT, unsigned char, SH_VECTOR> ShInOutVector3ub;
typedef ShAttrib<3, SH_TEMP, unsigned char, SH_VECTOR> ShVector3ub;
typedef ShAttrib<3, SH_CONST, unsigned char, SH_VECTOR> ShConstVector3ub;
typedef ShAttrib<4, SH_INPUT, unsigned char, SH_VECTOR> ShInputVector4ub;
typedef ShAttrib<4, SH_OUTPUT, unsigned char, SH_VECTOR> ShOutputVector4ub;
typedef ShAttrib<4, SH_INOUT, unsigned char, SH_VECTOR> ShInOutVector4ub;
typedef ShAttrib<4, SH_TEMP, unsigned char, SH_VECTOR> ShVector4ub;
typedef ShAttrib<4, SH_CONST, unsigned char, SH_VECTOR> ShConstVector4ub;


typedef ShAttrib<1, SH_INPUT, float, SH_VECTOR> ShInputVector1f;
typedef ShAttrib<1, SH_OUTPUT, float, SH_VECTOR> ShOutputVector1f;
typedef ShAttrib<1, SH_INOUT, float, SH_VECTOR> ShInOutVector1f;
typedef ShAttrib<1, SH_TEMP, float, SH_VECTOR> ShVector1f;
typedef ShAttrib<1, SH_CONST, float, SH_VECTOR> ShConstVector1f;
typedef ShAttrib<2, SH_INPUT, float, SH_VECTOR> ShInputVector2f;
typedef ShAttrib<2, SH_OUTPUT, float, SH_VECTOR> ShOutputVector2f;
typedef ShAttrib<2, SH_INOUT, float, SH_VECTOR> ShInOutVector2f;
typedef ShAttrib<2, SH_TEMP, float, SH_VECTOR> ShVector2f;
typedef ShAttrib<2, SH_CONST, float, SH_VECTOR> ShConstVector2f;
typedef ShAttrib<3, SH_INPUT, float, SH_VECTOR> ShInputVector3f;
typedef ShAttrib<3, SH_OUTPUT, float, SH_VECTOR> ShOutputVector3f;
typedef ShAttrib<3, SH_INOUT, float, SH_VECTOR> ShInOutVector3f;
typedef ShAttrib<3, SH_TEMP, float, SH_VECTOR> ShVector3f;
typedef ShAttrib<3, SH_CONST, float, SH_VECTOR> ShConstVector3f;
typedef ShAttrib<4, SH_INPUT, float, SH_VECTOR> ShInputVector4f;
typedef ShAttrib<4, SH_OUTPUT, float, SH_VECTOR> ShOutputVector4f;
typedef ShAttrib<4, SH_INOUT, float, SH_VECTOR> ShInOutVector4f;
typedef ShAttrib<4, SH_TEMP, float, SH_VECTOR> ShVector4f;
typedef ShAttrib<4, SH_CONST, float, SH_VECTOR> ShConstVector4f;


typedef ShAttrib<1, SH_INPUT, char, SH_VECTOR> ShInputVector1b;
typedef ShAttrib<1, SH_OUTPUT, char, SH_VECTOR> ShOutputVector1b;
typedef ShAttrib<1, SH_INOUT, char, SH_VECTOR> ShInOutVector1b;
typedef ShAttrib<1, SH_TEMP, char, SH_VECTOR> ShVector1b;
typedef ShAttrib<1, SH_CONST, char, SH_VECTOR> ShConstVector1b;
typedef ShAttrib<2, SH_INPUT, char, SH_VECTOR> ShInputVector2b;
typedef ShAttrib<2, SH_OUTPUT, char, SH_VECTOR> ShOutputVector2b;
typedef ShAttrib<2, SH_INOUT, char, SH_VECTOR> ShInOutVector2b;
typedef ShAttrib<2, SH_TEMP, char, SH_VECTOR> ShVector2b;
typedef ShAttrib<2, SH_CONST, char, SH_VECTOR> ShConstVector2b;
typedef ShAttrib<3, SH_INPUT, char, SH_VECTOR> ShInputVector3b;
typedef ShAttrib<3, SH_OUTPUT, char, SH_VECTOR> ShOutputVector3b;
typedef ShAttrib<3, SH_INOUT, char, SH_VECTOR> ShInOutVector3b;
typedef ShAttrib<3, SH_TEMP, char, SH_VECTOR> ShVector3b;
typedef ShAttrib<3, SH_CONST, char, SH_VECTOR> ShConstVector3b;
typedef ShAttrib<4, SH_INPUT, char, SH_VECTOR> ShInputVector4b;
typedef ShAttrib<4, SH_OUTPUT, char, SH_VECTOR> ShOutputVector4b;
typedef ShAttrib<4, SH_INOUT, char, SH_VECTOR> ShInOutVector4b;
typedef ShAttrib<4, SH_TEMP, char, SH_VECTOR> ShVector4b;
typedef ShAttrib<4, SH_CONST, char, SH_VECTOR> ShConstVector4b;


typedef ShAttrib<1, SH_INPUT, unsigned short, SH_VECTOR> ShInputVector1us;
typedef ShAttrib<1, SH_OUTPUT, unsigned short, SH_VECTOR> ShOutputVector1us;
typedef ShAttrib<1, SH_INOUT, unsigned short, SH_VECTOR> ShInOutVector1us;
typedef ShAttrib<1, SH_TEMP, unsigned short, SH_VECTOR> ShVector1us;
typedef ShAttrib<1, SH_CONST, unsigned short, SH_VECTOR> ShConstVector1us;
typedef ShAttrib<2, SH_INPUT, unsigned short, SH_VECTOR> ShInputVector2us;
typedef ShAttrib<2, SH_OUTPUT, unsigned short, SH_VECTOR> ShOutputVector2us;
typedef ShAttrib<2, SH_INOUT, unsigned short, SH_VECTOR> ShInOutVector2us;
typedef ShAttrib<2, SH_TEMP, unsigned short, SH_VECTOR> ShVector2us;
typedef ShAttrib<2, SH_CONST, unsigned short, SH_VECTOR> ShConstVector2us;
typedef ShAttrib<3, SH_INPUT, unsigned short, SH_VECTOR> ShInputVector3us;
typedef ShAttrib<3, SH_OUTPUT, unsigned short, SH_VECTOR> ShOutputVector3us;
typedef ShAttrib<3, SH_INOUT, unsigned short, SH_VECTOR> ShInOutVector3us;
typedef ShAttrib<3, SH_TEMP, unsigned short, SH_VECTOR> ShVector3us;
typedef ShAttrib<3, SH_CONST, unsigned short, SH_VECTOR> ShConstVector3us;
typedef ShAttrib<4, SH_INPUT, unsigned short, SH_VECTOR> ShInputVector4us;
typedef ShAttrib<4, SH_OUTPUT, unsigned short, SH_VECTOR> ShOutputVector4us;
typedef ShAttrib<4, SH_INOUT, unsigned short, SH_VECTOR> ShInOutVector4us;
typedef ShAttrib<4, SH_TEMP, unsigned short, SH_VECTOR> ShVector4us;
typedef ShAttrib<4, SH_CONST, unsigned short, SH_VECTOR> ShConstVector4us;


typedef ShAttrib<1, SH_INPUT, ShFracUByte, SH_VECTOR> ShInputVector1fub;
typedef ShAttrib<1, SH_OUTPUT, ShFracUByte, SH_VECTOR> ShOutputVector1fub;
typedef ShAttrib<1, SH_INOUT, ShFracUByte, SH_VECTOR> ShInOutVector1fub;
typedef ShAttrib<1, SH_TEMP, ShFracUByte, SH_VECTOR> ShVector1fub;
typedef ShAttrib<1, SH_CONST, ShFracUByte, SH_VECTOR> ShConstVector1fub;
typedef ShAttrib<2, SH_INPUT, ShFracUByte, SH_VECTOR> ShInputVector2fub;
typedef ShAttrib<2, SH_OUTPUT, ShFracUByte, SH_VECTOR> ShOutputVector2fub;
typedef ShAttrib<2, SH_INOUT, ShFracUByte, SH_VECTOR> ShInOutVector2fub;
typedef ShAttrib<2, SH_TEMP, ShFracUByte, SH_VECTOR> ShVector2fub;
typedef ShAttrib<2, SH_CONST, ShFracUByte, SH_VECTOR> ShConstVector2fub;
typedef ShAttrib<3, SH_INPUT, ShFracUByte, SH_VECTOR> ShInputVector3fub;
typedef ShAttrib<3, SH_OUTPUT, ShFracUByte, SH_VECTOR> ShOutputVector3fub;
typedef ShAttrib<3, SH_INOUT, ShFracUByte, SH_VECTOR> ShInOutVector3fub;
typedef ShAttrib<3, SH_TEMP, ShFracUByte, SH_VECTOR> ShVector3fub;
typedef ShAttrib<3, SH_CONST, ShFracUByte, SH_VECTOR> ShConstVector3fub;
typedef ShAttrib<4, SH_INPUT, ShFracUByte, SH_VECTOR> ShInputVector4fub;
typedef ShAttrib<4, SH_OUTPUT, ShFracUByte, SH_VECTOR> ShOutputVector4fub;
typedef ShAttrib<4, SH_INOUT, ShFracUByte, SH_VECTOR> ShInOutVector4fub;
typedef ShAttrib<4, SH_TEMP, ShFracUByte, SH_VECTOR> ShVector4fub;
typedef ShAttrib<4, SH_CONST, ShFracUByte, SH_VECTOR> ShConstVector4fub;


typedef ShAttrib<1, SH_INPUT, ShHalf, SH_VECTOR> ShInputVector1h;
typedef ShAttrib<1, SH_OUTPUT, ShHalf, SH_VECTOR> ShOutputVector1h;
typedef ShAttrib<1, SH_INOUT, ShHalf, SH_VECTOR> ShInOutVector1h;
typedef ShAttrib<1, SH_TEMP, ShHalf, SH_VECTOR> ShVector1h;
typedef ShAttrib<1, SH_CONST, ShHalf, SH_VECTOR> ShConstVector1h;
typedef ShAttrib<2, SH_INPUT, ShHalf, SH_VECTOR> ShInputVector2h;
typedef ShAttrib<2, SH_OUTPUT, ShHalf, SH_VECTOR> ShOutputVector2h;
typedef ShAttrib<2, SH_INOUT, ShHalf, SH_VECTOR> ShInOutVector2h;
typedef ShAttrib<2, SH_TEMP, ShHalf, SH_VECTOR> ShVector2h;
typedef ShAttrib<2, SH_CONST, ShHalf, SH_VECTOR> ShConstVector2h;
typedef ShAttrib<3, SH_INPUT, ShHalf, SH_VECTOR> ShInputVector3h;
typedef ShAttrib<3, SH_OUTPUT, ShHalf, SH_VECTOR> ShOutputVector3h;
typedef ShAttrib<3, SH_INOUT, ShHalf, SH_VECTOR> ShInOutVector3h;
typedef ShAttrib<3, SH_TEMP, ShHalf, SH_VECTOR> ShVector3h;
typedef ShAttrib<3, SH_CONST, ShHalf, SH_VECTOR> ShConstVector3h;
typedef ShAttrib<4, SH_INPUT, ShHalf, SH_VECTOR> ShInputVector4h;
typedef ShAttrib<4, SH_OUTPUT, ShHalf, SH_VECTOR> ShOutputVector4h;
typedef ShAttrib<4, SH_INOUT, ShHalf, SH_VECTOR> ShInOutVector4h;
typedef ShAttrib<4, SH_TEMP, ShHalf, SH_VECTOR> ShVector4h;
typedef ShAttrib<4, SH_CONST, ShHalf, SH_VECTOR> ShConstVector4h;


typedef ShAttrib<1, SH_INPUT, ShFracShort, SH_VECTOR> ShInputVector1fs;
typedef ShAttrib<1, SH_OUTPUT, ShFracShort, SH_VECTOR> ShOutputVector1fs;
typedef ShAttrib<1, SH_INOUT, ShFracShort, SH_VECTOR> ShInOutVector1fs;
typedef ShAttrib<1, SH_TEMP, ShFracShort, SH_VECTOR> ShVector1fs;
typedef ShAttrib<1, SH_CONST, ShFracShort, SH_VECTOR> ShConstVector1fs;
typedef ShAttrib<2, SH_INPUT, ShFracShort, SH_VECTOR> ShInputVector2fs;
typedef ShAttrib<2, SH_OUTPUT, ShFracShort, SH_VECTOR> ShOutputVector2fs;
typedef ShAttrib<2, SH_INOUT, ShFracShort, SH_VECTOR> ShInOutVector2fs;
typedef ShAttrib<2, SH_TEMP, ShFracShort, SH_VECTOR> ShVector2fs;
typedef ShAttrib<2, SH_CONST, ShFracShort, SH_VECTOR> ShConstVector2fs;
typedef ShAttrib<3, SH_INPUT, ShFracShort, SH_VECTOR> ShInputVector3fs;
typedef ShAttrib<3, SH_OUTPUT, ShFracShort, SH_VECTOR> ShOutputVector3fs;
typedef ShAttrib<3, SH_INOUT, ShFracShort, SH_VECTOR> ShInOutVector3fs;
typedef ShAttrib<3, SH_TEMP, ShFracShort, SH_VECTOR> ShVector3fs;
typedef ShAttrib<3, SH_CONST, ShFracShort, SH_VECTOR> ShConstVector3fs;
typedef ShAttrib<4, SH_INPUT, ShFracShort, SH_VECTOR> ShInputVector4fs;
typedef ShAttrib<4, SH_OUTPUT, ShFracShort, SH_VECTOR> ShOutputVector4fs;
typedef ShAttrib<4, SH_INOUT, ShFracShort, SH_VECTOR> ShInOutVector4fs;
typedef ShAttrib<4, SH_TEMP, ShFracShort, SH_VECTOR> ShVector4fs;
typedef ShAttrib<4, SH_CONST, ShFracShort, SH_VECTOR> ShConstVector4fs;


typedef ShAttrib<1, SH_INPUT, ShFracInt, SH_VECTOR> ShInputVector1fi;
typedef ShAttrib<1, SH_OUTPUT, ShFracInt, SH_VECTOR> ShOutputVector1fi;
typedef ShAttrib<1, SH_INOUT, ShFracInt, SH_VECTOR> ShInOutVector1fi;
typedef ShAttrib<1, SH_TEMP, ShFracInt, SH_VECTOR> ShVector1fi;
typedef ShAttrib<1, SH_CONST, ShFracInt, SH_VECTOR> ShConstVector1fi;
typedef ShAttrib<2, SH_INPUT, ShFracInt, SH_VECTOR> ShInputVector2fi;
typedef ShAttrib<2, SH_OUTPUT, ShFracInt, SH_VECTOR> ShOutputVector2fi;
typedef ShAttrib<2, SH_INOUT, ShFracInt, SH_VECTOR> ShInOutVector2fi;
typedef ShAttrib<2, SH_TEMP, ShFracInt, SH_VECTOR> ShVector2fi;
typedef ShAttrib<2, SH_CONST, ShFracInt, SH_VECTOR> ShConstVector2fi;
typedef ShAttrib<3, SH_INPUT, ShFracInt, SH_VECTOR> ShInputVector3fi;
typedef ShAttrib<3, SH_OUTPUT, ShFracInt, SH_VECTOR> ShOutputVector3fi;
typedef ShAttrib<3, SH_INOUT, ShFracInt, SH_VECTOR> ShInOutVector3fi;
typedef ShAttrib<3, SH_TEMP, ShFracInt, SH_VECTOR> ShVector3fi;
typedef ShAttrib<3, SH_CONST, ShFracInt, SH_VECTOR> ShConstVector3fi;
typedef ShAttrib<4, SH_INPUT, ShFracInt, SH_VECTOR> ShInputVector4fi;
typedef ShAttrib<4, SH_OUTPUT, ShFracInt, SH_VECTOR> ShOutputVector4fi;
typedef ShAttrib<4, SH_INOUT, ShFracInt, SH_VECTOR> ShInOutVector4fi;
typedef ShAttrib<4, SH_TEMP, ShFracInt, SH_VECTOR> ShVector4fi;
typedef ShAttrib<4, SH_CONST, ShFracInt, SH_VECTOR> ShConstVector4fi;


typedef ShAttrib<1, SH_INPUT, unsigned int, SH_VECTOR> ShInputVector1ui;
typedef ShAttrib<1, SH_OUTPUT, unsigned int, SH_VECTOR> ShOutputVector1ui;
typedef ShAttrib<1, SH_INOUT, unsigned int, SH_VECTOR> ShInOutVector1ui;
typedef ShAttrib<1, SH_TEMP, unsigned int, SH_VECTOR> ShVector1ui;
typedef ShAttrib<1, SH_CONST, unsigned int, SH_VECTOR> ShConstVector1ui;
typedef ShAttrib<2, SH_INPUT, unsigned int, SH_VECTOR> ShInputVector2ui;
typedef ShAttrib<2, SH_OUTPUT, unsigned int, SH_VECTOR> ShOutputVector2ui;
typedef ShAttrib<2, SH_INOUT, unsigned int, SH_VECTOR> ShInOutVector2ui;
typedef ShAttrib<2, SH_TEMP, unsigned int, SH_VECTOR> ShVector2ui;
typedef ShAttrib<2, SH_CONST, unsigned int, SH_VECTOR> ShConstVector2ui;
typedef ShAttrib<3, SH_INPUT, unsigned int, SH_VECTOR> ShInputVector3ui;
typedef ShAttrib<3, SH_OUTPUT, unsigned int, SH_VECTOR> ShOutputVector3ui;
typedef ShAttrib<3, SH_INOUT, unsigned int, SH_VECTOR> ShInOutVector3ui;
typedef ShAttrib<3, SH_TEMP, unsigned int, SH_VECTOR> ShVector3ui;
typedef ShAttrib<3, SH_CONST, unsigned int, SH_VECTOR> ShConstVector3ui;
typedef ShAttrib<4, SH_INPUT, unsigned int, SH_VECTOR> ShInputVector4ui;
typedef ShAttrib<4, SH_OUTPUT, unsigned int, SH_VECTOR> ShOutputVector4ui;
typedef ShAttrib<4, SH_INOUT, unsigned int, SH_VECTOR> ShInOutVector4ui;
typedef ShAttrib<4, SH_TEMP, unsigned int, SH_VECTOR> ShVector4ui;
typedef ShAttrib<4, SH_CONST, unsigned int, SH_VECTOR> ShConstVector4ui;



} // namespace SH

#endif // SH_SHVECTOR_HPP
