#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram cross_a_f_3f_3f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a ^ b;
  } SH_END;

  cross_a_f_3f_3f_infix_test0.name("cross_a_f_3f_3f_infix_test0");
  last_test = "cross_a_f_3f_3f_infix_test0";
  {  // f_3f_3f_infix_test0
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    try {
      if (test.run(cross_a_f_3f_3f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cross_a_f_3f_3f_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a ^ b;
  } SH_END;

  cross_a_f_3f_3f_infix_test1.name("cross_a_f_3f_3f_infix_test1");
  last_test = "cross_a_f_3f_3f_infix_test1";
  {  // f_3f_3f_infix_test1
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    try {
      if (test.run(cross_a_f_3f_3f_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cross_a_f_3f_3f_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a ^ b;
  } SH_END;

  cross_a_f_3f_3f_infix_test2.name("cross_a_f_3f_3f_infix_test2");
  last_test = "cross_a_f_3f_3f_infix_test2";
  {  // f_3f_3f_infix_test2
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    try {
      if (test.run(cross_a_f_3f_3f_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cross_a_f_3f_3f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a ^ b;
  } SH_END;

  cross_a_f_3f_3f_infix_test3.name("cross_a_f_3f_3f_infix_test3");
  last_test = "cross_a_f_3f_3f_infix_test3";
  {  // f_3f_3f_infix_test3
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    try {
      if (test.run(cross_a_f_3f_3f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cross_a_f_3f_3f_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a ^ b;
  } SH_END;

  cross_a_f_3f_3f_infix_test4.name("cross_a_f_3f_3f_infix_test4");
  last_test = "cross_a_f_3f_3f_infix_test4";
  {  // f_3f_3f_infix_test4
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(1.5), float(0.5), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.5), float(-0.5), float(-1.0));

    try {
      if (test.run(cross_a_f_3f_3f_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cross_a_f_3f_3f_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a ^ b;
  } SH_END;

  cross_a_f_3f_3f_infix_test5.name("cross_a_f_3f_3f_infix_test5");
  last_test = "cross_a_f_3f_3f_infix_test5";
  {  // f_3f_3f_infix_test5
    ShAttrib<3, SH_CONST, float> a(float(10.2), float(1.4), float(3.2));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.8), float(-7.0), float(8.8));

    try {
      if (test.run(cross_a_f_3f_3f_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cross_a_f_3f_3f_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a ^ b;
  } SH_END;

  cross_a_f_3f_3f_infix_test6.name("cross_a_f_3f_3f_infix_test6");
  last_test = "cross_a_f_3f_3f_infix_test6";
  {  // f_3f_3f_infix_test6
    ShAttrib<3, SH_CONST, float> a(float(50.0), float(100.0), float(0.001));
    ShAttrib<3, SH_CONST, float> b(float(0.3), float(1.1), float(0.95));
    ShAttrib<3, SH_CONST, float> expected(float(94.9989), float(-47.4997), float(25.0));

    try {
      if (test.run(cross_a_f_3f_3f_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cross_a_f_3f_3f_infix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a ^ b;
  } SH_END;

  cross_a_f_3f_3f_infix_test7.name("cross_a_f_3f_3f_infix_test7");
  last_test = "cross_a_f_3f_3f_infix_test7";
  {  // f_3f_3f_infix_test7
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-1.0), float(-1.0));
    ShAttrib<3, SH_CONST, float> b(float(1.5), float(0.5), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.5), float(0.5), float(1.0));

    try {
      if (test.run(cross_a_f_3f_3f_infix_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cross_a_f_3f_3f_infix_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a ^ b;
  } SH_END;

  cross_a_f_3f_3f_infix_test8.name("cross_a_f_3f_3f_infix_test8");
  last_test = "cross_a_f_3f_3f_infix_test8";
  {  // f_3f_3f_infix_test8
    ShAttrib<3, SH_CONST, float> a(float(-10.2), float(-1.4), float(-3.2));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.8), float(7.0), float(-8.8));

    try {
      if (test.run(cross_a_f_3f_3f_infix_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cross_a_f_3f_3f_infix_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a ^ b;
  } SH_END;

  cross_a_f_3f_3f_infix_test9.name("cross_a_f_3f_3f_infix_test9");
  last_test = "cross_a_f_3f_3f_infix_test9";
  {  // f_3f_3f_infix_test9
    ShAttrib<3, SH_CONST, float> a(float(-50.0), float(-100.0), float(-0.001));
    ShAttrib<3, SH_CONST, float> b(float(0.3), float(1.1), float(0.95));
    ShAttrib<3, SH_CONST, float> expected(float(-94.9989), float(47.4997), float(-25.0));

    try {
      if (test.run(cross_a_f_3f_3f_infix_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cross_a_f_3f_3f_infix_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a ^ b;
  } SH_END;

  cross_a_f_3f_3f_infix_test10.name("cross_a_f_3f_3f_infix_test10");
  last_test = "cross_a_f_3f_3f_infix_test10";
  {  // f_3f_3f_infix_test10
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.5), float(-0.5), float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.5), float(0.5), float(1.0));

    try {
      if (test.run(cross_a_f_3f_3f_infix_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cross_a_f_3f_3f_infix_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a ^ b;
  } SH_END;

  cross_a_f_3f_3f_infix_test11.name("cross_a_f_3f_3f_infix_test11");
  last_test = "cross_a_f_3f_3f_infix_test11";
  {  // f_3f_3f_infix_test11
    ShAttrib<3, SH_CONST, float> a(float(10.2), float(1.4), float(3.2));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(-1.0), float(-1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.8), float(7.0), float(-8.8));

    try {
      if (test.run(cross_a_f_3f_3f_infix_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cross_a_f_3f_3f_infix_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a ^ b;
  } SH_END;

  cross_a_f_3f_3f_infix_test12.name("cross_a_f_3f_3f_infix_test12");
  last_test = "cross_a_f_3f_3f_infix_test12";
  {  // f_3f_3f_infix_test12
    ShAttrib<3, SH_CONST, float> a(float(50.0), float(100.0), float(0.001));
    ShAttrib<3, SH_CONST, float> b(float(-0.3), float(-1.1), float(-0.95));
    ShAttrib<3, SH_CONST, float> expected(float(-94.9989), float(47.4997), float(-25.0));

    try {
      if (test.run(cross_a_f_3f_3f_infix_test12, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cross_a_f_3f_3f_infix_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a ^ b;
  } SH_END;

  cross_a_f_3f_3f_infix_test13.name("cross_a_f_3f_3f_infix_test13");
  last_test = "cross_a_f_3f_3f_infix_test13";
  {  // f_3f_3f_infix_test13
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.5), float(0.5), float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-2.5), float(-3.5), float(1.0));

    try {
      if (test.run(cross_a_f_3f_3f_infix_test13, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cross_a_f_3f_3f_infix_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a ^ b;
  } SH_END;

  cross_a_f_3f_3f_infix_test14.name("cross_a_f_3f_3f_infix_test14");
  last_test = "cross_a_f_3f_3f_infix_test14";
  {  // f_3f_3f_infix_test14
    ShAttrib<3, SH_CONST, float> a(float(10.2), float(-1.4), float(3.2));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(-1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.8), float(-7.0), float(-8.8));

    try {
      if (test.run(cross_a_f_3f_3f_infix_test14, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cross_a_f_3f_3f_infix_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a ^ b;
  } SH_END;

  cross_a_f_3f_3f_infix_test15.name("cross_a_f_3f_3f_infix_test15");
  last_test = "cross_a_f_3f_3f_infix_test15";
  {  // f_3f_3f_infix_test15
    ShAttrib<3, SH_CONST, float> a(float(-50.0), float(100.0), float(-0.001));
    ShAttrib<3, SH_CONST, float> b(float(0.3), float(1.1), float(-0.95));
    ShAttrib<3, SH_CONST, float> expected(float(-94.9989), float(-47.5003), float(-85.0));

    try {
      if (test.run(cross_a_f_3f_3f_infix_test15, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_3f_3f_infix_test0
    last_test = "f_3f_3f_infix_test0";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a ^ b;

    try {
      if (test.check("f_3f_3f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test1
    last_test = "f_3f_3f_infix_test1";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a ^ b;

    try {
      if (test.check("f_3f_3f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test2
    last_test = "f_3f_3f_infix_test2";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a ^ b;

    try {
      if (test.check("f_3f_3f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a ^ b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test4
    last_test = "f_3f_3f_infix_test4";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(1.5), float(0.5), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.5), float(-0.5), float(-1.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a ^ b;

    try {
      if (test.check("f_3f_3f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test5
    last_test = "f_3f_3f_infix_test5";
    ShAttrib<3, SH_CONST, float> a(float(10.2), float(1.4), float(3.2));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.8), float(-7.0), float(8.8));

    ShAttrib<3, SH_TEMP, float> out;
    out = a ^ b;

    try {
      if (test.check("f_3f_3f_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test6
    last_test = "f_3f_3f_infix_test6";
    ShAttrib<3, SH_CONST, float> a(float(50.0), float(100.0), float(0.001));
    ShAttrib<3, SH_CONST, float> b(float(0.3), float(1.1), float(0.95));
    ShAttrib<3, SH_CONST, float> expected(float(94.9989), float(-47.4997), float(25.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a ^ b;

    try {
      if (test.check("f_3f_3f_infix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test7
    last_test = "f_3f_3f_infix_test7";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-1.0), float(-1.0));
    ShAttrib<3, SH_CONST, float> b(float(1.5), float(0.5), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.5), float(0.5), float(1.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a ^ b;

    try {
      if (test.check("f_3f_3f_infix_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test8
    last_test = "f_3f_3f_infix_test8";
    ShAttrib<3, SH_CONST, float> a(float(-10.2), float(-1.4), float(-3.2));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.8), float(7.0), float(-8.8));

    ShAttrib<3, SH_TEMP, float> out;
    out = a ^ b;

    try {
      if (test.check("f_3f_3f_infix_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test9
    last_test = "f_3f_3f_infix_test9";
    ShAttrib<3, SH_CONST, float> a(float(-50.0), float(-100.0), float(-0.001));
    ShAttrib<3, SH_CONST, float> b(float(0.3), float(1.1), float(0.95));
    ShAttrib<3, SH_CONST, float> expected(float(-94.9989), float(47.4997), float(-25.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a ^ b;

    try {
      if (test.check("f_3f_3f_infix_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test10
    last_test = "f_3f_3f_infix_test10";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.5), float(-0.5), float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.5), float(0.5), float(1.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a ^ b;

    try {
      if (test.check("f_3f_3f_infix_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test11
    last_test = "f_3f_3f_infix_test11";
    ShAttrib<3, SH_CONST, float> a(float(10.2), float(1.4), float(3.2));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(-1.0), float(-1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.8), float(7.0), float(-8.8));

    ShAttrib<3, SH_TEMP, float> out;
    out = a ^ b;

    try {
      if (test.check("f_3f_3f_infix_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test12
    last_test = "f_3f_3f_infix_test12";
    ShAttrib<3, SH_CONST, float> a(float(50.0), float(100.0), float(0.001));
    ShAttrib<3, SH_CONST, float> b(float(-0.3), float(-1.1), float(-0.95));
    ShAttrib<3, SH_CONST, float> expected(float(-94.9989), float(47.4997), float(-25.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a ^ b;

    try {
      if (test.check("f_3f_3f_infix_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test13
    last_test = "f_3f_3f_infix_test13";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.5), float(0.5), float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-2.5), float(-3.5), float(1.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a ^ b;

    try {
      if (test.check("f_3f_3f_infix_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test14
    last_test = "f_3f_3f_infix_test14";
    ShAttrib<3, SH_CONST, float> a(float(10.2), float(-1.4), float(3.2));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(-1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.8), float(-7.0), float(-8.8));

    ShAttrib<3, SH_TEMP, float> out;
    out = a ^ b;

    try {
      if (test.check("f_3f_3f_infix_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test15
    last_test = "f_3f_3f_infix_test15";
    ShAttrib<3, SH_CONST, float> a(float(-50.0), float(100.0), float(-0.001));
    ShAttrib<3, SH_CONST, float> b(float(0.3), float(1.1), float(-0.95));
    ShAttrib<3, SH_CONST, float> expected(float(-94.9989), float(-47.5003), float(-85.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a ^ b;

    try {
      if (test.check("f_3f_3f_infix_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

