#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram inc_a_f_4f_prefix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = ++ a;
  } SH_END;

  inc_a_f_4f_prefix_test0.name("inc_a_f_4f_prefix_test0");
  last_test = "inc_a_f_4f_prefix_test0";
  {  // f_4f_prefix_test0
    ShAttrib<4, SH_CONST, float> a(float(-1.5), float(0.0), float(0.5), float(3.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.5), float(1.0), float(1.5), float(4.0));

    try {
      if (test.run(inc_a_f_4f_prefix_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram dec_a_f_4f_prefix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = -- a;
  } SH_END;

  dec_a_f_4f_prefix_test0.name("dec_a_f_4f_prefix_test0");
  last_test = "dec_a_f_4f_prefix_test0";
  {  // f_4f_prefix_test0
    ShAttrib<4, SH_CONST, float> a(float(-1.5), float(0.0), float(0.5), float(3.0));
    ShAttrib<4, SH_CONST, float> expected(float(-2.5), float(-1.0), float(-0.5), float(2.0));

    try {
      if (test.run(dec_a_f_4f_prefix_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_4f_prefix_test0
    last_test = "f_4f_prefix_test0";
    ShAttrib<4, SH_CONST, float> a(float(-1.5), float(0.0), float(0.5), float(3.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.5), float(1.0), float(1.5), float(4.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = ++ a;

    try {
      if (test.check("f_4f_prefix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_prefix_test0
    last_test = "f_4f_prefix_test0";
    ShAttrib<4, SH_CONST, float> a(float(-1.5), float(0.0), float(0.5), float(3.0));
    ShAttrib<4, SH_CONST, float> expected(float(-2.5), float(-1.0), float(-0.5), float(2.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = -- a;

    try {
      if (test.check("f_4f_prefix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

