#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram lerp_a_f_3f_3f_3f_calllerp_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_INPUT, float> c;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = lerp(a, b, c);
  } SH_END;

  lerp_a_f_3f_3f_3f_calllerp_test0.name("lerp_a_f_3f_3f_3f_calllerp_test0");
  last_test = "lerp_a_f_3f_3f_3f_calllerp_test0";
  {  // f_3f_3f_3f_calllerp_test0
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(0.4), float(0.8));
    ShAttrib<3, SH_CONST, float> c(float(1.0), float(-10.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(-10.0), float(5.0));

    try {
      if (test.run(lerp_a_f_3f_3f_3f_calllerp_test0, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lerp_a_f_3f_3f_3f_calllerp_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_INPUT, float> c;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = lerp(a, b, c);
  } SH_END;

  lerp_a_f_3f_3f_3f_calllerp_test1.name("lerp_a_f_3f_3f_3f_calllerp_test1");
  last_test = "lerp_a_f_3f_3f_3f_calllerp_test1";
  {  // f_3f_3f_3f_calllerp_test1
    ShAttrib<3, SH_CONST, float> a(float(0.5), float(0.5), float(0.5));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(0.4), float(0.8));
    ShAttrib<3, SH_CONST, float> c(float(1.0), float(-10.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.55), float(-4.8), float(2.9));

    try {
      if (test.run(lerp_a_f_3f_3f_3f_calllerp_test1, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lerp_a_f_3f_3f_3f_calllerp_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_INPUT, float> c;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = lerp(a, b, c);
  } SH_END;

  lerp_a_f_3f_3f_3f_calllerp_test2.name("lerp_a_f_3f_3f_3f_calllerp_test2");
  last_test = "lerp_a_f_3f_3f_3f_calllerp_test2";
  {  // f_3f_3f_3f_calllerp_test2
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(0.4), float(0.8));
    ShAttrib<3, SH_CONST, float> c(float(1.0), float(-10.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.1), float(0.4), float(0.8));

    try {
      if (test.run(lerp_a_f_3f_3f_3f_calllerp_test2, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lerp_a_f_3f_3f_3f_calllerp_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_INPUT, float> c;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = lerp(a, b, c);
  } SH_END;

  lerp_a_f_3f_3f_3f_calllerp_test3.name("lerp_a_f_3f_3f_3f_calllerp_test3");
  last_test = "lerp_a_f_3f_3f_3f_calllerp_test3";
  {  // f_3f_3f_3f_calllerp_test3
    ShAttrib<3, SH_CONST, float> a(float(0.1), float(0.3), float(0.9));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(-2.0), float(10.0));
    ShAttrib<3, SH_CONST, float> c(float(10.0), float(0.5), float(5.23));
    ShAttrib<3, SH_CONST, float> expected(float(9.4), float(-0.25), float(9.523));

    try {
      if (test.run(lerp_a_f_3f_3f_3f_calllerp_test3, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lerp_a_f_3f_3f_3f_calllerp_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_INPUT, float> c;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = lerp(a, b, c);
  } SH_END;

  lerp_a_f_3f_3f_3f_calllerp_test4.name("lerp_a_f_3f_3f_3f_calllerp_test4");
  last_test = "lerp_a_f_3f_3f_3f_calllerp_test4";
  {  // f_3f_3f_3f_calllerp_test4
    ShAttrib<3, SH_CONST, float> a(float(0.1), float(0.3), float(0.9));
    ShAttrib<3, SH_CONST, float> b(float(40.0), float(-20.0), float(100.0));
    ShAttrib<3, SH_CONST, float> c(float(10.0), float(0.5), float(5.23));
    ShAttrib<3, SH_CONST, float> expected(float(13.0), float(-5.65), float(90.523));

    try {
      if (test.run(lerp_a_f_3f_3f_3f_calllerp_test4, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lerp_a_f_3f_3f_3f_calllerp_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_INPUT, float> c;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = lerp(a, b, c);
  } SH_END;

  lerp_a_f_3f_3f_3f_calllerp_test5.name("lerp_a_f_3f_3f_3f_calllerp_test5");
  last_test = "lerp_a_f_3f_3f_3f_calllerp_test5";
  {  // f_3f_3f_3f_calllerp_test5
    ShAttrib<3, SH_CONST, float> a(float(0.1), float(0.3), float(0.9));
    ShAttrib<3, SH_CONST, float> b(float(400.0), float(-200.0), float(1000.0));
    ShAttrib<3, SH_CONST, float> c(float(10.0), float(0.5), float(5.23));
    ShAttrib<3, SH_CONST, float> expected(float(49.0), float(-59.65), float(900.523));

    try {
      if (test.run(lerp_a_f_3f_3f_3f_calllerp_test5, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lerp_a_f_f_f_f_calllerp_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = lerp(a, b, c);
  } SH_END;

  lerp_a_f_f_f_f_calllerp_test6.name("lerp_a_f_f_f_f_calllerp_test6");
  last_test = "lerp_a_f_f_f_f_calllerp_test6";
  {  // f_f_f_f_calllerp_test6
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(-3.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(-1.0));

    try {
      if (test.run(lerp_a_f_f_f_f_calllerp_test6, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lerp_a_f_1f_1f_1f_calllerp_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = lerp(a, b, c);
  } SH_END;

  lerp_a_f_1f_1f_1f_calllerp_test7.name("lerp_a_f_1f_1f_1f_calllerp_test7");
  last_test = "lerp_a_f_1f_1f_1f_calllerp_test7";
  {  // f_1f_1f_1f_calllerp_test7
    ShAttrib<1, SH_CONST, float> a(float(0.1));
    ShAttrib<1, SH_CONST, float> b(float(40.0));
    ShAttrib<1, SH_CONST, float> c(float(10.0));
    ShAttrib<1, SH_CONST, float> expected(float(13.0));

    try {
      if (test.run(lerp_a_f_1f_1f_1f_calllerp_test7, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lerp_a_f_4f_4f_4f_calllerp_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lerp(a, b, c);
  } SH_END;

  lerp_a_f_4f_4f_4f_calllerp_test8.name("lerp_a_f_4f_4f_4f_calllerp_test8");
  last_test = "lerp_a_f_4f_4f_4f_calllerp_test8";
  {  // f_4f_4f_4f_calllerp_test8
    ShAttrib<4, SH_CONST, float> a(float(0.5), float(0.85), float(0.1), float(1.0));
    ShAttrib<4, SH_CONST, float> b(float(5.0), float(1.0), float(0.4), float(30.0));
    ShAttrib<4, SH_CONST, float> c(float(6.2), float(2.0), float(600.0), float(12.3333));
    ShAttrib<4, SH_CONST, float> expected(float(5.6), float(1.15), float(540.04), float(30.0));

    try {
      if (test.run(lerp_a_f_4f_4f_4f_calllerp_test8, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lerp_a_f_f_4f_4f_calllerp_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lerp(a, b, c);
  } SH_END;

  lerp_a_f_f_4f_4f_calllerp_test9.name("lerp_a_f_f_4f_4f_calllerp_test9");
  last_test = "lerp_a_f_f_4f_4f_calllerp_test9";
  {  // f_f_4f_4f_calllerp_test9
    ShAttrib<1, SH_CONST, float> a(float(0.1));
    ShAttrib<4, SH_CONST, float> b(float(4300.2), float(-0.2), float(1000), float(0.4));
    ShAttrib<4, SH_CONST, float> c(float(10.0), float(12.0), float(1.0), float(0.0));
    ShAttrib<4, SH_CONST, float> expected(float(439.02), float(10.78), float(100.9), float(0.04));

    try {
      if (test.run(lerp_a_f_f_4f_4f_calllerp_test9, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lerp_a_f_f_3f_3f_calllerp_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_INPUT, float> c;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = lerp(a, b, c);
  } SH_END;

  lerp_a_f_f_3f_3f_calllerp_test10.name("lerp_a_f_f_3f_3f_calllerp_test10");
  last_test = "lerp_a_f_f_3f_3f_calllerp_test10";
  {  // f_f_3f_3f_calllerp_test10
    ShAttrib<1, SH_CONST, float> a(float(10.0));
    ShAttrib<3, SH_CONST, float> b(float(40.0), float(-2.0), float(0.0));
    ShAttrib<3, SH_CONST, float> c(float(10.0), float(12.0), float(-5.2));
    ShAttrib<3, SH_CONST, float> expected(float(310.0), float(-128.0), float(46.8));

    try {
      if (test.run(lerp_a_f_f_3f_3f_calllerp_test10, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_3f_3f_3f_calllerp_test0
    last_test = "f_3f_3f_3f_calllerp_test0";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(0.4), float(0.8));
    ShAttrib<3, SH_CONST, float> c(float(1.0), float(-10.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(-10.0), float(5.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = lerp(a, b, c);

    try {
      if (test.check("f_3f_3f_3f_calllerp_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_3f_calllerp_test1
    last_test = "f_3f_3f_3f_calllerp_test1";
    ShAttrib<3, SH_CONST, float> a(float(0.5), float(0.5), float(0.5));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(0.4), float(0.8));
    ShAttrib<3, SH_CONST, float> c(float(1.0), float(-10.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.55), float(-4.8), float(2.9));

    ShAttrib<3, SH_TEMP, float> out;
    out = lerp(a, b, c);

    try {
      if (test.check("f_3f_3f_3f_calllerp_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_3f_calllerp_test2
    last_test = "f_3f_3f_3f_calllerp_test2";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(0.4), float(0.8));
    ShAttrib<3, SH_CONST, float> c(float(1.0), float(-10.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.1), float(0.4), float(0.8));

    ShAttrib<3, SH_TEMP, float> out;
    out = lerp(a, b, c);

    try {
      if (test.check("f_3f_3f_3f_calllerp_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_3f_calllerp_test3
    last_test = "f_3f_3f_3f_calllerp_test3";
    ShAttrib<3, SH_CONST, float> a(float(0.1), float(0.3), float(0.9));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(-2.0), float(10.0));
    ShAttrib<3, SH_CONST, float> c(float(10.0), float(0.5), float(5.23));
    ShAttrib<3, SH_CONST, float> expected(float(9.4), float(-0.25), float(9.523));

    ShAttrib<3, SH_TEMP, float> out;
    out = lerp(a, b, c);

    try {
      if (test.check("f_3f_3f_3f_calllerp_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_3f_calllerp_test4
    last_test = "f_3f_3f_3f_calllerp_test4";
    ShAttrib<3, SH_CONST, float> a(float(0.1), float(0.3), float(0.9));
    ShAttrib<3, SH_CONST, float> b(float(40.0), float(-20.0), float(100.0));
    ShAttrib<3, SH_CONST, float> c(float(10.0), float(0.5), float(5.23));
    ShAttrib<3, SH_CONST, float> expected(float(13.0), float(-5.65), float(90.523));

    ShAttrib<3, SH_TEMP, float> out;
    out = lerp(a, b, c);

    try {
      if (test.check("f_3f_3f_3f_calllerp_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_3f_calllerp_test5
    last_test = "f_3f_3f_3f_calllerp_test5";
    ShAttrib<3, SH_CONST, float> a(float(0.1), float(0.3), float(0.9));
    ShAttrib<3, SH_CONST, float> b(float(400.0), float(-200.0), float(1000.0));
    ShAttrib<3, SH_CONST, float> c(float(10.0), float(0.5), float(5.23));
    ShAttrib<3, SH_CONST, float> expected(float(49.0), float(-59.65), float(900.523));

    ShAttrib<3, SH_TEMP, float> out;
    out = lerp(a, b, c);

    try {
      if (test.check("f_3f_3f_3f_calllerp_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_f_f_calllerp_test6
    last_test = "f_f_f_f_calllerp_test6";
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(-3.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(-1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = lerp(a, b, c);

    try {
      if (test.check("f_f_f_f_calllerp_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllerp_test7
    last_test = "f_1f_1f_1f_calllerp_test7";
    ShAttrib<1, SH_CONST, float> a(float(0.1));
    ShAttrib<1, SH_CONST, float> b(float(40.0));
    ShAttrib<1, SH_CONST, float> c(float(10.0));
    ShAttrib<1, SH_CONST, float> expected(float(13.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = lerp(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllerp_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_4f_calllerp_test8
    last_test = "f_4f_4f_4f_calllerp_test8";
    ShAttrib<4, SH_CONST, float> a(float(0.5), float(0.85), float(0.1), float(1.0));
    ShAttrib<4, SH_CONST, float> b(float(5.0), float(1.0), float(0.4), float(30.0));
    ShAttrib<4, SH_CONST, float> c(float(6.2), float(2.0), float(600.0), float(12.3333));
    ShAttrib<4, SH_CONST, float> expected(float(5.6), float(1.15), float(540.04), float(30.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = lerp(a, b, c);

    try {
      if (test.check("f_4f_4f_4f_calllerp_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_4f_4f_calllerp_test9
    last_test = "f_f_4f_4f_calllerp_test9";
    ShAttrib<1, SH_CONST, float> a(float(0.1));
    ShAttrib<4, SH_CONST, float> b(float(4300.2), float(-0.2), float(1000), float(0.4));
    ShAttrib<4, SH_CONST, float> c(float(10.0), float(12.0), float(1.0), float(0.0));
    ShAttrib<4, SH_CONST, float> expected(float(439.02), float(10.78), float(100.9), float(0.04));

    ShAttrib<4, SH_TEMP, float> out;
    out = lerp(a, b, c);

    try {
      if (test.check("f_f_4f_4f_calllerp_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_3f_calllerp_test10
    last_test = "f_f_3f_3f_calllerp_test10";
    ShAttrib<1, SH_CONST, float> a(float(10.0));
    ShAttrib<3, SH_CONST, float> b(float(40.0), float(-2.0), float(0.0));
    ShAttrib<3, SH_CONST, float> c(float(10.0), float(12.0), float(-5.2));
    ShAttrib<3, SH_CONST, float> expected(float(310.0), float(-128.0), float(46.8));

    ShAttrib<3, SH_TEMP, float> out;
    out = lerp(a, b, c);

    try {
      if (test.check("f_f_3f_3f_calllerp_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

