#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram cond_a_f_1f_1f_1f_callcond_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = cond(a, b, c);
  } SH_END;

  cond_a_f_1f_1f_1f_callcond_test0.name("cond_a_f_1f_1f_1f_callcond_test0");
  last_test = "cond_a_f_1f_1f_1f_callcond_test0";
  {  // f_1f_1f_1f_callcond_test0
    ShAttrib<1, SH_CONST, float> a(float(10));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    try {
      if (test.run(cond_a_f_1f_1f_1f_callcond_test0, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cond_a_f_1f_1f_1f_callcond_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = cond(a, b, c);
  } SH_END;

  cond_a_f_1f_1f_1f_callcond_test1.name("cond_a_f_1f_1f_1f_callcond_test1");
  last_test = "cond_a_f_1f_1f_1f_callcond_test1";
  {  // f_1f_1f_1f_callcond_test1
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    try {
      if (test.run(cond_a_f_1f_1f_1f_callcond_test1, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cond_a_f_1f_1f_1f_callcond_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = cond(a, b, c);
  } SH_END;

  cond_a_f_1f_1f_1f_callcond_test2.name("cond_a_f_1f_1f_1f_callcond_test2");
  last_test = "cond_a_f_1f_1f_1f_callcond_test2";
  {  // f_1f_1f_1f_callcond_test2
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    try {
      if (test.run(cond_a_f_1f_1f_1f_callcond_test2, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cond_a_f_1f_1f_1f_callcond_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = cond(a, b, c);
  } SH_END;

  cond_a_f_1f_1f_1f_callcond_test3.name("cond_a_f_1f_1f_1f_callcond_test3");
  last_test = "cond_a_f_1f_1f_1f_callcond_test3";
  {  // f_1f_1f_1f_callcond_test3
    ShAttrib<1, SH_CONST, float> a(float(0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(cond_a_f_1f_1f_1f_callcond_test3, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cond_a_f_1f_1f_1f_callcond_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = cond(a, b, c);
  } SH_END;

  cond_a_f_1f_1f_1f_callcond_test4.name("cond_a_f_1f_1f_1f_callcond_test4");
  last_test = "cond_a_f_1f_1f_1f_callcond_test4";
  {  // f_1f_1f_1f_callcond_test4
    ShAttrib<1, SH_CONST, float> a(float(-0.3));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(cond_a_f_1f_1f_1f_callcond_test4, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cond_a_f_1f_1f_1f_callcond_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = cond(a, b, c);
  } SH_END;

  cond_a_f_1f_1f_1f_callcond_test5.name("cond_a_f_1f_1f_1f_callcond_test5");
  last_test = "cond_a_f_1f_1f_1f_callcond_test5";
  {  // f_1f_1f_1f_callcond_test5
    ShAttrib<1, SH_CONST, float> a(float(-3000));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(cond_a_f_1f_1f_1f_callcond_test5, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cond_a_f_4f_4f_4f_callcond_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = cond(a, b, c);
  } SH_END;

  cond_a_f_4f_4f_4f_callcond_test6.name("cond_a_f_4f_4f_4f_callcond_test6");
  last_test = "cond_a_f_4f_4f_4f_callcond_test6";
  {  // f_4f_4f_4f_callcond_test6
    ShAttrib<4, SH_CONST, float> a(float(1.4), float(0.0), float(-45.0), float(1024));
    ShAttrib<4, SH_CONST, float> b(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<4, SH_CONST, float> c(float(0.0), float(-1.0), float(-2.0), float(-45.8));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(-1.0), float(-2.0), float(4.0));

    try {
      if (test.run(cond_a_f_4f_4f_4f_callcond_test6, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cond_a_f_3f_3f_3f_callcond_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_INPUT, float> c;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = cond(a, b, c);
  } SH_END;

  cond_a_f_3f_3f_3f_callcond_test7.name("cond_a_f_3f_3f_3f_callcond_test7");
  last_test = "cond_a_f_3f_3f_3f_callcond_test7";
  {  // f_3f_3f_3f_callcond_test7
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(20.0), float(-1.0));
    ShAttrib<3, SH_CONST, float> b(float(28.1), float(0.3), float(0.045));
    ShAttrib<3, SH_CONST, float> c(float(0.0), float(-1.0), float(-45.8));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.3), float(-45.8));

    try {
      if (test.run(cond_a_f_3f_3f_3f_callcond_test7, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cond_a_f_2f_2f_2f_callcond_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, float> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_INPUT, float> c;
    ShAttrib<2, SH_OUTPUT, float> out;
    out = cond(a, b, c);
  } SH_END;

  cond_a_f_2f_2f_2f_callcond_test8.name("cond_a_f_2f_2f_2f_callcond_test8");
  last_test = "cond_a_f_2f_2f_2f_callcond_test8";
  {  // f_2f_2f_2f_callcond_test8
    ShAttrib<2, SH_CONST, float> a(float(1.4), float(0.0));
    ShAttrib<2, SH_CONST, float> b(float(-0.4), float(2.2));
    ShAttrib<2, SH_CONST, float> c(float(0.0), float(-1.1));
    ShAttrib<2, SH_CONST, float> expected(float(-0.4), float(-1.1));

    try {
      if (test.run(cond_a_f_2f_2f_2f_callcond_test8, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cond_a_f_f_4f_4f_callcond_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = cond(a, b, c);
  } SH_END;

  cond_a_f_f_4f_4f_callcond_test9.name("cond_a_f_f_4f_4f_callcond_test9");
  last_test = "cond_a_f_f_4f_4f_callcond_test9";
  {  // f_f_4f_4f_callcond_test9
    ShAttrib<1, SH_CONST, float> a(float(1.4));
    ShAttrib<4, SH_CONST, float> b(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<4, SH_CONST, float> c(float(0.0), float(-1.0), float(-2.0), float(-45.8));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0), float(4.0));

    try {
      if (test.run(cond_a_f_f_4f_4f_callcond_test9, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cond_a_f_f_4f_4f_callcond_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = cond(a, b, c);
  } SH_END;

  cond_a_f_f_4f_4f_callcond_test10.name("cond_a_f_f_4f_4f_callcond_test10");
  last_test = "cond_a_f_f_4f_4f_callcond_test10";
  {  // f_f_4f_4f_callcond_test10
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<4, SH_CONST, float> b(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<4, SH_CONST, float> c(float(0.0), float(-1.0), float(-2.0), float(-45.8));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(-1.0), float(-2.0), float(-45.8));

    try {
      if (test.run(cond_a_f_f_4f_4f_callcond_test10, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram all_a_f_4f_callall_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = all(a);
  } SH_END;

  all_a_f_4f_callall_test0.name("all_a_f_4f_callall_test0");
  last_test = "all_a_f_4f_callall_test0";
  {  // f_4f_callall_test0
    ShAttrib<4, SH_CONST, float> a(float(0), float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(all_a_f_4f_callall_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram all_a_f_4f_callall_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = all(a);
  } SH_END;

  all_a_f_4f_callall_test1.name("all_a_f_4f_callall_test1");
  last_test = "all_a_f_4f_callall_test1";
  {  // f_4f_callall_test1
    ShAttrib<4, SH_CONST, float> a(float(0), float(0), float(0), float(1));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(all_a_f_4f_callall_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram all_a_f_4f_callall_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = all(a);
  } SH_END;

  all_a_f_4f_callall_test2.name("all_a_f_4f_callall_test2");
  last_test = "all_a_f_4f_callall_test2";
  {  // f_4f_callall_test2
    ShAttrib<4, SH_CONST, float> a(float(1), float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(all_a_f_4f_callall_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram all_a_f_4f_callall_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = all(a);
  } SH_END;

  all_a_f_4f_callall_test3.name("all_a_f_4f_callall_test3");
  last_test = "all_a_f_4f_callall_test3";
  {  // f_4f_callall_test3
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(15), float(0.5), float(12));
    ShAttrib<1, SH_CONST, float> expected(float(0.1));

    try {
      if (test.run(all_a_f_4f_callall_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram all_a_f_3f_callall_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = all(a);
  } SH_END;

  all_a_f_3f_callall_test4.name("all_a_f_3f_callall_test4");
  last_test = "all_a_f_3f_callall_test4";
  {  // f_3f_callall_test4
    ShAttrib<3, SH_CONST, float> a(float(0), float(1), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(all_a_f_3f_callall_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram all_a_f_1f_callall_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = all(a);
  } SH_END;

  all_a_f_1f_callall_test5.name("all_a_f_1f_callall_test5");
  last_test = "all_a_f_1f_callall_test5";
  {  // f_1f_callall_test5
    ShAttrib<1, SH_CONST, float> a(float(10));
    ShAttrib<1, SH_CONST, float> expected(float(10));

    try {
      if (test.run(all_a_f_1f_callall_test5, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram all_a_f_1f_callall_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = all(a);
  } SH_END;

  all_a_f_1f_callall_test6.name("all_a_f_1f_callall_test6");
  last_test = "all_a_f_1f_callall_test6";
  {  // f_1f_callall_test6
    ShAttrib<1, SH_CONST, float> a(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(all_a_f_1f_callall_test6, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram all_a_f_4f_callall_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = all(a);
  } SH_END;

  all_a_f_4f_callall_test7.name("all_a_f_4f_callall_test7");
  last_test = "all_a_f_4f_callall_test7";
  {  // f_4f_callall_test7
    ShAttrib<4, SH_CONST, float> a(float(-1), float(-0.5), float(-5000), float(-2));
    ShAttrib<1, SH_CONST, float> expected(float(-5000));

    try {
      if (test.run(all_a_f_4f_callall_test7, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram all_a_f_3f_callall_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = all(a);
  } SH_END;

  all_a_f_3f_callall_test8.name("all_a_f_3f_callall_test8");
  last_test = "all_a_f_3f_callall_test8";
  {  // f_3f_callall_test8
    ShAttrib<3, SH_CONST, float> a(float(-1), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(-1));

    try {
      if (test.run(all_a_f_3f_callall_test8, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram all_a_f_3f_callall_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = all(a);
  } SH_END;

  all_a_f_3f_callall_test9.name("all_a_f_3f_callall_test9");
  last_test = "all_a_f_3f_callall_test9";
  {  // f_3f_callall_test9
    ShAttrib<3, SH_CONST, float> a(float(-1000), float(0), float(1000));
    ShAttrib<1, SH_CONST, float> expected(float(-1000));

    try {
      if (test.run(all_a_f_3f_callall_test9, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram any_a_f_4f_callany_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = any(a);
  } SH_END;

  any_a_f_4f_callany_test0.name("any_a_f_4f_callany_test0");
  last_test = "any_a_f_4f_callany_test0";
  {  // f_4f_callany_test0
    ShAttrib<4, SH_CONST, float> a(float(0), float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(any_a_f_4f_callany_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram any_a_f_4f_callany_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = any(a);
  } SH_END;

  any_a_f_4f_callany_test1.name("any_a_f_4f_callany_test1");
  last_test = "any_a_f_4f_callany_test1";
  {  // f_4f_callany_test1
    ShAttrib<4, SH_CONST, float> a(float(0), float(0), float(0), float(1));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    try {
      if (test.run(any_a_f_4f_callany_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram any_a_f_4f_callany_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = any(a);
  } SH_END;

  any_a_f_4f_callany_test2.name("any_a_f_4f_callany_test2");
  last_test = "any_a_f_4f_callany_test2";
  {  // f_4f_callany_test2
    ShAttrib<4, SH_CONST, float> a(float(1), float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    try {
      if (test.run(any_a_f_4f_callany_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram any_a_f_4f_callany_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = any(a);
  } SH_END;

  any_a_f_4f_callany_test3.name("any_a_f_4f_callany_test3");
  last_test = "any_a_f_4f_callany_test3";
  {  // f_4f_callany_test3
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(15), float(0.5), float(12));
    ShAttrib<1, SH_CONST, float> expected(float(15));

    try {
      if (test.run(any_a_f_4f_callany_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram any_a_f_3f_callany_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = any(a);
  } SH_END;

  any_a_f_3f_callany_test4.name("any_a_f_3f_callany_test4");
  last_test = "any_a_f_3f_callany_test4";
  {  // f_3f_callany_test4
    ShAttrib<3, SH_CONST, float> a(float(0), float(1), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    try {
      if (test.run(any_a_f_3f_callany_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram any_a_f_1f_callany_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = any(a);
  } SH_END;

  any_a_f_1f_callany_test5.name("any_a_f_1f_callany_test5");
  last_test = "any_a_f_1f_callany_test5";
  {  // f_1f_callany_test5
    ShAttrib<1, SH_CONST, float> a(float(10));
    ShAttrib<1, SH_CONST, float> expected(float(10));

    try {
      if (test.run(any_a_f_1f_callany_test5, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram any_a_f_1f_callany_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = any(a);
  } SH_END;

  any_a_f_1f_callany_test6.name("any_a_f_1f_callany_test6");
  last_test = "any_a_f_1f_callany_test6";
  {  // f_1f_callany_test6
    ShAttrib<1, SH_CONST, float> a(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(any_a_f_1f_callany_test6, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram any_a_f_4f_callany_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = any(a);
  } SH_END;

  any_a_f_4f_callany_test7.name("any_a_f_4f_callany_test7");
  last_test = "any_a_f_4f_callany_test7";
  {  // f_4f_callany_test7
    ShAttrib<4, SH_CONST, float> a(float(-1), float(-0.5), float(-5000), float(-2));
    ShAttrib<1, SH_CONST, float> expected(float(-0.5));

    try {
      if (test.run(any_a_f_4f_callany_test7, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram any_a_f_3f_callany_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = any(a);
  } SH_END;

  any_a_f_3f_callany_test8.name("any_a_f_3f_callany_test8");
  last_test = "any_a_f_3f_callany_test8";
  {  // f_3f_callany_test8
    ShAttrib<3, SH_CONST, float> a(float(-1), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(any_a_f_3f_callany_test8, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram any_a_f_3f_callany_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = any(a);
  } SH_END;

  any_a_f_3f_callany_test9.name("any_a_f_3f_callany_test9");
  last_test = "any_a_f_3f_callany_test9";
  {  // f_3f_callany_test9
    ShAttrib<3, SH_CONST, float> a(float(-1000), float(0), float(1000));
    ShAttrib<1, SH_CONST, float> expected(float(1000));

    try {
      if (test.run(any_a_f_3f_callany_test9, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram not_a_f_4f_prefix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = ! a;
  } SH_END;

  not_a_f_4f_prefix_test0.name("not_a_f_4f_prefix_test0");
  last_test = "not_a_f_4f_prefix_test0";
  {  // f_4f_prefix_test0
    ShAttrib<4, SH_CONST, float> a(float(0), float(0), float(0), float(0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1), float(1), float(1));

    try {
      if (test.run(not_a_f_4f_prefix_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram not_a_f_4f_prefix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = ! a;
  } SH_END;

  not_a_f_4f_prefix_test1.name("not_a_f_4f_prefix_test1");
  last_test = "not_a_f_4f_prefix_test1";
  {  // f_4f_prefix_test1
    ShAttrib<4, SH_CONST, float> a(float(0), float(0), float(0), float(1));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1), float(1), float(0));

    try {
      if (test.run(not_a_f_4f_prefix_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram not_a_f_4f_prefix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = ! a;
  } SH_END;

  not_a_f_4f_prefix_test2.name("not_a_f_4f_prefix_test2");
  last_test = "not_a_f_4f_prefix_test2";
  {  // f_4f_prefix_test2
    ShAttrib<4, SH_CONST, float> a(float(1), float(0), float(0), float(0));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(1), float(1), float(1));

    try {
      if (test.run(not_a_f_4f_prefix_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram not_a_f_4f_prefix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = ! a;
  } SH_END;

  not_a_f_4f_prefix_test3.name("not_a_f_4f_prefix_test3");
  last_test = "not_a_f_4f_prefix_test3";
  {  // f_4f_prefix_test3
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(15), float(0.5), float(12));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(0), float(0), float(0));

    try {
      if (test.run(not_a_f_4f_prefix_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram not_a_f_3f_prefix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = ! a;
  } SH_END;

  not_a_f_3f_prefix_test4.name("not_a_f_3f_prefix_test4");
  last_test = "not_a_f_3f_prefix_test4";
  {  // f_3f_prefix_test4
    ShAttrib<3, SH_CONST, float> a(float(0), float(1), float(0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(1));

    try {
      if (test.run(not_a_f_3f_prefix_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram not_a_f_1f_prefix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = ! a;
  } SH_END;

  not_a_f_1f_prefix_test5.name("not_a_f_1f_prefix_test5");
  last_test = "not_a_f_1f_prefix_test5";
  {  // f_1f_prefix_test5
    ShAttrib<1, SH_CONST, float> a(float(10));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(not_a_f_1f_prefix_test5, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram not_a_f_1f_prefix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = ! a;
  } SH_END;

  not_a_f_1f_prefix_test6.name("not_a_f_1f_prefix_test6");
  last_test = "not_a_f_1f_prefix_test6";
  {  // f_1f_prefix_test6
    ShAttrib<1, SH_CONST, float> a(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    try {
      if (test.run(not_a_f_1f_prefix_test6, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram not_a_f_4f_prefix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = ! a;
  } SH_END;

  not_a_f_4f_prefix_test7.name("not_a_f_4f_prefix_test7");
  last_test = "not_a_f_4f_prefix_test7";
  {  // f_4f_prefix_test7
    ShAttrib<4, SH_CONST, float> a(float(-1), float(-0.5), float(-5000), float(-2));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1), float(1), float(1));

    try {
      if (test.run(not_a_f_4f_prefix_test7, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram not_a_f_3f_prefix_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = ! a;
  } SH_END;

  not_a_f_3f_prefix_test8.name("not_a_f_3f_prefix_test8");
  last_test = "not_a_f_3f_prefix_test8";
  {  // f_3f_prefix_test8
    ShAttrib<3, SH_CONST, float> a(float(-1), float(0), float(0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    try {
      if (test.run(not_a_f_3f_prefix_test8, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram not_a_f_3f_prefix_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = ! a;
  } SH_END;

  not_a_f_3f_prefix_test9.name("not_a_f_3f_prefix_test9");
  last_test = "not_a_f_3f_prefix_test9";
  {  // f_3f_prefix_test9
    ShAttrib<3, SH_CONST, float> a(float(-1000), float(0), float(1000));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(0));

    try {
      if (test.run(not_a_f_3f_prefix_test9, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram and_a_f_3f_3f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a && b;
  } SH_END;

  and_a_f_3f_3f_infix_test0.name("and_a_f_3f_3f_infix_test0");
  last_test = "and_a_f_3f_3f_infix_test0";
  {  // f_3f_3f_infix_test0
    ShAttrib<3, SH_CONST, float> a(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> b(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    try {
      if (test.run(and_a_f_3f_3f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram and_a_f_3f_3f_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a && b;
  } SH_END;

  and_a_f_3f_3f_infix_test1.name("and_a_f_3f_3f_infix_test1");
  last_test = "and_a_f_3f_3f_infix_test1";
  {  // f_3f_3f_infix_test1
    ShAttrib<3, SH_CONST, float> a(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> b(float(1), float(0), float(-1));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(-1));

    try {
      if (test.run(and_a_f_3f_3f_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram and_a_f_4f_4f_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = a && b;
  } SH_END;

  and_a_f_4f_4f_infix_test2.name("and_a_f_4f_4f_infix_test2");
  last_test = "and_a_f_4f_4f_infix_test2";
  {  // f_4f_4f_infix_test2
    ShAttrib<4, SH_CONST, float> a(float(1), float(0), float(0.4), float(-1));
    ShAttrib<4, SH_CONST, float> b(float(1), float(0), float(0.4), float(-1));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0), float(0.4), float(-1));

    try {
      if (test.run(and_a_f_4f_4f_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram and_a_f_3f_3f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a && b;
  } SH_END;

  and_a_f_3f_3f_infix_test3.name("and_a_f_3f_3f_infix_test3");
  last_test = "and_a_f_3f_3f_infix_test3";
  {  // f_3f_3f_infix_test3
    ShAttrib<3, SH_CONST, float> a(float(0.1), float(0.2), float(0.3));
    ShAttrib<3, SH_CONST, float> b(float(-0.1), float(-0.2), float(-0.3));
    ShAttrib<3, SH_CONST, float> expected(float(-0.1), float(-0.2), float(-0.3));

    try {
      if (test.run(and_a_f_3f_3f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram and_a_f_1f_1f_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a && b;
  } SH_END;

  and_a_f_1f_1f_infix_test4.name("and_a_f_1f_1f_infix_test4");
  last_test = "and_a_f_1f_1f_infix_test4";
  {  // f_1f_1f_infix_test4
    ShAttrib<1, SH_CONST, float> a(float(0.1));
    ShAttrib<1, SH_CONST, float> b(float(-0.1));
    ShAttrib<1, SH_CONST, float> expected(float(-0.1));

    try {
      if (test.run(and_a_f_1f_1f_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram and_a_f_1f_1f_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a && b;
  } SH_END;

  and_a_f_1f_1f_infix_test5.name("and_a_f_1f_1f_infix_test5");
  last_test = "and_a_f_1f_1f_infix_test5";
  {  // f_1f_1f_infix_test5
    ShAttrib<1, SH_CONST, float> a(float(0.1));
    ShAttrib<1, SH_CONST, float> b(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(and_a_f_1f_1f_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram and_a_f_1f_1f_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a && b;
  } SH_END;

  and_a_f_1f_1f_infix_test6.name("and_a_f_1f_1f_infix_test6");
  last_test = "and_a_f_1f_1f_infix_test6";
  {  // f_1f_1f_infix_test6
    ShAttrib<1, SH_CONST, float> a(float(0));
    ShAttrib<1, SH_CONST, float> b(float(-1000));
    ShAttrib<1, SH_CONST, float> expected(float(-1000));

    try {
      if (test.run(and_a_f_1f_1f_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram or_a_f_3f_3f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a || b;
  } SH_END;

  or_a_f_3f_3f_infix_test0.name("or_a_f_3f_3f_infix_test0");
  last_test = "or_a_f_3f_3f_infix_test0";
  {  // f_3f_3f_infix_test0
    ShAttrib<3, SH_CONST, float> a(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> b(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    try {
      if (test.run(or_a_f_3f_3f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram or_a_f_3f_3f_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a || b;
  } SH_END;

  or_a_f_3f_3f_infix_test1.name("or_a_f_3f_3f_infix_test1");
  last_test = "or_a_f_3f_3f_infix_test1";
  {  // f_3f_3f_infix_test1
    ShAttrib<3, SH_CONST, float> a(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> b(float(1), float(0), float(-1));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(0));

    try {
      if (test.run(or_a_f_3f_3f_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram or_a_f_4f_4f_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = a || b;
  } SH_END;

  or_a_f_4f_4f_infix_test2.name("or_a_f_4f_4f_infix_test2");
  last_test = "or_a_f_4f_4f_infix_test2";
  {  // f_4f_4f_infix_test2
    ShAttrib<4, SH_CONST, float> a(float(1), float(0), float(0.4), float(-1));
    ShAttrib<4, SH_CONST, float> b(float(1), float(0), float(0.4), float(-1));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0), float(0.4), float(-1));

    try {
      if (test.run(or_a_f_4f_4f_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram or_a_f_3f_3f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a || b;
  } SH_END;

  or_a_f_3f_3f_infix_test3.name("or_a_f_3f_3f_infix_test3");
  last_test = "or_a_f_3f_3f_infix_test3";
  {  // f_3f_3f_infix_test3
    ShAttrib<3, SH_CONST, float> a(float(0.1), float(0.2), float(0.3));
    ShAttrib<3, SH_CONST, float> b(float(-0.1), float(-0.2), float(-0.3));
    ShAttrib<3, SH_CONST, float> expected(float(0.1), float(0.2), float(0.3));

    try {
      if (test.run(or_a_f_3f_3f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram or_a_f_1f_1f_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a || b;
  } SH_END;

  or_a_f_1f_1f_infix_test4.name("or_a_f_1f_1f_infix_test4");
  last_test = "or_a_f_1f_1f_infix_test4";
  {  // f_1f_1f_infix_test4
    ShAttrib<1, SH_CONST, float> a(float(0.1));
    ShAttrib<1, SH_CONST, float> b(float(-0.1));
    ShAttrib<1, SH_CONST, float> expected(float(0.1));

    try {
      if (test.run(or_a_f_1f_1f_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram or_a_f_1f_1f_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a || b;
  } SH_END;

  or_a_f_1f_1f_infix_test5.name("or_a_f_1f_1f_infix_test5");
  last_test = "or_a_f_1f_1f_infix_test5";
  {  // f_1f_1f_infix_test5
    ShAttrib<1, SH_CONST, float> a(float(0.1));
    ShAttrib<1, SH_CONST, float> b(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.1));

    try {
      if (test.run(or_a_f_1f_1f_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram or_a_f_1f_1f_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a || b;
  } SH_END;

  or_a_f_1f_1f_infix_test6.name("or_a_f_1f_1f_infix_test6");
  last_test = "or_a_f_1f_1f_infix_test6";
  {  // f_1f_1f_infix_test6
    ShAttrib<1, SH_CONST, float> a(float(0));
    ShAttrib<1, SH_CONST, float> b(float(-1000));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(or_a_f_1f_1f_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_1f_1f_1f_callcond_test0
    last_test = "f_1f_1f_1f_callcond_test0";
    ShAttrib<1, SH_CONST, float> a(float(10));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = cond(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_callcond_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_callcond_test1
    last_test = "f_1f_1f_1f_callcond_test1";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = cond(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_callcond_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_callcond_test2
    last_test = "f_1f_1f_1f_callcond_test2";
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = cond(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_callcond_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_callcond_test3
    last_test = "f_1f_1f_1f_callcond_test3";
    ShAttrib<1, SH_CONST, float> a(float(0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = cond(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_callcond_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_callcond_test4
    last_test = "f_1f_1f_1f_callcond_test4";
    ShAttrib<1, SH_CONST, float> a(float(-0.3));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = cond(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_callcond_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_callcond_test5
    last_test = "f_1f_1f_1f_callcond_test5";
    ShAttrib<1, SH_CONST, float> a(float(-3000));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = cond(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_callcond_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_4f_callcond_test6
    last_test = "f_4f_4f_4f_callcond_test6";
    ShAttrib<4, SH_CONST, float> a(float(1.4), float(0.0), float(-45.0), float(1024));
    ShAttrib<4, SH_CONST, float> b(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<4, SH_CONST, float> c(float(0.0), float(-1.0), float(-2.0), float(-45.8));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(-1.0), float(-2.0), float(4.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = cond(a, b, c);

    try {
      if (test.check("f_4f_4f_4f_callcond_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_3f_callcond_test7
    last_test = "f_3f_3f_3f_callcond_test7";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(20.0), float(-1.0));
    ShAttrib<3, SH_CONST, float> b(float(28.1), float(0.3), float(0.045));
    ShAttrib<3, SH_CONST, float> c(float(0.0), float(-1.0), float(-45.8));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.3), float(-45.8));

    ShAttrib<3, SH_TEMP, float> out;
    out = cond(a, b, c);

    try {
      if (test.check("f_3f_3f_3f_callcond_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_2f_2f_callcond_test8
    last_test = "f_2f_2f_2f_callcond_test8";
    ShAttrib<2, SH_CONST, float> a(float(1.4), float(0.0));
    ShAttrib<2, SH_CONST, float> b(float(-0.4), float(2.2));
    ShAttrib<2, SH_CONST, float> c(float(0.0), float(-1.1));
    ShAttrib<2, SH_CONST, float> expected(float(-0.4), float(-1.1));

    ShAttrib<2, SH_TEMP, float> out;
    out = cond(a, b, c);

    try {
      if (test.check("f_2f_2f_2f_callcond_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_4f_4f_callcond_test9
    last_test = "f_f_4f_4f_callcond_test9";
    ShAttrib<1, SH_CONST, float> a(float(1.4));
    ShAttrib<4, SH_CONST, float> b(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<4, SH_CONST, float> c(float(0.0), float(-1.0), float(-2.0), float(-45.8));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0), float(4.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = cond(a, b, c);

    try {
      if (test.check("f_f_4f_4f_callcond_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_4f_4f_callcond_test10
    last_test = "f_f_4f_4f_callcond_test10";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<4, SH_CONST, float> b(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<4, SH_CONST, float> c(float(0.0), float(-1.0), float(-2.0), float(-45.8));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(-1.0), float(-2.0), float(-45.8));

    ShAttrib<4, SH_TEMP, float> out;
    out = cond(a, b, c);

    try {
      if (test.check("f_f_4f_4f_callcond_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callall_test0
    last_test = "f_4f_callall_test0";
    ShAttrib<4, SH_CONST, float> a(float(0), float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = all(a);

    try {
      if (test.check("f_4f_callall_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callall_test1
    last_test = "f_4f_callall_test1";
    ShAttrib<4, SH_CONST, float> a(float(0), float(0), float(0), float(1));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = all(a);

    try {
      if (test.check("f_4f_callall_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callall_test2
    last_test = "f_4f_callall_test2";
    ShAttrib<4, SH_CONST, float> a(float(1), float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = all(a);

    try {
      if (test.check("f_4f_callall_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callall_test3
    last_test = "f_4f_callall_test3";
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(15), float(0.5), float(12));
    ShAttrib<1, SH_CONST, float> expected(float(0.1));

    ShAttrib<1, SH_TEMP, float> out;
    out = all(a);

    try {
      if (test.check("f_4f_callall_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callall_test4
    last_test = "f_3f_callall_test4";
    ShAttrib<3, SH_CONST, float> a(float(0), float(1), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = all(a);

    try {
      if (test.check("f_3f_callall_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callall_test5
    last_test = "f_1f_callall_test5";
    ShAttrib<1, SH_CONST, float> a(float(10));
    ShAttrib<1, SH_CONST, float> expected(float(10));

    ShAttrib<1, SH_TEMP, float> out;
    out = all(a);

    try {
      if (test.check("f_1f_callall_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callall_test6
    last_test = "f_1f_callall_test6";
    ShAttrib<1, SH_CONST, float> a(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = all(a);

    try {
      if (test.check("f_1f_callall_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callall_test7
    last_test = "f_4f_callall_test7";
    ShAttrib<4, SH_CONST, float> a(float(-1), float(-0.5), float(-5000), float(-2));
    ShAttrib<1, SH_CONST, float> expected(float(-5000));

    ShAttrib<1, SH_TEMP, float> out;
    out = all(a);

    try {
      if (test.check("f_4f_callall_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callall_test8
    last_test = "f_3f_callall_test8";
    ShAttrib<3, SH_CONST, float> a(float(-1), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(-1));

    ShAttrib<1, SH_TEMP, float> out;
    out = all(a);

    try {
      if (test.check("f_3f_callall_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callall_test9
    last_test = "f_3f_callall_test9";
    ShAttrib<3, SH_CONST, float> a(float(-1000), float(0), float(1000));
    ShAttrib<1, SH_CONST, float> expected(float(-1000));

    ShAttrib<1, SH_TEMP, float> out;
    out = all(a);

    try {
      if (test.check("f_3f_callall_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callany_test0
    last_test = "f_4f_callany_test0";
    ShAttrib<4, SH_CONST, float> a(float(0), float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = any(a);

    try {
      if (test.check("f_4f_callany_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callany_test1
    last_test = "f_4f_callany_test1";
    ShAttrib<4, SH_CONST, float> a(float(0), float(0), float(0), float(1));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    ShAttrib<1, SH_TEMP, float> out;
    out = any(a);

    try {
      if (test.check("f_4f_callany_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callany_test2
    last_test = "f_4f_callany_test2";
    ShAttrib<4, SH_CONST, float> a(float(1), float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    ShAttrib<1, SH_TEMP, float> out;
    out = any(a);

    try {
      if (test.check("f_4f_callany_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callany_test3
    last_test = "f_4f_callany_test3";
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(15), float(0.5), float(12));
    ShAttrib<1, SH_CONST, float> expected(float(15));

    ShAttrib<1, SH_TEMP, float> out;
    out = any(a);

    try {
      if (test.check("f_4f_callany_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callany_test4
    last_test = "f_3f_callany_test4";
    ShAttrib<3, SH_CONST, float> a(float(0), float(1), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    ShAttrib<1, SH_TEMP, float> out;
    out = any(a);

    try {
      if (test.check("f_3f_callany_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callany_test5
    last_test = "f_1f_callany_test5";
    ShAttrib<1, SH_CONST, float> a(float(10));
    ShAttrib<1, SH_CONST, float> expected(float(10));

    ShAttrib<1, SH_TEMP, float> out;
    out = any(a);

    try {
      if (test.check("f_1f_callany_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callany_test6
    last_test = "f_1f_callany_test6";
    ShAttrib<1, SH_CONST, float> a(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = any(a);

    try {
      if (test.check("f_1f_callany_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callany_test7
    last_test = "f_4f_callany_test7";
    ShAttrib<4, SH_CONST, float> a(float(-1), float(-0.5), float(-5000), float(-2));
    ShAttrib<1, SH_CONST, float> expected(float(-0.5));

    ShAttrib<1, SH_TEMP, float> out;
    out = any(a);

    try {
      if (test.check("f_4f_callany_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callany_test8
    last_test = "f_3f_callany_test8";
    ShAttrib<3, SH_CONST, float> a(float(-1), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = any(a);

    try {
      if (test.check("f_3f_callany_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callany_test9
    last_test = "f_3f_callany_test9";
    ShAttrib<3, SH_CONST, float> a(float(-1000), float(0), float(1000));
    ShAttrib<1, SH_CONST, float> expected(float(1000));

    ShAttrib<1, SH_TEMP, float> out;
    out = any(a);

    try {
      if (test.check("f_3f_callany_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_prefix_test0
    last_test = "f_4f_prefix_test0";
    ShAttrib<4, SH_CONST, float> a(float(0), float(0), float(0), float(0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1), float(1), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = ! a;

    try {
      if (test.check("f_4f_prefix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_prefix_test1
    last_test = "f_4f_prefix_test1";
    ShAttrib<4, SH_CONST, float> a(float(0), float(0), float(0), float(1));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1), float(1), float(0));

    ShAttrib<4, SH_TEMP, float> out;
    out = ! a;

    try {
      if (test.check("f_4f_prefix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_prefix_test2
    last_test = "f_4f_prefix_test2";
    ShAttrib<4, SH_CONST, float> a(float(1), float(0), float(0), float(0));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(1), float(1), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = ! a;

    try {
      if (test.check("f_4f_prefix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_prefix_test3
    last_test = "f_4f_prefix_test3";
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(15), float(0.5), float(12));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(0), float(0), float(0));

    ShAttrib<4, SH_TEMP, float> out;
    out = ! a;

    try {
      if (test.check("f_4f_prefix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_prefix_test4
    last_test = "f_3f_prefix_test4";
    ShAttrib<3, SH_CONST, float> a(float(0), float(1), float(0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = ! a;

    try {
      if (test.check("f_3f_prefix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_prefix_test5
    last_test = "f_1f_prefix_test5";
    ShAttrib<1, SH_CONST, float> a(float(10));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = ! a;

    try {
      if (test.check("f_1f_prefix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_prefix_test6
    last_test = "f_1f_prefix_test6";
    ShAttrib<1, SH_CONST, float> a(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    ShAttrib<1, SH_TEMP, float> out;
    out = ! a;

    try {
      if (test.check("f_1f_prefix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_prefix_test7
    last_test = "f_4f_prefix_test7";
    ShAttrib<4, SH_CONST, float> a(float(-1), float(-0.5), float(-5000), float(-2));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1), float(1), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = ! a;

    try {
      if (test.check("f_4f_prefix_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_prefix_test8
    last_test = "f_3f_prefix_test8";
    ShAttrib<3, SH_CONST, float> a(float(-1), float(0), float(0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = ! a;

    try {
      if (test.check("f_3f_prefix_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_prefix_test9
    last_test = "f_3f_prefix_test9";
    ShAttrib<3, SH_CONST, float> a(float(-1000), float(0), float(1000));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = ! a;

    try {
      if (test.check("f_3f_prefix_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test0
    last_test = "f_3f_3f_infix_test0";
    ShAttrib<3, SH_CONST, float> a(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> b(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a && b;

    try {
      if (test.check("f_3f_3f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test1
    last_test = "f_3f_3f_infix_test1";
    ShAttrib<3, SH_CONST, float> a(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> b(float(1), float(0), float(-1));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(-1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a && b;

    try {
      if (test.check("f_3f_3f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_infix_test2
    last_test = "f_4f_4f_infix_test2";
    ShAttrib<4, SH_CONST, float> a(float(1), float(0), float(0.4), float(-1));
    ShAttrib<4, SH_CONST, float> b(float(1), float(0), float(0.4), float(-1));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0), float(0.4), float(-1));

    ShAttrib<4, SH_TEMP, float> out;
    out = a && b;

    try {
      if (test.check("f_4f_4f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShAttrib<3, SH_CONST, float> a(float(0.1), float(0.2), float(0.3));
    ShAttrib<3, SH_CONST, float> b(float(-0.1), float(-0.2), float(-0.3));
    ShAttrib<3, SH_CONST, float> expected(float(-0.1), float(-0.2), float(-0.3));

    ShAttrib<3, SH_TEMP, float> out;
    out = a && b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test4
    last_test = "f_1f_1f_infix_test4";
    ShAttrib<1, SH_CONST, float> a(float(0.1));
    ShAttrib<1, SH_CONST, float> b(float(-0.1));
    ShAttrib<1, SH_CONST, float> expected(float(-0.1));

    ShAttrib<1, SH_TEMP, float> out;
    out = a && b;

    try {
      if (test.check("f_1f_1f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test5
    last_test = "f_1f_1f_infix_test5";
    ShAttrib<1, SH_CONST, float> a(float(0.1));
    ShAttrib<1, SH_CONST, float> b(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = a && b;

    try {
      if (test.check("f_1f_1f_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test6
    last_test = "f_1f_1f_infix_test6";
    ShAttrib<1, SH_CONST, float> a(float(0));
    ShAttrib<1, SH_CONST, float> b(float(-1000));
    ShAttrib<1, SH_CONST, float> expected(float(-1000));

    ShAttrib<1, SH_TEMP, float> out;
    out = a && b;

    try {
      if (test.check("f_1f_1f_infix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test0
    last_test = "f_3f_3f_infix_test0";
    ShAttrib<3, SH_CONST, float> a(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> b(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a || b;

    try {
      if (test.check("f_3f_3f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test1
    last_test = "f_3f_3f_infix_test1";
    ShAttrib<3, SH_CONST, float> a(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> b(float(1), float(0), float(-1));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a || b;

    try {
      if (test.check("f_3f_3f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_infix_test2
    last_test = "f_4f_4f_infix_test2";
    ShAttrib<4, SH_CONST, float> a(float(1), float(0), float(0.4), float(-1));
    ShAttrib<4, SH_CONST, float> b(float(1), float(0), float(0.4), float(-1));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0), float(0.4), float(-1));

    ShAttrib<4, SH_TEMP, float> out;
    out = a || b;

    try {
      if (test.check("f_4f_4f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShAttrib<3, SH_CONST, float> a(float(0.1), float(0.2), float(0.3));
    ShAttrib<3, SH_CONST, float> b(float(-0.1), float(-0.2), float(-0.3));
    ShAttrib<3, SH_CONST, float> expected(float(0.1), float(0.2), float(0.3));

    ShAttrib<3, SH_TEMP, float> out;
    out = a || b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test4
    last_test = "f_1f_1f_infix_test4";
    ShAttrib<1, SH_CONST, float> a(float(0.1));
    ShAttrib<1, SH_CONST, float> b(float(-0.1));
    ShAttrib<1, SH_CONST, float> expected(float(0.1));

    ShAttrib<1, SH_TEMP, float> out;
    out = a || b;

    try {
      if (test.check("f_1f_1f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test5
    last_test = "f_1f_1f_infix_test5";
    ShAttrib<1, SH_CONST, float> a(float(0.1));
    ShAttrib<1, SH_CONST, float> b(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.1));

    ShAttrib<1, SH_TEMP, float> out;
    out = a || b;

    try {
      if (test.check("f_1f_1f_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test6
    last_test = "f_1f_1f_infix_test6";
    ShAttrib<1, SH_CONST, float> a(float(0));
    ShAttrib<1, SH_CONST, float> b(float(-1000));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = a || b;

    try {
      if (test.check("f_1f_1f_infix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

