#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram mad_a_f_3f_3f_3f_callmad_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_INPUT, float> c;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = mad(a, b, c);
  } SH_END;

  mad_a_f_3f_3f_3f_callmad_test0.name("mad_a_f_3f_3f_3f_callmad_test0");
  last_test = "mad_a_f_3f_3f_3f_callmad_test0";
  {  // f_3f_3f_3f_callmad_test0
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> c(float(1.0), float(1.1), float(1.2));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(5.1), float(11.2));

    try {
      if (test.run(mad_a_f_3f_3f_3f_callmad_test0, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mad_a_f_1f_1f_1f_callmad_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = mad(a, b, c);
  } SH_END;

  mad_a_f_1f_1f_1f_callmad_test1.name("mad_a_f_1f_1f_1f_callmad_test1");
  last_test = "mad_a_f_1f_1f_1f_callmad_test1";
  {  // f_1f_1f_1f_callmad_test1
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<1, SH_CONST, float> c(float(-5000.0));
    ShAttrib<1, SH_CONST, float> expected(float(-4993.0));

    try {
      if (test.run(mad_a_f_1f_1f_1f_callmad_test1, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mad_a_f_3f_3f_3f_callmad_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_INPUT, float> c;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = mad(a, b, c);
  } SH_END;

  mad_a_f_3f_3f_3f_callmad_test2.name("mad_a_f_3f_3f_3f_callmad_test2");
  last_test = "mad_a_f_3f_3f_3f_callmad_test2";
  {  // f_3f_3f_3f_callmad_test2
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<3, SH_CONST, float> c(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(-16.0), float(-25.0), float(-36.0));

    try {
      if (test.run(mad_a_f_3f_3f_3f_callmad_test2, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mad_a_f_f_3f_3f_callmad_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_INPUT, float> c;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = mad(a, b, c);
  } SH_END;

  mad_a_f_f_3f_3f_callmad_test3.name("mad_a_f_f_3f_3f_callmad_test3");
  last_test = "mad_a_f_f_3f_3f_callmad_test3";
  {  // f_f_3f_3f_callmad_test3
    ShAttrib<1, SH_CONST, float> a(float(7.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> c(float(-1.0), float(0.5), float(10.0));
    ShAttrib<3, SH_CONST, float> expected(float(6.0), float(14.5), float(31.0));

    try {
      if (test.run(mad_a_f_f_3f_3f_callmad_test3, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mad_a_f_3f_f_3f_callmad_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_INPUT, float> c;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = mad(a, b, c);
  } SH_END;

  mad_a_f_3f_f_3f_callmad_test4.name("mad_a_f_3f_f_3f_callmad_test4");
  last_test = "mad_a_f_3f_f_3f_callmad_test4";
  {  // f_3f_f_3f_callmad_test4
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<3, SH_CONST, float> c(float(-1.0), float(0.5), float(10.0));
    ShAttrib<3, SH_CONST, float> expected(float(6.0), float(14.5), float(31.0));

    try {
      if (test.run(mad_a_f_3f_f_3f_callmad_test4, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_3f_3f_3f_callmad_test0
    last_test = "f_3f_3f_3f_callmad_test0";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> c(float(1.0), float(1.1), float(1.2));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(5.1), float(11.2));

    ShAttrib<3, SH_TEMP, float> out;
    out = mad(a, b, c);

    try {
      if (test.check("f_3f_3f_3f_callmad_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_callmad_test1
    last_test = "f_1f_1f_1f_callmad_test1";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<1, SH_CONST, float> c(float(-5000.0));
    ShAttrib<1, SH_CONST, float> expected(float(-4993.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = mad(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_callmad_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_3f_callmad_test2
    last_test = "f_3f_3f_3f_callmad_test2";
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<3, SH_CONST, float> c(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(-16.0), float(-25.0), float(-36.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = mad(a, b, c);

    try {
      if (test.check("f_3f_3f_3f_callmad_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_3f_callmad_test3
    last_test = "f_f_3f_3f_callmad_test3";
    ShAttrib<1, SH_CONST, float> a(float(7.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> c(float(-1.0), float(0.5), float(10.0));
    ShAttrib<3, SH_CONST, float> expected(float(6.0), float(14.5), float(31.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = mad(a, b, c);

    try {
      if (test.check("f_f_3f_3f_callmad_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_3f_callmad_test4
    last_test = "f_3f_f_3f_callmad_test4";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<3, SH_CONST, float> c(float(-1.0), float(0.5), float(10.0));
    ShAttrib<3, SH_CONST, float> expected(float(6.0), float(14.5), float(31.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = mad(a, b, c);

    try {
      if (test.check("f_3f_f_3f_callmad_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

