#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  {  // f_3f_3f_infix_test0
    last_test = "f_3f_3f_infix_test0";
    ShMatrix<3, 3, SH_TEMP, float> a;
    a[0](0) = 0.0; a[0](1) = 0.0; a[0](2) = 0.0; 
    a[1](0) = 0.0; a[1](1) = 0.0; a[1](2) = 0.0; 
    a[2](0) = 0.0; a[2](1) = 0.0; a[2](2) = 0.0; 
    ShMatrix<3, 3, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; 
    ShMatrix<3, 3, SH_TEMP, float> expected;
    expected[0](0) = 0.0; expected[0](1) = 0.0; expected[0](2) = 0.0; 
    expected[1](0) = 0.0; expected[1](1) = 0.0; expected[1](2) = 0.0; 
    expected[2](0) = 0.0; expected[2](1) = 0.0; expected[2](2) = 0.0; 

    ShMatrix<3, 3, SH_TEMP, float> out;
    out = a / b;

    try {
      if (test.check("f_3f_3f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test1
    last_test = "f_3f_3f_infix_test1";
    ShMatrix<3, 3, SH_TEMP, float> a;
    a[0](0) = -1.0; a[0](1) = -2.0; a[0](2) = -3.0; 
    a[1](0) = -3.0; a[1](1) = -4.0; a[1](2) = -5.0; 
    a[2](0) = -5.0; a[2](1) = -6.0; a[2](2) = -7.0; 
    ShMatrix<3, 3, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; 
    ShMatrix<3, 3, SH_TEMP, float> expected;
    expected[0](0) = -1.0; expected[0](1) = -1.0; expected[0](2) = -1.0; 
    expected[1](0) = -1.0; expected[1](1) = -1.0; expected[1](2) = -1.0; 
    expected[2](0) = -1.0; expected[2](1) = -1.0; expected[2](2) = -1.0; 

    ShMatrix<3, 3, SH_TEMP, float> out;
    out = a / b;

    try {
      if (test.check("f_3f_3f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test2
    last_test = "f_3f_3f_infix_test2";
    ShMatrix<3, 3, SH_TEMP, float> a;
    a[0](0) = -1.0; a[0](1) = 0.5; a[0](2) = 3.23333; 
    a[1](0) = -3.0; a[1](1) = 4.2; a[1](2) = -0.1; 
    a[2](0) = 5000.0; a[2](1) = -6.0; a[2](2) = 7.1; 
    ShMatrix<3, 3, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 1.0; b[0](2) = 1.0; 
    b[1](0) = 1.0; b[1](1) = 1.0; b[1](2) = 1.0; 
    b[2](0) = 1.0; b[2](1) = 1.0; b[2](2) = 1.0; 
    ShMatrix<3, 3, SH_TEMP, float> expected;
    expected[0](0) = -1.0; expected[0](1) = 0.5; expected[0](2) = 3.23333; 
    expected[1](0) = -3.0; expected[1](1) = 4.2; expected[1](2) = -0.1; 
    expected[2](0) = 5000.0; expected[2](1) = -6.0; expected[2](2) = 7.1; 

    ShMatrix<3, 3, SH_TEMP, float> out;
    out = a / b;

    try {
      if (test.check("f_3f_3f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShMatrix<3, 3, SH_TEMP, float> a;
    a[0](0) = 0.0; a[0](1) = 1.0; a[0](2) = 2.0; 
    a[1](0) = 0.0; a[1](1) = 1.0; a[1](2) = 0.0; 
    a[2](0) = 0.0; a[2](1) = 0.0; a[2](2) = 1.0; 
    ShMatrix<3, 3, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; 
    ShMatrix<3, 3, SH_TEMP, float> expected;
    expected[0](0) = 0.0; expected[0](1) = 0.5; expected[0](2) = 0.666666666667; 
    expected[1](0) = 0.0; expected[1](1) = 0.25; expected[1](2) = 0.0; 
    expected[2](0) = 0.0; expected[2](1) = 0.0; expected[2](2) = 0.142857142857; 

    ShMatrix<3, 3, SH_TEMP, float> out;
    out = a / b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test4
    last_test = "f_3f_3f_infix_test4";
    ShMatrix<3, 2, SH_TEMP, float> a;
    a[0](0) = -1000.0; a[0](1) = 1.3333; 
    a[1](0) = 0.0; a[1](1) = 1.0; 
    a[2](0) = -0.1; a[2](1) = 0.5; 
    ShMatrix<3, 2, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; 
    ShMatrix<3, 2, SH_TEMP, float> expected;
    expected[0](0) = -1000.0; expected[0](1) = 0.66665; 
    expected[1](0) = 0.0; expected[1](1) = 0.25; 
    expected[2](0) = -0.02; expected[2](1) = 0.0833333333333; 

    ShMatrix<3, 2, SH_TEMP, float> out;
    out = a / b;

    try {
      if (test.check("f_3f_3f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test5
    last_test = "f_3f_3f_infix_test5";
    ShMatrix<3, 4, SH_TEMP, float> a;
    a[0](0) = 0.0; a[0](1) = 1.0; a[0](2) = 2.0; a[0](3) = 3.0; 
    a[1](0) = 0.0; a[1](1) = 1.0; a[1](2) = 0.0; a[1](3) = 0.5; 
    a[2](0) = 0.0; a[2](1) = 0.0; a[2](2) = 1.0; a[2](3) = 6.7; 
    ShMatrix<3, 4, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; b[0](3) = 4.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; b[1](3) = 90.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; b[2](3) = -1.0; 
    ShMatrix<3, 4, SH_TEMP, float> expected;
    expected[0](0) = 0.0; expected[0](1) = 0.5; expected[0](2) = 0.666666666667; expected[0](3) = 0.75; 
    expected[1](0) = 0.0; expected[1](1) = 0.25; expected[1](2) = 0.0; expected[1](3) = 0.00555555555556; 
    expected[2](0) = 0.0; expected[2](1) = 0.0; expected[2](2) = 0.142857142857; expected[2](3) = -6.7; 

    ShMatrix<3, 4, SH_TEMP, float> out;
    out = a / b;

    try {
      if (test.check("f_3f_3f_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test0
    last_test = "f_3f_3f_infix_test0";
    ShMatrix<3, 3, SH_TEMP, float> a;
    a[0](0) = 0.0; a[0](1) = 0.0; a[0](2) = 0.0; 
    a[1](0) = 0.0; a[1](1) = 0.0; a[1](2) = 0.0; 
    a[2](0) = 0.0; a[2](1) = 0.0; a[2](2) = 0.0; 
    ShMatrix<3, 3, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; 
    ShMatrix<3, 3, SH_TEMP, float> expected;
    expected[0](0) = 0.0; expected[0](1) = 0.0; expected[0](2) = 0.0; 
    expected[1](0) = 0.0; expected[1](1) = 0.0; expected[1](2) = 0.0; 
    expected[2](0) = 0.0; expected[2](1) = 0.0; expected[2](2) = 0.0; 

    ShMatrix<3, 3, SH_TEMP, float> out;
    out = a /= b;

    try {
      if (test.check("f_3f_3f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test1
    last_test = "f_3f_3f_infix_test1";
    ShMatrix<3, 3, SH_TEMP, float> a;
    a[0](0) = -1.0; a[0](1) = -2.0; a[0](2) = -3.0; 
    a[1](0) = -3.0; a[1](1) = -4.0; a[1](2) = -5.0; 
    a[2](0) = -5.0; a[2](1) = -6.0; a[2](2) = -7.0; 
    ShMatrix<3, 3, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; 
    ShMatrix<3, 3, SH_TEMP, float> expected;
    expected[0](0) = -1.0; expected[0](1) = -1.0; expected[0](2) = -1.0; 
    expected[1](0) = -1.0; expected[1](1) = -1.0; expected[1](2) = -1.0; 
    expected[2](0) = -1.0; expected[2](1) = -1.0; expected[2](2) = -1.0; 

    ShMatrix<3, 3, SH_TEMP, float> out;
    out = a /= b;

    try {
      if (test.check("f_3f_3f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test2
    last_test = "f_3f_3f_infix_test2";
    ShMatrix<3, 3, SH_TEMP, float> a;
    a[0](0) = -1.0; a[0](1) = 0.5; a[0](2) = 3.23333; 
    a[1](0) = -3.0; a[1](1) = 4.2; a[1](2) = -0.1; 
    a[2](0) = 5000.0; a[2](1) = -6.0; a[2](2) = 7.1; 
    ShMatrix<3, 3, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 1.0; b[0](2) = 1.0; 
    b[1](0) = 1.0; b[1](1) = 1.0; b[1](2) = 1.0; 
    b[2](0) = 1.0; b[2](1) = 1.0; b[2](2) = 1.0; 
    ShMatrix<3, 3, SH_TEMP, float> expected;
    expected[0](0) = -1.0; expected[0](1) = 0.5; expected[0](2) = 3.23333; 
    expected[1](0) = -3.0; expected[1](1) = 4.2; expected[1](2) = -0.1; 
    expected[2](0) = 5000.0; expected[2](1) = -6.0; expected[2](2) = 7.1; 

    ShMatrix<3, 3, SH_TEMP, float> out;
    out = a /= b;

    try {
      if (test.check("f_3f_3f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShMatrix<3, 3, SH_TEMP, float> a;
    a[0](0) = 0.0; a[0](1) = 1.0; a[0](2) = 2.0; 
    a[1](0) = 0.0; a[1](1) = 1.0; a[1](2) = 0.0; 
    a[2](0) = 0.0; a[2](1) = 0.0; a[2](2) = 1.0; 
    ShMatrix<3, 3, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; 
    ShMatrix<3, 3, SH_TEMP, float> expected;
    expected[0](0) = 0.0; expected[0](1) = 0.5; expected[0](2) = 0.666666666667; 
    expected[1](0) = 0.0; expected[1](1) = 0.25; expected[1](2) = 0.0; 
    expected[2](0) = 0.0; expected[2](1) = 0.0; expected[2](2) = 0.142857142857; 

    ShMatrix<3, 3, SH_TEMP, float> out;
    out = a /= b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test4
    last_test = "f_3f_3f_infix_test4";
    ShMatrix<3, 2, SH_TEMP, float> a;
    a[0](0) = -1000.0; a[0](1) = 1.3333; 
    a[1](0) = 0.0; a[1](1) = 1.0; 
    a[2](0) = -0.1; a[2](1) = 0.5; 
    ShMatrix<3, 2, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; 
    ShMatrix<3, 2, SH_TEMP, float> expected;
    expected[0](0) = -1000.0; expected[0](1) = 0.66665; 
    expected[1](0) = 0.0; expected[1](1) = 0.25; 
    expected[2](0) = -0.02; expected[2](1) = 0.0833333333333; 

    ShMatrix<3, 2, SH_TEMP, float> out;
    out = a /= b;

    try {
      if (test.check("f_3f_3f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test5
    last_test = "f_3f_3f_infix_test5";
    ShMatrix<3, 4, SH_TEMP, float> a;
    a[0](0) = 0.0; a[0](1) = 1.0; a[0](2) = 2.0; a[0](3) = 3.0; 
    a[1](0) = 0.0; a[1](1) = 1.0; a[1](2) = 0.0; a[1](3) = 0.5; 
    a[2](0) = 0.0; a[2](1) = 0.0; a[2](2) = 1.0; a[2](3) = 6.7; 
    ShMatrix<3, 4, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; b[0](3) = 4.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; b[1](3) = 90.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; b[2](3) = -1.0; 
    ShMatrix<3, 4, SH_TEMP, float> expected;
    expected[0](0) = 0.0; expected[0](1) = 0.5; expected[0](2) = 0.666666666667; expected[0](3) = 0.75; 
    expected[1](0) = 0.0; expected[1](1) = 0.25; expected[1](2) = 0.0; expected[1](3) = 0.00555555555556; 
    expected[2](0) = 0.0; expected[2](1) = 0.0; expected[2](2) = 0.142857142857; expected[2](3) = -6.7; 

    ShMatrix<3, 4, SH_TEMP, float> out;
    out = a /= b;

    try {
      if (test.check("f_3f_3f_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

