#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  {  // f_3f_3f_infix_test0
    last_test = "f_3f_3f_infix_test0";
    ShMatrix<3, 3, SH_TEMP, float> a;
    a[0](0) = 0.0; a[0](1) = 0.0; a[0](2) = 0.0; 
    a[1](0) = 0.0; a[1](1) = 0.0; a[1](2) = 0.0; 
    a[2](0) = 0.0; a[2](1) = 0.0; a[2](2) = 0.0; 
    ShMatrix<3, 3, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; 
    ShMatrix<3, 3, SH_TEMP, float> expected;
    expected[0](0) = 0.0; expected[0](1) = 0.0; expected[0](2) = 0.0; 
    expected[1](0) = 0.0; expected[1](1) = 0.0; expected[1](2) = 0.0; 
    expected[2](0) = 0.0; expected[2](1) = 0.0; expected[2](2) = 0.0; 

    ShMatrix<3, 3, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_3f_3f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test1
    last_test = "f_3f_3f_infix_test1";
    ShMatrix<3, 3, SH_TEMP, float> a;
    a[0](0) = 1.0; a[0](1) = 0.0; a[0](2) = 0.0; 
    a[1](0) = 0.0; a[1](1) = 1.0; a[1](2) = 0.0; 
    a[2](0) = 0.0; a[2](1) = 0.0; a[2](2) = 1.0; 
    ShMatrix<3, 3, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; 
    ShMatrix<3, 3, SH_TEMP, float> expected;
    expected[0](0) = 1.0; expected[0](1) = 2.0; expected[0](2) = 3.0; 
    expected[1](0) = 3.0; expected[1](1) = 4.0; expected[1](2) = 5.0; 
    expected[2](0) = 5.0; expected[2](1) = 6.0; expected[2](2) = 7.0; 

    ShMatrix<3, 3, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_3f_3f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_infix_test2
    last_test = "f_4f_4f_infix_test2";
    ShMatrix<4, 4, SH_TEMP, float> a;
    a[0](0) = 0.0; a[0](1) = 1.0; a[0](2) = 2.0; a[0](3) = 0.5; 
    a[1](0) = 0.0; a[1](1) = 1.0; a[1](2) = 0.0; a[1](3) = 20.0; 
    a[2](0) = 0.0; a[2](1) = 0.0; a[2](2) = 1.0; a[2](3) = -0.3; 
    a[3](0) = 1.0; a[3](1) = 2.0; a[3](2) = -0.334; a[3](3) = 50.0; 
    ShMatrix<4, 4, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; b[0](3) = 4.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; b[1](3) = 6.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; b[2](3) = 8.0; 
    b[3](0) = 9.0; b[3](1) = -10.0; b[3](2) = -11.0; b[3](3) = -12.0; 
    ShMatrix<4, 4, SH_TEMP, float> expected;
    expected[0](0) = 17.5; expected[0](1) = 11.0; expected[0](2) = 13.5; expected[0](3) = 16.0; 
    expected[1](0) = 183.0; expected[1](1) = -196.0; expected[1](2) = -215.0; expected[1](3) = -234.0; 
    expected[2](0) = 2.3; expected[2](1) = 9.0; expected[2](2) = 10.3; expected[2](3) = 11.6; 
    expected[3](0) = 455.33; expected[3](1) = -492.004; expected[3](2) = -539.338; expected[3](3) = -586.672; 

    ShMatrix<4, 4, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_4f_4f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShMatrix<3, 3, SH_TEMP, float> a;
    a[0](0) = 0.0; a[0](1) = 1.0; a[0](2) = 2.0; 
    a[1](0) = 0.0; a[1](1) = 1.0; a[1](2) = 0.0; 
    a[2](0) = 0.0; a[2](1) = 0.0; a[2](2) = 1.0; 
    ShMatrix<3, 3, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; 
    ShMatrix<3, 3, SH_TEMP, float> expected;
    expected[0](0) = 13.0; expected[0](1) = 16.0; expected[0](2) = 19.0; 
    expected[1](0) = 3.0; expected[1](1) = 4.0; expected[1](2) = 5.0; 
    expected[2](0) = 5.0; expected[2](1) = 6.0; expected[2](2) = 7.0; 

    ShMatrix<3, 3, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_2f_infix_test4
    last_test = "f_2f_2f_infix_test4";
    ShMatrix<2, 2, SH_TEMP, float> a;
    a[0](0) = 0.0; a[0](1) = 1.0; 
    a[1](0) = 0.0; a[1](1) = 1.0; 
    ShMatrix<2, 2, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; 
    ShMatrix<2, 2, SH_TEMP, float> expected;
    expected[0](0) = 3.0; expected[0](1) = 4.0; 
    expected[1](0) = 3.0; expected[1](1) = 4.0; 

    ShMatrix<2, 2, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_2f_2f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_2f_infix_test5
    last_test = "f_3f_2f_infix_test5";
    ShMatrix<3, 2, SH_TEMP, float> a;
    a[0](0) = 34.0; a[0](1) = 1.0; 
    a[1](0) = 0.5; a[1](1) = -1.9; 
    a[2](0) = 1000.0; a[2](1) = 0.012345; 
    ShMatrix<2, 4, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; b[0](3) = 4.0; 
    b[1](0) = 5.0; b[1](1) = 6.0; b[1](2) = 7.0; b[1](3) = 8.0; 
    ShMatrix<3, 4, SH_TEMP, float> expected;
    expected[0](0) = 39.0; expected[0](1) = 74.0; expected[0](2) = 109.0; expected[0](3) = 144.0; 
    expected[1](0) = -9.0; expected[1](1) = -10.4; expected[1](2) = -11.8; expected[1](3) = -13.2; 
    expected[2](0) = 1000.061725; expected[2](1) = 2000.07407; expected[2](2) = 3000.086415; expected[2](3) = 4000.09876; 

    ShMatrix<3, 4, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_3f_2f_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test6
    last_test = "f_f_3f_infix_test6";
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShMatrix<3, 3, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; 
    ShMatrix<3, 3, SH_TEMP, float> expected;
    expected[0](0) = 0.5; expected[0](1) = 1.0; expected[0](2) = 1.5; 
    expected[1](0) = 1.5; expected[1](1) = 2.0; expected[1](2) = 2.5; 
    expected[2](0) = 2.5; expected[2](1) = 3.0; expected[2](2) = 3.5; 

    ShMatrix<3, 3, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_f_3f_infix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test7
    last_test = "f_3f_f_infix_test7";
    ShMatrix<3, 3, SH_TEMP, float> a;
    a[0](0) = 1.0; a[0](1) = 2.0; a[0](2) = 3.0; 
    a[1](0) = 3.0; a[1](1) = 4.0; a[1](2) = 5.0; 
    a[2](0) = 5.0; a[2](1) = 6.0; a[2](2) = 7.0; 
    ShAttrib<1, SH_CONST, float> b(float(-2.3));
    ShMatrix<3, 3, SH_TEMP, float> expected;
    expected[0](0) = -2.3; expected[0](1) = -4.6; expected[0](2) = -6.9; 
    expected[1](0) = -6.9; expected[1](1) = -9.2; expected[1](2) = -11.5; 
    expected[2](0) = -11.5; expected[2](1) = -13.8; expected[2](2) = -16.1; 

    ShMatrix<3, 3, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_3f_f_infix_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test8
    last_test = "f_3f_3f_infix_test8";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(1.0), float(2.0));
    ShMatrix<3, 3, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; 
    ShAttrib<3, SH_CONST, float> expected(float(13.0), float(16.0), float(19.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_3f_3f_infix_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test9
    last_test = "f_3f_3f_infix_test9";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(1.0), float(2.0));
    ShMatrix<3, 2, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; 
    ShAttrib<2, SH_CONST, float> expected(float(13.0), float(16.0));

    ShAttrib<2, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_3f_3f_infix_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test10
    last_test = "f_3f_3f_infix_test10";
    ShMatrix<3, 3, SH_TEMP, float> a;
    a[0](0) = 1.0; a[0](1) = 2.0; a[0](2) = 3.0; 
    a[1](0) = 3.0; a[1](1) = 4.0; a[1](2) = 5.0; 
    a[2](0) = 5.0; a[2](1) = 6.0; a[2](2) = 7.0; 
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(-0.3), float(10.1));
    ShAttrib<3, SH_CONST, float> expected(float(30.7), float(52.3), float(73.9));

    ShAttrib<3, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_3f_3f_infix_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_3f_infix_test11
    last_test = "f_2f_3f_infix_test11";
    ShMatrix<2, 3, SH_TEMP, float> a;
    a[0](0) = 1.0; a[0](1) = 2.0; a[0](2) = 3.0; 
    a[1](0) = 3.0; a[1](1) = 4.0; a[1](2) = 5.0; 
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(-0.3), float(10.1));
    ShAttrib<2, SH_CONST, float> expected(float(30.7), float(52.3));

    ShAttrib<2, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_2f_3f_infix_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_infix_test12
    last_test = "f_4f_4f_infix_test12";
    ShMatrix<4, 3, SH_TEMP, float> a;
    a[0](0) = 0.0; a[0](1) = 1.0; a[0](2) = 2.0; 
    a[1](0) = 0.0; a[1](1) = 1.0; a[1](2) = 0.0; 
    a[2](0) = 0.0; a[2](1) = 0.0; a[2](2) = 1.0; 
    a[3](0) = 1.0; a[3](1) = 2.0; a[3](2) = -0.334; 
    ShMatrix<4, 4, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; b[0](3) = 4.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; b[1](3) = 6.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; b[2](3) = 8.0; 
    b[3](0) = 9.0; b[3](1) = -10.0; b[3](2) = -11.0; b[3](3) = -12.0; 
    ShMatrix<4, 4, SH_TEMP, float> expected;
    expected[0](0) = 13.0; expected[0](1) = 16.0; expected[0](2) = 19.0; expected[0](3) = 22.0; 
    expected[1](0) = 3.0; expected[1](1) = 4.0; expected[1](2) = 5.0; expected[1](3) = 6.0; 
    expected[2](0) = 5.0; expected[2](1) = 6.0; expected[2](2) = 7.0; expected[2](3) = 8.0; 
    expected[3](0) = 14.33; expected[3](1) = -2.004; expected[3](2) = -0.338; expected[3](3) = 1.328; 

    ShMatrix<4, 4, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_4f_4f_infix_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_2f_infix_test13
    last_test = "f_2f_2f_infix_test13";
    ShMatrix<2, 1, SH_TEMP, float> a;
    a[0](0) = -0.5; 
    a[1](0) = 2.1; 
    ShMatrix<2, 2, SH_TEMP, float> b;
    b[0](0) = -1.0; b[0](1) = 2.3; 
    b[1](0) = 30; b[1](1) = -4; 
    ShMatrix<2, 2, SH_TEMP, float> expected;
    expected[0](0) = 0.5; expected[0](1) = -1.15; 
    expected[1](0) = 27.9; expected[1](1) = 0.83; 

    ShMatrix<2, 2, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_2f_2f_infix_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_2f_infix_test14
    last_test = "f_2f_2f_infix_test14";
    ShMatrix<2, 3, SH_TEMP, float> a;
    a[0](0) = -0.5; a[0](1) = 10.0; a[0](2) = 1.2; 
    a[1](0) = 2.1; a[1](1) = 1.2; a[1](2) = 0.3; 
    ShMatrix<2, 2, SH_TEMP, float> b;
    b[0](0) = -1.0; b[0](1) = 2.3; 
    b[1](0) = 30; b[1](1) = -4; 
    ShMatrix<2, 2, SH_TEMP, float> expected;
    expected[0](0) = 300.5; expected[0](1) = -41.15; 
    expected[1](0) = 33.9; expected[1](1) = 0.03; 

    ShMatrix<2, 2, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_2f_2f_infix_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test0
    last_test = "f_3f_3f_infix_test0";
    ShMatrix<3, 3, SH_TEMP, float> a;
    a[0](0) = 0.0; a[0](1) = 0.0; a[0](2) = 0.0; 
    a[1](0) = 0.0; a[1](1) = 0.0; a[1](2) = 0.0; 
    a[2](0) = 0.0; a[2](1) = 0.0; a[2](2) = 0.0; 
    ShMatrix<3, 3, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; 
    ShMatrix<3, 3, SH_TEMP, float> expected;
    expected[0](0) = 0.0; expected[0](1) = 0.0; expected[0](2) = 0.0; 
    expected[1](0) = 0.0; expected[1](1) = 0.0; expected[1](2) = 0.0; 
    expected[2](0) = 0.0; expected[2](1) = 0.0; expected[2](2) = 0.0; 

    ShMatrix<3, 3, SH_TEMP, float> out;
    out = a *= b;

    try {
      if (test.check("f_3f_3f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test1
    last_test = "f_3f_3f_infix_test1";
    ShMatrix<3, 3, SH_TEMP, float> a;
    a[0](0) = 1.0; a[0](1) = 0.0; a[0](2) = 0.0; 
    a[1](0) = 0.0; a[1](1) = 1.0; a[1](2) = 0.0; 
    a[2](0) = 0.0; a[2](1) = 0.0; a[2](2) = 1.0; 
    ShMatrix<3, 3, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; 
    ShMatrix<3, 3, SH_TEMP, float> expected;
    expected[0](0) = 1.0; expected[0](1) = 2.0; expected[0](2) = 3.0; 
    expected[1](0) = 3.0; expected[1](1) = 4.0; expected[1](2) = 5.0; 
    expected[2](0) = 5.0; expected[2](1) = 6.0; expected[2](2) = 7.0; 

    ShMatrix<3, 3, SH_TEMP, float> out;
    out = a *= b;

    try {
      if (test.check("f_3f_3f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_infix_test2
    last_test = "f_4f_4f_infix_test2";
    ShMatrix<4, 4, SH_TEMP, float> a;
    a[0](0) = 0.0; a[0](1) = 1.0; a[0](2) = 2.0; a[0](3) = 0.5; 
    a[1](0) = 0.0; a[1](1) = 1.0; a[1](2) = 0.0; a[1](3) = 20.0; 
    a[2](0) = 0.0; a[2](1) = 0.0; a[2](2) = 1.0; a[2](3) = -0.3; 
    a[3](0) = 1.0; a[3](1) = 2.0; a[3](2) = -0.334; a[3](3) = 50.0; 
    ShMatrix<4, 4, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; b[0](3) = 4.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; b[1](3) = 6.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; b[2](3) = 8.0; 
    b[3](0) = 9.0; b[3](1) = -10.0; b[3](2) = -11.0; b[3](3) = -12.0; 
    ShMatrix<4, 4, SH_TEMP, float> expected;
    expected[0](0) = 17.5; expected[0](1) = 11.0; expected[0](2) = 13.5; expected[0](3) = 16.0; 
    expected[1](0) = 183.0; expected[1](1) = -196.0; expected[1](2) = -215.0; expected[1](3) = -234.0; 
    expected[2](0) = 2.3; expected[2](1) = 9.0; expected[2](2) = 10.3; expected[2](3) = 11.6; 
    expected[3](0) = 455.33; expected[3](1) = -492.004; expected[3](2) = -539.338; expected[3](3) = -586.672; 

    ShMatrix<4, 4, SH_TEMP, float> out;
    out = a *= b;

    try {
      if (test.check("f_4f_4f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShMatrix<3, 3, SH_TEMP, float> a;
    a[0](0) = 0.0; a[0](1) = 1.0; a[0](2) = 2.0; 
    a[1](0) = 0.0; a[1](1) = 1.0; a[1](2) = 0.0; 
    a[2](0) = 0.0; a[2](1) = 0.0; a[2](2) = 1.0; 
    ShMatrix<3, 3, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; b[0](2) = 3.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; b[1](2) = 5.0; 
    b[2](0) = 5.0; b[2](1) = 6.0; b[2](2) = 7.0; 
    ShMatrix<3, 3, SH_TEMP, float> expected;
    expected[0](0) = 13.0; expected[0](1) = 16.0; expected[0](2) = 19.0; 
    expected[1](0) = 3.0; expected[1](1) = 4.0; expected[1](2) = 5.0; 
    expected[2](0) = 5.0; expected[2](1) = 6.0; expected[2](2) = 7.0; 

    ShMatrix<3, 3, SH_TEMP, float> out;
    out = a *= b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_2f_infix_test4
    last_test = "f_2f_2f_infix_test4";
    ShMatrix<2, 2, SH_TEMP, float> a;
    a[0](0) = 0.0; a[0](1) = 1.0; 
    a[1](0) = 0.0; a[1](1) = 1.0; 
    ShMatrix<2, 2, SH_TEMP, float> b;
    b[0](0) = 1.0; b[0](1) = 2.0; 
    b[1](0) = 3.0; b[1](1) = 4.0; 
    ShMatrix<2, 2, SH_TEMP, float> expected;
    expected[0](0) = 3.0; expected[0](1) = 4.0; 
    expected[1](0) = 3.0; expected[1](1) = 4.0; 

    ShMatrix<2, 2, SH_TEMP, float> out;
    out = a *= b;

    try {
      if (test.check("f_2f_2f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test5
    last_test = "f_3f_f_infix_test5";
    ShMatrix<3, 3, SH_TEMP, float> a;
    a[0](0) = 1.0; a[0](1) = 2.0; a[0](2) = 3.0; 
    a[1](0) = 3.0; a[1](1) = 4.0; a[1](2) = 5.0; 
    a[2](0) = 5.0; a[2](1) = 6.0; a[2](2) = 7.0; 
    ShAttrib<1, SH_CONST, float> b(float(-2.3));
    ShMatrix<3, 3, SH_TEMP, float> expected;
    expected[0](0) = -2.3; expected[0](1) = -4.6; expected[0](2) = -6.9; 
    expected[1](0) = -6.9; expected[1](1) = -9.2; expected[1](2) = -11.5; 
    expected[2](0) = -11.5; expected[2](1) = -13.8; expected[2](2) = -16.1; 

    ShMatrix<3, 3, SH_TEMP, float> out;
    out = a *= b;

    try {
      if (test.check("f_3f_f_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

