#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram max_a_f_3f_3f_callmax_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = max(a, b);
  } SH_END;

  max_a_f_3f_3f_callmax_test0.name("max_a_f_3f_3f_callmax_test0");
  last_test = "max_a_f_3f_3f_callmax_test0";
  {  // f_3f_3f_callmax_test0
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(2.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(5.0));

    try {
      if (test.run(max_a_f_3f_3f_callmax_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max_a_f_4f_4f_callmax_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = max(a, b);
  } SH_END;

  max_a_f_4f_4f_callmax_test1.name("max_a_f_4f_4f_callmax_test1");
  last_test = "max_a_f_4f_4f_callmax_test1";
  {  // f_4f_4f_callmax_test1
    ShAttrib<4, SH_CONST, float> a(float(0.2), float(0.5), float(0.9), float(1.5));
    ShAttrib<4, SH_CONST, float> b(float(0), float(0), float(0), float(0));
    ShAttrib<4, SH_CONST, float> expected(float(0.2), float(0.5), float(0.9), float(1.5));

    try {
      if (test.run(max_a_f_4f_4f_callmax_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max_a_f_4f_4f_callmax_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = max(a, b);
  } SH_END;

  max_a_f_4f_4f_callmax_test2.name("max_a_f_4f_4f_callmax_test2");
  last_test = "max_a_f_4f_4f_callmax_test2";
  {  // f_4f_4f_callmax_test2
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(1.0), float(2.0), float(5.0));
    ShAttrib<4, SH_CONST, float> expected(float(2.0), float(3.0), float(2.0), float(5.0));

    try {
      if (test.run(max_a_f_4f_4f_callmax_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max_a_f_4f_4f_callmax_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = max(a, b);
  } SH_END;

  max_a_f_4f_4f_callmax_test3.name("max_a_f_4f_4f_callmax_test3");
  last_test = "max_a_f_4f_4f_callmax_test3";
  {  // f_4f_4f_callmax_test3
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(0.1), float(0.5), float(2.9), float(2.3));
    ShAttrib<4, SH_CONST, float> expected(float(2.0), float(3.0), float(2.9), float(3.0));

    try {
      if (test.run(max_a_f_4f_4f_callmax_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max_a_f_4f_4f_callmax_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = max(a, b);
  } SH_END;

  max_a_f_4f_4f_callmax_test4.name("max_a_f_4f_4f_callmax_test4");
  last_test = "max_a_f_4f_4f_callmax_test4";
  {  // f_4f_4f_callmax_test4
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.5), float(-1.0), float(-2.0), float(-4.0));
    ShAttrib<4, SH_CONST, float> expected(float(2.0), float(3.0), float(2.0), float(3.0));

    try {
      if (test.run(max_a_f_4f_4f_callmax_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max_a_f_4f_4f_callmax_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = max(a, b);
  } SH_END;

  max_a_f_4f_4f_callmax_test5.name("max_a_f_4f_4f_callmax_test5");
  last_test = "max_a_f_4f_4f_callmax_test5";
  {  // f_4f_4f_callmax_test5
    ShAttrib<4, SH_CONST, float> a(float(-2.0), float(-3.0), float(-2.0), float(-3.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.5), float(-1.0), float(-2.0), float(-4.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.5), float(-1.0), float(-2.0), float(-3.0));

    try {
      if (test.run(max_a_f_4f_4f_callmax_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max_a_i_3i_3i_callmax_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = max(a, b);
  } SH_END;

  max_a_i_3i_3i_callmax_test6.name("max_a_i_3i_3i_callmax_test6");
  last_test = "max_a_i_3i_3i_callmax_test6";
  {  // i_3i_3i_callmax_test6
    ShAttrib<3, SH_CONST, int> a(int(0.0), int(0.0), int(0.0));
    ShAttrib<3, SH_CONST, int> b(int(1.0), int(2.0), int(5.0));
    ShAttrib<3, SH_CONST, int> expected(int(1.0), int(2.0), int(5.0));

    try {
      if (test.run(max_a_i_3i_3i_callmax_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max_a_i_4i_4i_callmax_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = max(a, b);
  } SH_END;

  max_a_i_4i_4i_callmax_test7.name("max_a_i_4i_4i_callmax_test7");
  last_test = "max_a_i_4i_4i_callmax_test7";
  {  // i_4i_4i_callmax_test7
    ShAttrib<4, SH_CONST, int> a(int(0.2), int(0.5), int(0.9), int(1.5));
    ShAttrib<4, SH_CONST, int> b(int(0), int(0), int(0), int(0));
    ShAttrib<4, SH_CONST, int> expected(int(0.2), int(0.5), int(0.9), int(1.5));

    try {
      if (test.run(max_a_i_4i_4i_callmax_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max_a_i_4i_4i_callmax_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = max(a, b);
  } SH_END;

  max_a_i_4i_4i_callmax_test8.name("max_a_i_4i_4i_callmax_test8");
  last_test = "max_a_i_4i_4i_callmax_test8";
  {  // i_4i_4i_callmax_test8
    ShAttrib<4, SH_CONST, int> a(int(2.0), int(3.0), int(2.0), int(3.0));
    ShAttrib<4, SH_CONST, int> b(int(0.0), int(1.0), int(2.0), int(5.0));
    ShAttrib<4, SH_CONST, int> expected(int(2.0), int(3.0), int(2.0), int(5.0));

    try {
      if (test.run(max_a_i_4i_4i_callmax_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max_a_i_4i_4i_callmax_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = max(a, b);
  } SH_END;

  max_a_i_4i_4i_callmax_test9.name("max_a_i_4i_4i_callmax_test9");
  last_test = "max_a_i_4i_4i_callmax_test9";
  {  // i_4i_4i_callmax_test9
    ShAttrib<4, SH_CONST, int> a(int(2.0), int(3.0), int(2.0), int(3.0));
    ShAttrib<4, SH_CONST, int> b(int(0.1), int(0.5), int(2.9), int(2.3));
    ShAttrib<4, SH_CONST, int> expected(int(2.0), int(3.0), int(2.9), int(3.0));

    try {
      if (test.run(max_a_i_4i_4i_callmax_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max_a_i_4i_4i_callmax_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = max(a, b);
  } SH_END;

  max_a_i_4i_4i_callmax_test10.name("max_a_i_4i_4i_callmax_test10");
  last_test = "max_a_i_4i_4i_callmax_test10";
  {  // i_4i_4i_callmax_test10
    ShAttrib<4, SH_CONST, int> a(int(2.0), int(3.0), int(2.0), int(3.0));
    ShAttrib<4, SH_CONST, int> b(int(-0.5), int(-1.0), int(-2.0), int(-4.0));
    ShAttrib<4, SH_CONST, int> expected(int(2.0), int(3.0), int(2.0), int(3.0));

    try {
      if (test.run(max_a_i_4i_4i_callmax_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max_a_i_4i_4i_callmax_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = max(a, b);
  } SH_END;

  max_a_i_4i_4i_callmax_test11.name("max_a_i_4i_4i_callmax_test11");
  last_test = "max_a_i_4i_4i_callmax_test11";
  {  // i_4i_4i_callmax_test11
    ShAttrib<4, SH_CONST, int> a(int(-2.0), int(-3.0), int(-2.0), int(-3.0));
    ShAttrib<4, SH_CONST, int> b(int(-0.5), int(-1.0), int(-2.0), int(-4.0));
    ShAttrib<4, SH_CONST, int> expected(int(-0.5), int(-1.0), int(-2.0), int(-3.0));

    try {
      if (test.run(max_a_i_4i_4i_callmax_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max1_a_f_4f_callmax_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = max(a);
  } SH_END;

  max1_a_f_4f_callmax_test0.name("max1_a_f_4f_callmax_test0");
  last_test = "max1_a_f_4f_callmax_test0";
  {  // f_4f_callmax_test0
    ShAttrib<4, SH_CONST, float> a(float(0), float(0.1), float(0.5), float(1.9));
    ShAttrib<1, SH_CONST, float> expected(float(1.9));

    try {
      if (test.run(max1_a_f_4f_callmax_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max1_a_f_4f_callmax_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = max(a);
  } SH_END;

  max1_a_f_4f_callmax_test1.name("max1_a_f_4f_callmax_test1");
  last_test = "max1_a_f_4f_callmax_test1";
  {  // f_4f_callmax_test1
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0), float(1.9), float(1.5));
    ShAttrib<1, SH_CONST, float> expected(float(1.9));

    try {
      if (test.run(max1_a_f_4f_callmax_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max1_a_f_4f_callmax_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = max(a);
  } SH_END;

  max1_a_f_4f_callmax_test2.name("max1_a_f_4f_callmax_test2");
  last_test = "max1_a_f_4f_callmax_test2";
  {  // f_4f_callmax_test2
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<1, SH_CONST, float> expected(float(4.0));

    try {
      if (test.run(max1_a_f_4f_callmax_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max1_a_f_4f_callmax_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = max(a);
  } SH_END;

  max1_a_f_4f_callmax_test3.name("max1_a_f_4f_callmax_test3");
  last_test = "max1_a_f_4f_callmax_test3";
  {  // f_4f_callmax_test3
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(1.0), float(4.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(4.0));

    try {
      if (test.run(max1_a_f_4f_callmax_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max1_a_f_4f_callmax_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = max(a);
  } SH_END;

  max1_a_f_4f_callmax_test4.name("max1_a_f_4f_callmax_test4");
  last_test = "max1_a_f_4f_callmax_test4";
  {  // f_4f_callmax_test4
    ShAttrib<4, SH_CONST, float> a(float(-1.0), float(-2.1), float(-3.5), float(-4.4));
    ShAttrib<1, SH_CONST, float> expected(float(-1.0));

    try {
      if (test.run(max1_a_f_4f_callmax_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max1_a_i_4i_callmax_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = max(a);
  } SH_END;

  max1_a_i_4i_callmax_test5.name("max1_a_i_4i_callmax_test5");
  last_test = "max1_a_i_4i_callmax_test5";
  {  // i_4i_callmax_test5
    ShAttrib<4, SH_CONST, int> a(int(0), int(0.1), int(0.5), int(1.9));
    ShAttrib<1, SH_CONST, int> expected(int(1.9));

    try {
      if (test.run(max1_a_i_4i_callmax_test5, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max1_a_i_4i_callmax_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = max(a);
  } SH_END;

  max1_a_i_4i_callmax_test6.name("max1_a_i_4i_callmax_test6");
  last_test = "max1_a_i_4i_callmax_test6";
  {  // i_4i_callmax_test6
    ShAttrib<4, SH_CONST, int> a(int(0.1), int(0), int(1.9), int(1.5));
    ShAttrib<1, SH_CONST, int> expected(int(1.9));

    try {
      if (test.run(max1_a_i_4i_callmax_test6, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max1_a_i_4i_callmax_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = max(a);
  } SH_END;

  max1_a_i_4i_callmax_test7.name("max1_a_i_4i_callmax_test7");
  last_test = "max1_a_i_4i_callmax_test7";
  {  // i_4i_callmax_test7
    ShAttrib<4, SH_CONST, int> a(int(1.0), int(2.0), int(3.0), int(4.0));
    ShAttrib<1, SH_CONST, int> expected(int(4.0));

    try {
      if (test.run(max1_a_i_4i_callmax_test7, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max1_a_i_4i_callmax_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = max(a);
  } SH_END;

  max1_a_i_4i_callmax_test8.name("max1_a_i_4i_callmax_test8");
  last_test = "max1_a_i_4i_callmax_test8";
  {  // i_4i_callmax_test8
    ShAttrib<4, SH_CONST, int> a(int(2.0), int(1.0), int(4.0), int(3.0));
    ShAttrib<1, SH_CONST, int> expected(int(4.0));

    try {
      if (test.run(max1_a_i_4i_callmax_test8, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram max1_a_i_4i_callmax_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = max(a);
  } SH_END;

  max1_a_i_4i_callmax_test9.name("max1_a_i_4i_callmax_test9");
  last_test = "max1_a_i_4i_callmax_test9";
  {  // i_4i_callmax_test9
    ShAttrib<4, SH_CONST, int> a(int(-1.0), int(-2.1), int(-3.5), int(-4.4));
    ShAttrib<1, SH_CONST, int> expected(int(-1.0));

    try {
      if (test.run(max1_a_i_4i_callmax_test9, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_3f_3f_callmax_test0
    last_test = "f_3f_3f_callmax_test0";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(2.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(5.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = max(a, b);

    try {
      if (test.check("f_3f_3f_callmax_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callmax_test1
    last_test = "f_4f_4f_callmax_test1";
    ShAttrib<4, SH_CONST, float> a(float(0.2), float(0.5), float(0.9), float(1.5));
    ShAttrib<4, SH_CONST, float> b(float(0), float(0), float(0), float(0));
    ShAttrib<4, SH_CONST, float> expected(float(0.2), float(0.5), float(0.9), float(1.5));

    ShAttrib<4, SH_TEMP, float> out;
    out = max(a, b);

    try {
      if (test.check("f_4f_4f_callmax_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callmax_test2
    last_test = "f_4f_4f_callmax_test2";
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(1.0), float(2.0), float(5.0));
    ShAttrib<4, SH_CONST, float> expected(float(2.0), float(3.0), float(2.0), float(5.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = max(a, b);

    try {
      if (test.check("f_4f_4f_callmax_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callmax_test3
    last_test = "f_4f_4f_callmax_test3";
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(0.1), float(0.5), float(2.9), float(2.3));
    ShAttrib<4, SH_CONST, float> expected(float(2.0), float(3.0), float(2.9), float(3.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = max(a, b);

    try {
      if (test.check("f_4f_4f_callmax_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callmax_test4
    last_test = "f_4f_4f_callmax_test4";
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.5), float(-1.0), float(-2.0), float(-4.0));
    ShAttrib<4, SH_CONST, float> expected(float(2.0), float(3.0), float(2.0), float(3.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = max(a, b);

    try {
      if (test.check("f_4f_4f_callmax_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callmax_test5
    last_test = "f_4f_4f_callmax_test5";
    ShAttrib<4, SH_CONST, float> a(float(-2.0), float(-3.0), float(-2.0), float(-3.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.5), float(-1.0), float(-2.0), float(-4.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.5), float(-1.0), float(-2.0), float(-3.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = max(a, b);

    try {
      if (test.check("f_4f_4f_callmax_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_callmax_test6
    last_test = "i_3i_3i_callmax_test6";
    ShAttrib<3, SH_CONST, int> a(int(0.0), int(0.0), int(0.0));
    ShAttrib<3, SH_CONST, int> b(int(1.0), int(2.0), int(5.0));
    ShAttrib<3, SH_CONST, int> expected(int(1.0), int(2.0), int(5.0));

    ShAttrib<3, SH_TEMP, int> out;
    out = max(a, b);

    try {
      if (test.check("i_3i_3i_callmax_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_callmax_test7
    last_test = "i_4i_4i_callmax_test7";
    ShAttrib<4, SH_CONST, int> a(int(0.2), int(0.5), int(0.9), int(1.5));
    ShAttrib<4, SH_CONST, int> b(int(0), int(0), int(0), int(0));
    ShAttrib<4, SH_CONST, int> expected(int(0.2), int(0.5), int(0.9), int(1.5));

    ShAttrib<4, SH_TEMP, int> out;
    out = max(a, b);

    try {
      if (test.check("i_4i_4i_callmax_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_callmax_test8
    last_test = "i_4i_4i_callmax_test8";
    ShAttrib<4, SH_CONST, int> a(int(2.0), int(3.0), int(2.0), int(3.0));
    ShAttrib<4, SH_CONST, int> b(int(0.0), int(1.0), int(2.0), int(5.0));
    ShAttrib<4, SH_CONST, int> expected(int(2.0), int(3.0), int(2.0), int(5.0));

    ShAttrib<4, SH_TEMP, int> out;
    out = max(a, b);

    try {
      if (test.check("i_4i_4i_callmax_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_callmax_test9
    last_test = "i_4i_4i_callmax_test9";
    ShAttrib<4, SH_CONST, int> a(int(2.0), int(3.0), int(2.0), int(3.0));
    ShAttrib<4, SH_CONST, int> b(int(0.1), int(0.5), int(2.9), int(2.3));
    ShAttrib<4, SH_CONST, int> expected(int(2.0), int(3.0), int(2.9), int(3.0));

    ShAttrib<4, SH_TEMP, int> out;
    out = max(a, b);

    try {
      if (test.check("i_4i_4i_callmax_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_callmax_test10
    last_test = "i_4i_4i_callmax_test10";
    ShAttrib<4, SH_CONST, int> a(int(2.0), int(3.0), int(2.0), int(3.0));
    ShAttrib<4, SH_CONST, int> b(int(-0.5), int(-1.0), int(-2.0), int(-4.0));
    ShAttrib<4, SH_CONST, int> expected(int(2.0), int(3.0), int(2.0), int(3.0));

    ShAttrib<4, SH_TEMP, int> out;
    out = max(a, b);

    try {
      if (test.check("i_4i_4i_callmax_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_callmax_test11
    last_test = "i_4i_4i_callmax_test11";
    ShAttrib<4, SH_CONST, int> a(int(-2.0), int(-3.0), int(-2.0), int(-3.0));
    ShAttrib<4, SH_CONST, int> b(int(-0.5), int(-1.0), int(-2.0), int(-4.0));
    ShAttrib<4, SH_CONST, int> expected(int(-0.5), int(-1.0), int(-2.0), int(-3.0));

    ShAttrib<4, SH_TEMP, int> out;
    out = max(a, b);

    try {
      if (test.check("i_4i_4i_callmax_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callmax_test0
    last_test = "f_4f_callmax_test0";
    ShAttrib<4, SH_CONST, float> a(float(0), float(0.1), float(0.5), float(1.9));
    ShAttrib<1, SH_CONST, float> expected(float(1.9));

    ShAttrib<1, SH_TEMP, float> out;
    out = max(a);

    try {
      if (test.check("f_4f_callmax_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callmax_test1
    last_test = "f_4f_callmax_test1";
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0), float(1.9), float(1.5));
    ShAttrib<1, SH_CONST, float> expected(float(1.9));

    ShAttrib<1, SH_TEMP, float> out;
    out = max(a);

    try {
      if (test.check("f_4f_callmax_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callmax_test2
    last_test = "f_4f_callmax_test2";
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<1, SH_CONST, float> expected(float(4.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = max(a);

    try {
      if (test.check("f_4f_callmax_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callmax_test3
    last_test = "f_4f_callmax_test3";
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(1.0), float(4.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(4.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = max(a);

    try {
      if (test.check("f_4f_callmax_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callmax_test4
    last_test = "f_4f_callmax_test4";
    ShAttrib<4, SH_CONST, float> a(float(-1.0), float(-2.1), float(-3.5), float(-4.4));
    ShAttrib<1, SH_CONST, float> expected(float(-1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = max(a);

    try {
      if (test.check("f_4f_callmax_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_callmax_test5
    last_test = "i_4i_callmax_test5";
    ShAttrib<4, SH_CONST, int> a(int(0), int(0.1), int(0.5), int(1.9));
    ShAttrib<1, SH_CONST, int> expected(int(1.9));

    ShAttrib<1, SH_TEMP, int> out;
    out = max(a);

    try {
      if (test.check("i_4i_callmax_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_callmax_test6
    last_test = "i_4i_callmax_test6";
    ShAttrib<4, SH_CONST, int> a(int(0.1), int(0), int(1.9), int(1.5));
    ShAttrib<1, SH_CONST, int> expected(int(1.9));

    ShAttrib<1, SH_TEMP, int> out;
    out = max(a);

    try {
      if (test.check("i_4i_callmax_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_callmax_test7
    last_test = "i_4i_callmax_test7";
    ShAttrib<4, SH_CONST, int> a(int(1.0), int(2.0), int(3.0), int(4.0));
    ShAttrib<1, SH_CONST, int> expected(int(4.0));

    ShAttrib<1, SH_TEMP, int> out;
    out = max(a);

    try {
      if (test.check("i_4i_callmax_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_callmax_test8
    last_test = "i_4i_callmax_test8";
    ShAttrib<4, SH_CONST, int> a(int(2.0), int(1.0), int(4.0), int(3.0));
    ShAttrib<1, SH_CONST, int> expected(int(4.0));

    ShAttrib<1, SH_TEMP, int> out;
    out = max(a);

    try {
      if (test.check("i_4i_callmax_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_callmax_test9
    last_test = "i_4i_callmax_test9";
    ShAttrib<4, SH_CONST, int> a(int(-1.0), int(-2.1), int(-3.5), int(-4.4));
    ShAttrib<1, SH_CONST, int> expected(int(-1.0));

    ShAttrib<1, SH_TEMP, int> out;
    out = max(a);

    try {
      if (test.check("i_4i_callmax_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  ShProgram min_a_f_3f_3f_callmin_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = min(a, b);
  } SH_END;

  min_a_f_3f_3f_callmin_test0.name("min_a_f_3f_3f_callmin_test0");
  last_test = "min_a_f_3f_3f_callmin_test0";
  {  // f_3f_3f_callmin_test0
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(2.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    try {
      if (test.run(min_a_f_3f_3f_callmin_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min_a_f_4f_4f_callmin_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = min(a, b);
  } SH_END;

  min_a_f_4f_4f_callmin_test1.name("min_a_f_4f_4f_callmin_test1");
  last_test = "min_a_f_4f_4f_callmin_test1";
  {  // f_4f_4f_callmin_test1
    ShAttrib<4, SH_CONST, float> a(float(0.2), float(0.5), float(0.9), float(1.5));
    ShAttrib<4, SH_CONST, float> b(float(0), float(0), float(0), float(0));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(0), float(0), float(0));

    try {
      if (test.run(min_a_f_4f_4f_callmin_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min_a_f_4f_4f_callmin_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = min(a, b);
  } SH_END;

  min_a_f_4f_4f_callmin_test2.name("min_a_f_4f_4f_callmin_test2");
  last_test = "min_a_f_4f_4f_callmin_test2";
  {  // f_4f_4f_callmin_test2
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(1.0), float(2.0), float(5.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(1.0), float(2.0), float(3.0));

    try {
      if (test.run(min_a_f_4f_4f_callmin_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min_a_f_4f_4f_callmin_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = min(a, b);
  } SH_END;

  min_a_f_4f_4f_callmin_test3.name("min_a_f_4f_4f_callmin_test3");
  last_test = "min_a_f_4f_4f_callmin_test3";
  {  // f_4f_4f_callmin_test3
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(0.1), float(0.5), float(2.9), float(2.3));
    ShAttrib<4, SH_CONST, float> expected(float(0.1), float(0.5), float(2.0), float(2.3));

    try {
      if (test.run(min_a_f_4f_4f_callmin_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min_a_f_4f_4f_callmin_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = min(a, b);
  } SH_END;

  min_a_f_4f_4f_callmin_test4.name("min_a_f_4f_4f_callmin_test4");
  last_test = "min_a_f_4f_4f_callmin_test4";
  {  // f_4f_4f_callmin_test4
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.5), float(-1.0), float(-2.0), float(-4.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.5), float(-1.0), float(-2.0), float(-4.0));

    try {
      if (test.run(min_a_f_4f_4f_callmin_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min_a_f_4f_4f_callmin_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = min(a, b);
  } SH_END;

  min_a_f_4f_4f_callmin_test5.name("min_a_f_4f_4f_callmin_test5");
  last_test = "min_a_f_4f_4f_callmin_test5";
  {  // f_4f_4f_callmin_test5
    ShAttrib<4, SH_CONST, float> a(float(-2.0), float(-3.0), float(-2.0), float(-3.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.5), float(-1.0), float(-2.0), float(-4.0));
    ShAttrib<4, SH_CONST, float> expected(float(-2.0), float(-3.0), float(-2.0), float(-4.0));

    try {
      if (test.run(min_a_f_4f_4f_callmin_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min_a_i_3i_3i_callmin_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = min(a, b);
  } SH_END;

  min_a_i_3i_3i_callmin_test6.name("min_a_i_3i_3i_callmin_test6");
  last_test = "min_a_i_3i_3i_callmin_test6";
  {  // i_3i_3i_callmin_test6
    ShAttrib<3, SH_CONST, int> a(int(0.0), int(0.0), int(0.0));
    ShAttrib<3, SH_CONST, int> b(int(1.0), int(2.0), int(5.0));
    ShAttrib<3, SH_CONST, int> expected(int(0.0), int(0.0), int(0.0));

    try {
      if (test.run(min_a_i_3i_3i_callmin_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min_a_i_4i_4i_callmin_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = min(a, b);
  } SH_END;

  min_a_i_4i_4i_callmin_test7.name("min_a_i_4i_4i_callmin_test7");
  last_test = "min_a_i_4i_4i_callmin_test7";
  {  // i_4i_4i_callmin_test7
    ShAttrib<4, SH_CONST, int> a(int(0.2), int(0.5), int(0.9), int(1.5));
    ShAttrib<4, SH_CONST, int> b(int(0), int(0), int(0), int(0));
    ShAttrib<4, SH_CONST, int> expected(int(0), int(0), int(0), int(0));

    try {
      if (test.run(min_a_i_4i_4i_callmin_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min_a_i_4i_4i_callmin_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = min(a, b);
  } SH_END;

  min_a_i_4i_4i_callmin_test8.name("min_a_i_4i_4i_callmin_test8");
  last_test = "min_a_i_4i_4i_callmin_test8";
  {  // i_4i_4i_callmin_test8
    ShAttrib<4, SH_CONST, int> a(int(2.0), int(3.0), int(2.0), int(3.0));
    ShAttrib<4, SH_CONST, int> b(int(0.0), int(1.0), int(2.0), int(5.0));
    ShAttrib<4, SH_CONST, int> expected(int(0.0), int(1.0), int(2.0), int(3.0));

    try {
      if (test.run(min_a_i_4i_4i_callmin_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min_a_i_4i_4i_callmin_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = min(a, b);
  } SH_END;

  min_a_i_4i_4i_callmin_test9.name("min_a_i_4i_4i_callmin_test9");
  last_test = "min_a_i_4i_4i_callmin_test9";
  {  // i_4i_4i_callmin_test9
    ShAttrib<4, SH_CONST, int> a(int(2.0), int(3.0), int(2.0), int(3.0));
    ShAttrib<4, SH_CONST, int> b(int(0.1), int(0.5), int(2.9), int(2.3));
    ShAttrib<4, SH_CONST, int> expected(int(0.1), int(0.5), int(2.0), int(2.3));

    try {
      if (test.run(min_a_i_4i_4i_callmin_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min_a_i_4i_4i_callmin_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = min(a, b);
  } SH_END;

  min_a_i_4i_4i_callmin_test10.name("min_a_i_4i_4i_callmin_test10");
  last_test = "min_a_i_4i_4i_callmin_test10";
  {  // i_4i_4i_callmin_test10
    ShAttrib<4, SH_CONST, int> a(int(2.0), int(3.0), int(2.0), int(3.0));
    ShAttrib<4, SH_CONST, int> b(int(-0.5), int(-1.0), int(-2.0), int(-4.0));
    ShAttrib<4, SH_CONST, int> expected(int(-0.5), int(-1.0), int(-2.0), int(-4.0));

    try {
      if (test.run(min_a_i_4i_4i_callmin_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min_a_i_4i_4i_callmin_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = min(a, b);
  } SH_END;

  min_a_i_4i_4i_callmin_test11.name("min_a_i_4i_4i_callmin_test11");
  last_test = "min_a_i_4i_4i_callmin_test11";
  {  // i_4i_4i_callmin_test11
    ShAttrib<4, SH_CONST, int> a(int(-2.0), int(-3.0), int(-2.0), int(-3.0));
    ShAttrib<4, SH_CONST, int> b(int(-0.5), int(-1.0), int(-2.0), int(-4.0));
    ShAttrib<4, SH_CONST, int> expected(int(-2.0), int(-3.0), int(-2.0), int(-4.0));

    try {
      if (test.run(min_a_i_4i_4i_callmin_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min1_a_f_4f_callmin_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = min(a);
  } SH_END;

  min1_a_f_4f_callmin_test0.name("min1_a_f_4f_callmin_test0");
  last_test = "min1_a_f_4f_callmin_test0";
  {  // f_4f_callmin_test0
    ShAttrib<4, SH_CONST, float> a(float(0), float(0.1), float(0.5), float(1.9));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(min1_a_f_4f_callmin_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min1_a_f_4f_callmin_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = min(a);
  } SH_END;

  min1_a_f_4f_callmin_test1.name("min1_a_f_4f_callmin_test1");
  last_test = "min1_a_f_4f_callmin_test1";
  {  // f_4f_callmin_test1
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0), float(1.9), float(1.5));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(min1_a_f_4f_callmin_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min1_a_f_4f_callmin_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = min(a);
  } SH_END;

  min1_a_f_4f_callmin_test2.name("min1_a_f_4f_callmin_test2");
  last_test = "min1_a_f_4f_callmin_test2";
  {  // f_4f_callmin_test2
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    try {
      if (test.run(min1_a_f_4f_callmin_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min1_a_f_4f_callmin_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = min(a);
  } SH_END;

  min1_a_f_4f_callmin_test3.name("min1_a_f_4f_callmin_test3");
  last_test = "min1_a_f_4f_callmin_test3";
  {  // f_4f_callmin_test3
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(1.0), float(4.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    try {
      if (test.run(min1_a_f_4f_callmin_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min1_a_f_4f_callmin_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = min(a);
  } SH_END;

  min1_a_f_4f_callmin_test4.name("min1_a_f_4f_callmin_test4");
  last_test = "min1_a_f_4f_callmin_test4";
  {  // f_4f_callmin_test4
    ShAttrib<4, SH_CONST, float> a(float(-1.0), float(-2.1), float(-3.5), float(-4.4));
    ShAttrib<1, SH_CONST, float> expected(float(-4.4));

    try {
      if (test.run(min1_a_f_4f_callmin_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min1_a_i_4i_callmin_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = min(a);
  } SH_END;

  min1_a_i_4i_callmin_test5.name("min1_a_i_4i_callmin_test5");
  last_test = "min1_a_i_4i_callmin_test5";
  {  // i_4i_callmin_test5
    ShAttrib<4, SH_CONST, int> a(int(0), int(0.1), int(0.5), int(1.9));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    try {
      if (test.run(min1_a_i_4i_callmin_test5, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min1_a_i_4i_callmin_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = min(a);
  } SH_END;

  min1_a_i_4i_callmin_test6.name("min1_a_i_4i_callmin_test6");
  last_test = "min1_a_i_4i_callmin_test6";
  {  // i_4i_callmin_test6
    ShAttrib<4, SH_CONST, int> a(int(0.1), int(0), int(1.9), int(1.5));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    try {
      if (test.run(min1_a_i_4i_callmin_test6, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min1_a_i_4i_callmin_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = min(a);
  } SH_END;

  min1_a_i_4i_callmin_test7.name("min1_a_i_4i_callmin_test7");
  last_test = "min1_a_i_4i_callmin_test7";
  {  // i_4i_callmin_test7
    ShAttrib<4, SH_CONST, int> a(int(1.0), int(2.0), int(3.0), int(4.0));
    ShAttrib<1, SH_CONST, int> expected(int(1.0));

    try {
      if (test.run(min1_a_i_4i_callmin_test7, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min1_a_i_4i_callmin_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = min(a);
  } SH_END;

  min1_a_i_4i_callmin_test8.name("min1_a_i_4i_callmin_test8");
  last_test = "min1_a_i_4i_callmin_test8";
  {  // i_4i_callmin_test8
    ShAttrib<4, SH_CONST, int> a(int(2.0), int(1.0), int(4.0), int(3.0));
    ShAttrib<1, SH_CONST, int> expected(int(1.0));

    try {
      if (test.run(min1_a_i_4i_callmin_test8, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram min1_a_i_4i_callmin_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = min(a);
  } SH_END;

  min1_a_i_4i_callmin_test9.name("min1_a_i_4i_callmin_test9");
  last_test = "min1_a_i_4i_callmin_test9";
  {  // i_4i_callmin_test9
    ShAttrib<4, SH_CONST, int> a(int(-1.0), int(-2.1), int(-3.5), int(-4.4));
    ShAttrib<1, SH_CONST, int> expected(int(-4.4));

    try {
      if (test.run(min1_a_i_4i_callmin_test9, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_3f_3f_callmin_test0
    last_test = "f_3f_3f_callmin_test0";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(2.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = min(a, b);

    try {
      if (test.check("f_3f_3f_callmin_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callmin_test1
    last_test = "f_4f_4f_callmin_test1";
    ShAttrib<4, SH_CONST, float> a(float(0.2), float(0.5), float(0.9), float(1.5));
    ShAttrib<4, SH_CONST, float> b(float(0), float(0), float(0), float(0));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(0), float(0), float(0));

    ShAttrib<4, SH_TEMP, float> out;
    out = min(a, b);

    try {
      if (test.check("f_4f_4f_callmin_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callmin_test2
    last_test = "f_4f_4f_callmin_test2";
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(1.0), float(2.0), float(5.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(1.0), float(2.0), float(3.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = min(a, b);

    try {
      if (test.check("f_4f_4f_callmin_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callmin_test3
    last_test = "f_4f_4f_callmin_test3";
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(0.1), float(0.5), float(2.9), float(2.3));
    ShAttrib<4, SH_CONST, float> expected(float(0.1), float(0.5), float(2.0), float(2.3));

    ShAttrib<4, SH_TEMP, float> out;
    out = min(a, b);

    try {
      if (test.check("f_4f_4f_callmin_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callmin_test4
    last_test = "f_4f_4f_callmin_test4";
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.5), float(-1.0), float(-2.0), float(-4.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.5), float(-1.0), float(-2.0), float(-4.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = min(a, b);

    try {
      if (test.check("f_4f_4f_callmin_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callmin_test5
    last_test = "f_4f_4f_callmin_test5";
    ShAttrib<4, SH_CONST, float> a(float(-2.0), float(-3.0), float(-2.0), float(-3.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.5), float(-1.0), float(-2.0), float(-4.0));
    ShAttrib<4, SH_CONST, float> expected(float(-2.0), float(-3.0), float(-2.0), float(-4.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = min(a, b);

    try {
      if (test.check("f_4f_4f_callmin_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_callmin_test6
    last_test = "i_3i_3i_callmin_test6";
    ShAttrib<3, SH_CONST, int> a(int(0.0), int(0.0), int(0.0));
    ShAttrib<3, SH_CONST, int> b(int(1.0), int(2.0), int(5.0));
    ShAttrib<3, SH_CONST, int> expected(int(0.0), int(0.0), int(0.0));

    ShAttrib<3, SH_TEMP, int> out;
    out = min(a, b);

    try {
      if (test.check("i_3i_3i_callmin_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_callmin_test7
    last_test = "i_4i_4i_callmin_test7";
    ShAttrib<4, SH_CONST, int> a(int(0.2), int(0.5), int(0.9), int(1.5));
    ShAttrib<4, SH_CONST, int> b(int(0), int(0), int(0), int(0));
    ShAttrib<4, SH_CONST, int> expected(int(0), int(0), int(0), int(0));

    ShAttrib<4, SH_TEMP, int> out;
    out = min(a, b);

    try {
      if (test.check("i_4i_4i_callmin_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_callmin_test8
    last_test = "i_4i_4i_callmin_test8";
    ShAttrib<4, SH_CONST, int> a(int(2.0), int(3.0), int(2.0), int(3.0));
    ShAttrib<4, SH_CONST, int> b(int(0.0), int(1.0), int(2.0), int(5.0));
    ShAttrib<4, SH_CONST, int> expected(int(0.0), int(1.0), int(2.0), int(3.0));

    ShAttrib<4, SH_TEMP, int> out;
    out = min(a, b);

    try {
      if (test.check("i_4i_4i_callmin_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_callmin_test9
    last_test = "i_4i_4i_callmin_test9";
    ShAttrib<4, SH_CONST, int> a(int(2.0), int(3.0), int(2.0), int(3.0));
    ShAttrib<4, SH_CONST, int> b(int(0.1), int(0.5), int(2.9), int(2.3));
    ShAttrib<4, SH_CONST, int> expected(int(0.1), int(0.5), int(2.0), int(2.3));

    ShAttrib<4, SH_TEMP, int> out;
    out = min(a, b);

    try {
      if (test.check("i_4i_4i_callmin_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_callmin_test10
    last_test = "i_4i_4i_callmin_test10";
    ShAttrib<4, SH_CONST, int> a(int(2.0), int(3.0), int(2.0), int(3.0));
    ShAttrib<4, SH_CONST, int> b(int(-0.5), int(-1.0), int(-2.0), int(-4.0));
    ShAttrib<4, SH_CONST, int> expected(int(-0.5), int(-1.0), int(-2.0), int(-4.0));

    ShAttrib<4, SH_TEMP, int> out;
    out = min(a, b);

    try {
      if (test.check("i_4i_4i_callmin_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_callmin_test11
    last_test = "i_4i_4i_callmin_test11";
    ShAttrib<4, SH_CONST, int> a(int(-2.0), int(-3.0), int(-2.0), int(-3.0));
    ShAttrib<4, SH_CONST, int> b(int(-0.5), int(-1.0), int(-2.0), int(-4.0));
    ShAttrib<4, SH_CONST, int> expected(int(-2.0), int(-3.0), int(-2.0), int(-4.0));

    ShAttrib<4, SH_TEMP, int> out;
    out = min(a, b);

    try {
      if (test.check("i_4i_4i_callmin_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callmin_test0
    last_test = "f_4f_callmin_test0";
    ShAttrib<4, SH_CONST, float> a(float(0), float(0.1), float(0.5), float(1.9));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = min(a);

    try {
      if (test.check("f_4f_callmin_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callmin_test1
    last_test = "f_4f_callmin_test1";
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0), float(1.9), float(1.5));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = min(a);

    try {
      if (test.check("f_4f_callmin_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callmin_test2
    last_test = "f_4f_callmin_test2";
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = min(a);

    try {
      if (test.check("f_4f_callmin_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callmin_test3
    last_test = "f_4f_callmin_test3";
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(1.0), float(4.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = min(a);

    try {
      if (test.check("f_4f_callmin_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callmin_test4
    last_test = "f_4f_callmin_test4";
    ShAttrib<4, SH_CONST, float> a(float(-1.0), float(-2.1), float(-3.5), float(-4.4));
    ShAttrib<1, SH_CONST, float> expected(float(-4.4));

    ShAttrib<1, SH_TEMP, float> out;
    out = min(a);

    try {
      if (test.check("f_4f_callmin_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_callmin_test5
    last_test = "i_4i_callmin_test5";
    ShAttrib<4, SH_CONST, int> a(int(0), int(0.1), int(0.5), int(1.9));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    ShAttrib<1, SH_TEMP, int> out;
    out = min(a);

    try {
      if (test.check("i_4i_callmin_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_callmin_test6
    last_test = "i_4i_callmin_test6";
    ShAttrib<4, SH_CONST, int> a(int(0.1), int(0), int(1.9), int(1.5));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    ShAttrib<1, SH_TEMP, int> out;
    out = min(a);

    try {
      if (test.check("i_4i_callmin_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_callmin_test7
    last_test = "i_4i_callmin_test7";
    ShAttrib<4, SH_CONST, int> a(int(1.0), int(2.0), int(3.0), int(4.0));
    ShAttrib<1, SH_CONST, int> expected(int(1.0));

    ShAttrib<1, SH_TEMP, int> out;
    out = min(a);

    try {
      if (test.check("i_4i_callmin_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_callmin_test8
    last_test = "i_4i_callmin_test8";
    ShAttrib<4, SH_CONST, int> a(int(2.0), int(1.0), int(4.0), int(3.0));
    ShAttrib<1, SH_CONST, int> expected(int(1.0));

    ShAttrib<1, SH_TEMP, int> out;
    out = min(a);

    try {
      if (test.check("i_4i_callmin_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_callmin_test9
    last_test = "i_4i_callmin_test9";
    ShAttrib<4, SH_CONST, int> a(int(-1.0), int(-2.1), int(-3.5), int(-4.4));
    ShAttrib<1, SH_CONST, int> expected(int(-4.4));

    ShAttrib<1, SH_TEMP, int> out;
    out = min(a);

    try {
      if (test.check("i_4i_callmin_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

