#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram neg_a_f_3f_prefix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = - a;
  } SH_END;

  neg_a_f_3f_prefix_test0.name("neg_a_f_3f_prefix_test0");
  last_test = "neg_a_f_3f_prefix_test0";
  {  // f_3f_prefix_test0
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(-0.0), float(-0.0), float(-0.0));

    try {
      if (test.run(neg_a_f_3f_prefix_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram neg_a_f_3f_prefix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = - a;
  } SH_END;

  neg_a_f_3f_prefix_test1.name("neg_a_f_3f_prefix_test1");
  last_test = "neg_a_f_3f_prefix_test1";
  {  // f_3f_prefix_test1
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(-2.0), float(-3.0));

    try {
      if (test.run(neg_a_f_3f_prefix_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram neg_a_f_3f_prefix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = - a;
  } SH_END;

  neg_a_f_3f_prefix_test2.name("neg_a_f_3f_prefix_test2");
  last_test = "neg_a_f_3f_prefix_test2";
  {  // f_3f_prefix_test2
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0));

    try {
      if (test.run(neg_a_f_3f_prefix_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram neg_a_f_4f_prefix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = - a;
  } SH_END;

  neg_a_f_4f_prefix_test3.name("neg_a_f_4f_prefix_test3");
  last_test = "neg_a_f_4f_prefix_test3";
  {  // f_4f_prefix_test3
    ShAttrib<4, SH_CONST, float> a(float(0.5), float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.5), float(1.0), float(2.0), float(3.0));

    try {
      if (test.run(neg_a_f_4f_prefix_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram neg_a_f_f_prefix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = - a;
  } SH_END;

  neg_a_f_f_prefix_test4.name("neg_a_f_f_prefix_test4");
  last_test = "neg_a_f_f_prefix_test4";
  {  // f_f_prefix_test4
    ShAttrib<1, SH_CONST, float> a(float(5000));
    ShAttrib<1, SH_CONST, float> expected(float(-5000));

    try {
      if (test.run(neg_a_f_f_prefix_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram neg_a_f_f_prefix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = - a;
  } SH_END;

  neg_a_f_f_prefix_test5.name("neg_a_f_f_prefix_test5");
  last_test = "neg_a_f_f_prefix_test5";
  {  // f_f_prefix_test5
    ShAttrib<1, SH_CONST, float> a(float(-0.3333));
    ShAttrib<1, SH_CONST, float> expected(float(0.3333));

    try {
      if (test.run(neg_a_f_f_prefix_test5, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram neg_a_i_3i_prefix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = - a;
  } SH_END;

  neg_a_i_3i_prefix_test6.name("neg_a_i_3i_prefix_test6");
  last_test = "neg_a_i_3i_prefix_test6";
  {  // i_3i_prefix_test6
    ShAttrib<3, SH_CONST, int> a(int(0.0), int(0.0), int(0.0));
    ShAttrib<3, SH_CONST, int> expected(int(-0.0), int(-0.0), int(-0.0));

    try {
      if (test.run(neg_a_i_3i_prefix_test6, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram neg_a_i_3i_prefix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = - a;
  } SH_END;

  neg_a_i_3i_prefix_test7.name("neg_a_i_3i_prefix_test7");
  last_test = "neg_a_i_3i_prefix_test7";
  {  // i_3i_prefix_test7
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> expected(int(-1.0), int(-2.0), int(-3.0));

    try {
      if (test.run(neg_a_i_3i_prefix_test7, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram neg_a_i_3i_prefix_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = - a;
  } SH_END;

  neg_a_i_3i_prefix_test8.name("neg_a_i_3i_prefix_test8");
  last_test = "neg_a_i_3i_prefix_test8";
  {  // i_3i_prefix_test8
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(-2.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1.0), int(2.0), int(3.0));

    try {
      if (test.run(neg_a_i_3i_prefix_test8, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram neg_a_i_4i_prefix_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = - a;
  } SH_END;

  neg_a_i_4i_prefix_test9.name("neg_a_i_4i_prefix_test9");
  last_test = "neg_a_i_4i_prefix_test9";
  {  // i_4i_prefix_test9
    ShAttrib<4, SH_CONST, int> a(int(0.5), int(-1.0), int(-2.0), int(-3.0));
    ShAttrib<4, SH_CONST, int> expected(int(-0.5), int(1.0), int(2.0), int(3.0));

    try {
      if (test.run(neg_a_i_4i_prefix_test9, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram neg_a_i_f_prefix_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = - a;
  } SH_END;

  neg_a_i_f_prefix_test10.name("neg_a_i_f_prefix_test10");
  last_test = "neg_a_i_f_prefix_test10";
  {  // i_f_prefix_test10
    ShAttrib<1, SH_CONST, float> a(float(5000));
    ShAttrib<1, SH_CONST, int> expected(int(-5000));

    try {
      if (test.run(neg_a_i_f_prefix_test10, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_3f_prefix_test0
    last_test = "f_3f_prefix_test0";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(-0.0), float(-0.0), float(-0.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = - a;

    try {
      if (test.check("f_3f_prefix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_prefix_test1
    last_test = "f_3f_prefix_test1";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(-2.0), float(-3.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = - a;

    try {
      if (test.check("f_3f_prefix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_prefix_test2
    last_test = "f_3f_prefix_test2";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = - a;

    try {
      if (test.check("f_3f_prefix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_prefix_test3
    last_test = "f_4f_prefix_test3";
    ShAttrib<4, SH_CONST, float> a(float(0.5), float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.5), float(1.0), float(2.0), float(3.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = - a;

    try {
      if (test.check("f_4f_prefix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_prefix_test4
    last_test = "f_f_prefix_test4";
    ShAttrib<1, SH_CONST, float> a(float(5000));
    ShAttrib<1, SH_CONST, float> expected(float(-5000));

    ShAttrib<1, SH_TEMP, float> out;
    out = - a;

    try {
      if (test.check("f_f_prefix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_prefix_test5
    last_test = "f_f_prefix_test5";
    ShAttrib<1, SH_CONST, float> a(float(-0.3333));
    ShAttrib<1, SH_CONST, float> expected(float(0.3333));

    ShAttrib<1, SH_TEMP, float> out;
    out = - a;

    try {
      if (test.check("f_f_prefix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_prefix_test6
    last_test = "i_3i_prefix_test6";
    ShAttrib<3, SH_CONST, int> a(int(0.0), int(0.0), int(0.0));
    ShAttrib<3, SH_CONST, int> expected(int(-0.0), int(-0.0), int(-0.0));

    ShAttrib<3, SH_TEMP, int> out;
    out = - a;

    try {
      if (test.check("i_3i_prefix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_prefix_test7
    last_test = "i_3i_prefix_test7";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> expected(int(-1.0), int(-2.0), int(-3.0));

    ShAttrib<3, SH_TEMP, int> out;
    out = - a;

    try {
      if (test.check("i_3i_prefix_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_prefix_test8
    last_test = "i_3i_prefix_test8";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(-2.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1.0), int(2.0), int(3.0));

    ShAttrib<3, SH_TEMP, int> out;
    out = - a;

    try {
      if (test.check("i_3i_prefix_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_prefix_test9
    last_test = "i_4i_prefix_test9";
    ShAttrib<4, SH_CONST, int> a(int(0.5), int(-1.0), int(-2.0), int(-3.0));
    ShAttrib<4, SH_CONST, int> expected(int(-0.5), int(1.0), int(2.0), int(3.0));

    ShAttrib<4, SH_TEMP, int> out;
    out = - a;

    try {
      if (test.check("i_4i_prefix_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_f_prefix_test10
    last_test = "i_f_prefix_test10";
    ShAttrib<1, SH_CONST, float> a(float(5000));
    ShAttrib<1, SH_CONST, int> expected(int(-5000));

    ShAttrib<1, SH_TEMP, int> out;
    out = - a;

    try {
      if (test.check("i_f_prefix_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

