#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram prod_a_f_4f_callprod_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_4f_callprod_test0.name("prod_a_f_4f_callprod_test0");
  last_test = "prod_a_f_4f_callprod_test0";
  {  // f_4f_callprod_test0
    ShAttrib<4, SH_CONST, float> a(float(1.5), float(1.0), float(2.718), float(3.14));
    ShAttrib<1, SH_CONST, float> expected(float(12.80178));

    try {
      if (test.run(prod_a_f_4f_callprod_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_1f_callprod_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_1f_callprod_test1.name("prod_a_f_1f_callprod_test1");
  last_test = "prod_a_f_1f_callprod_test1";
  {  // f_1f_callprod_test1
    ShAttrib<1, SH_CONST, float> a(float(1.5));
    ShAttrib<1, SH_CONST, float> expected(float(1.5));

    try {
      if (test.run(prod_a_f_1f_callprod_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_d_4d_callprod_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, double> a;
    ShAttrib<1, SH_OUTPUT, double> out;
    out = prod(a);
  } SH_END;

  prod_a_d_4d_callprod_test2.name("prod_a_d_4d_callprod_test2");
  last_test = "prod_a_d_4d_callprod_test2";
  {  // d_4d_callprod_test2
    ShAttrib<4, SH_CONST, double> a(double(1.5), double(1.0), double(2.718), double(3.14));
    ShAttrib<1, SH_CONST, double> expected(double(12.80178));

    try {
      if (test.run(prod_a_d_4d_callprod_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_d_1d_callprod_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, double> a;
    ShAttrib<1, SH_OUTPUT, double> out;
    out = prod(a);
  } SH_END;

  prod_a_d_1d_callprod_test3.name("prod_a_d_1d_callprod_test3");
  last_test = "prod_a_d_1d_callprod_test3";
  {  // d_1d_callprod_test3
    ShAttrib<1, SH_CONST, double> a(double(1.5));
    ShAttrib<1, SH_CONST, double> expected(double(1.5));

    try {
      if (test.run(prod_a_d_1d_callprod_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_i_4i_callprod_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = prod(a);
  } SH_END;

  prod_a_i_4i_callprod_test4.name("prod_a_i_4i_callprod_test4");
  last_test = "prod_a_i_4i_callprod_test4";
  {  // i_4i_callprod_test4
    ShAttrib<4, SH_CONST, int> a(int(1), int(2), int(3), int(4));
    ShAttrib<1, SH_CONST, int> expected(int(24));

    try {
      if (test.run(prod_a_i_4i_callprod_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_i_1i_callprod_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, int> a;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = prod(a);
  } SH_END;

  prod_a_i_1i_callprod_test5.name("prod_a_i_1i_callprod_test5");
  last_test = "prod_a_i_1i_callprod_test5";
  {  // i_1i_callprod_test5
    ShAttrib<1, SH_CONST, int> a(int(3));
    ShAttrib<1, SH_CONST, int> expected(int(3));

    try {
      if (test.run(prod_a_i_1i_callprod_test5, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_3f_callprod_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_3f_callprod_test6.name("prod_a_f_3f_callprod_test6");
  last_test = "prod_a_f_3f_callprod_test6";
  {  // f_3f_callprod_test6
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    try {
      if (test.run(prod_a_f_3f_callprod_test6, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_3f_callprod_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_3f_callprod_test7.name("prod_a_f_3f_callprod_test7");
  last_test = "prod_a_f_3f_callprod_test7";
  {  // f_3f_callprod_test7
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(-6.0));

    try {
      if (test.run(prod_a_f_3f_callprod_test7, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_3f_callprod_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_3f_callprod_test8.name("prod_a_f_3f_callprod_test8");
  last_test = "prod_a_f_3f_callprod_test8";
  {  // f_3f_callprod_test8
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    try {
      if (test.run(prod_a_f_3f_callprod_test8, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_3f_callprod_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_3f_callprod_test9.name("prod_a_f_3f_callprod_test9");
  last_test = "prod_a_f_3f_callprod_test9";
  {  // f_3f_callprod_test9
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(-6.0));

    try {
      if (test.run(prod_a_f_3f_callprod_test9, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_3f_callprod_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_3f_callprod_test10.name("prod_a_f_3f_callprod_test10");
  last_test = "prod_a_f_3f_callprod_test10";
  {  // f_3f_callprod_test10
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    try {
      if (test.run(prod_a_f_3f_callprod_test10, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_3f_callprod_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_3f_callprod_test11.name("prod_a_f_3f_callprod_test11");
  last_test = "prod_a_f_3f_callprod_test11";
  {  // f_3f_callprod_test11
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(-6.0));

    try {
      if (test.run(prod_a_f_3f_callprod_test11, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_3f_callprod_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_3f_callprod_test12.name("prod_a_f_3f_callprod_test12");
  last_test = "prod_a_f_3f_callprod_test12";
  {  // f_3f_callprod_test12
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(1.7442));

    try {
      if (test.run(prod_a_f_3f_callprod_test12, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_3f_callprod_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_3f_callprod_test13.name("prod_a_f_3f_callprod_test13");
  last_test = "prod_a_f_3f_callprod_test13";
  {  // f_3f_callprod_test13
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(-1.7442));

    try {
      if (test.run(prod_a_f_3f_callprod_test13, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_3f_callprod_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_3f_callprod_test14.name("prod_a_f_3f_callprod_test14");
  last_test = "prod_a_f_3f_callprod_test14";
  {  // f_3f_callprod_test14
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(1.7442));

    try {
      if (test.run(prod_a_f_3f_callprod_test14, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_3f_callprod_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_3f_callprod_test15.name("prod_a_f_3f_callprod_test15");
  last_test = "prod_a_f_3f_callprod_test15";
  {  // f_3f_callprod_test15
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(-1.7442));

    try {
      if (test.run(prod_a_f_3f_callprod_test15, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_3f_callprod_test16 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_3f_callprod_test16.name("prod_a_f_3f_callprod_test16");
  last_test = "prod_a_f_3f_callprod_test16";
  {  // f_3f_callprod_test16
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(1.7442));

    try {
      if (test.run(prod_a_f_3f_callprod_test16, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_3f_callprod_test17 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_3f_callprod_test17.name("prod_a_f_3f_callprod_test17");
  last_test = "prod_a_f_3f_callprod_test17";
  {  // f_3f_callprod_test17
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(-1.7442));

    try {
      if (test.run(prod_a_f_3f_callprod_test17, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_1f_callprod_test18 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_1f_callprod_test18.name("prod_a_f_1f_callprod_test18");
  last_test = "prod_a_f_1f_callprod_test18";
  {  // f_1f_callprod_test18
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(prod_a_f_1f_callprod_test18, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_3f_callprod_test19 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_3f_callprod_test19.name("prod_a_f_3f_callprod_test19");
  last_test = "prod_a_f_3f_callprod_test19";
  {  // f_3f_callprod_test19
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(prod_a_f_3f_callprod_test19, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_4f_callprod_test20 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_4f_callprod_test20.name("prod_a_f_4f_callprod_test20");
  last_test = "prod_a_f_4f_callprod_test20";
  {  // f_4f_callprod_test20
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(prod_a_f_4f_callprod_test20, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_4f_callprod_test21 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_4f_callprod_test21.name("prod_a_f_4f_callprod_test21");
  last_test = "prod_a_f_4f_callprod_test21";
  {  // f_4f_callprod_test21
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(prod_a_f_4f_callprod_test21, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_1f_callprod_test22 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_1f_callprod_test22.name("prod_a_f_1f_callprod_test22");
  last_test = "prod_a_f_1f_callprod_test22";
  {  // f_1f_callprod_test22
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    try {
      if (test.run(prod_a_f_1f_callprod_test22, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_1f_callprod_test23 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_1f_callprod_test23.name("prod_a_f_1f_callprod_test23");
  last_test = "prod_a_f_1f_callprod_test23";
  {  // f_1f_callprod_test23
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> expected(float(-1.0));

    try {
      if (test.run(prod_a_f_1f_callprod_test23, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_1f_callprod_test24 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_1f_callprod_test24.name("prod_a_f_1f_callprod_test24");
  last_test = "prod_a_f_1f_callprod_test24";
  {  // f_1f_callprod_test24
    ShAttrib<1, SH_CONST, float> a(float(1000.0));
    ShAttrib<1, SH_CONST, float> expected(float(1000.0));

    try {
      if (test.run(prod_a_f_1f_callprod_test24, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_1f_callprod_test25 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_1f_callprod_test25.name("prod_a_f_1f_callprod_test25");
  last_test = "prod_a_f_1f_callprod_test25";
  {  // f_1f_callprod_test25
    ShAttrib<1, SH_CONST, float> a(float(-1000.0));
    ShAttrib<1, SH_CONST, float> expected(float(-1000.0));

    try {
      if (test.run(prod_a_f_1f_callprod_test25, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_1f_callprod_test26 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_1f_callprod_test26.name("prod_a_f_1f_callprod_test26");
  last_test = "prod_a_f_1f_callprod_test26";
  {  // f_1f_callprod_test26
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> expected(float(0.5));

    try {
      if (test.run(prod_a_f_1f_callprod_test26, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram prod_a_f_1f_callprod_test27 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = prod(a);
  } SH_END;

  prod_a_f_1f_callprod_test27.name("prod_a_f_1f_callprod_test27");
  last_test = "prod_a_f_1f_callprod_test27";
  {  // f_1f_callprod_test27
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<1, SH_CONST, float> expected(float(-0.5));

    try {
      if (test.run(prod_a_f_1f_callprod_test27, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_4f_callsum_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_4f_callsum_test0.name("sum_a_f_4f_callsum_test0");
  last_test = "sum_a_f_4f_callsum_test0";
  {  // f_4f_callsum_test0
    ShAttrib<4, SH_CONST, float> a(float(1.5), float(1.0), float(2.718), float(3.14));
    ShAttrib<1, SH_CONST, float> expected(float(8.358));

    try {
      if (test.run(sum_a_f_4f_callsum_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_1f_callsum_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_1f_callsum_test1.name("sum_a_f_1f_callsum_test1");
  last_test = "sum_a_f_1f_callsum_test1";
  {  // f_1f_callsum_test1
    ShAttrib<1, SH_CONST, float> a(float(1.5));
    ShAttrib<1, SH_CONST, float> expected(float(1.5));

    try {
      if (test.run(sum_a_f_1f_callsum_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_d_4d_callsum_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, double> a;
    ShAttrib<1, SH_OUTPUT, double> out;
    out = sum(a);
  } SH_END;

  sum_a_d_4d_callsum_test2.name("sum_a_d_4d_callsum_test2");
  last_test = "sum_a_d_4d_callsum_test2";
  {  // d_4d_callsum_test2
    ShAttrib<4, SH_CONST, double> a(double(1.5), double(1.0), double(2.718), double(3.14));
    ShAttrib<1, SH_CONST, double> expected(double(8.358));

    try {
      if (test.run(sum_a_d_4d_callsum_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_d_1d_callsum_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, double> a;
    ShAttrib<1, SH_OUTPUT, double> out;
    out = sum(a);
  } SH_END;

  sum_a_d_1d_callsum_test3.name("sum_a_d_1d_callsum_test3");
  last_test = "sum_a_d_1d_callsum_test3";
  {  // d_1d_callsum_test3
    ShAttrib<1, SH_CONST, double> a(double(1.5));
    ShAttrib<1, SH_CONST, double> expected(double(1.5));

    try {
      if (test.run(sum_a_d_1d_callsum_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_i_4i_callsum_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = sum(a);
  } SH_END;

  sum_a_i_4i_callsum_test4.name("sum_a_i_4i_callsum_test4");
  last_test = "sum_a_i_4i_callsum_test4";
  {  // i_4i_callsum_test4
    ShAttrib<4, SH_CONST, int> a(int(1), int(2), int(3), int(4));
    ShAttrib<1, SH_CONST, int> expected(int(10));

    try {
      if (test.run(sum_a_i_4i_callsum_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_i_1i_callsum_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, int> a;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = sum(a);
  } SH_END;

  sum_a_i_1i_callsum_test5.name("sum_a_i_1i_callsum_test5");
  last_test = "sum_a_i_1i_callsum_test5";
  {  // i_1i_callsum_test5
    ShAttrib<1, SH_CONST, int> a(int(3));
    ShAttrib<1, SH_CONST, int> expected(int(3));

    try {
      if (test.run(sum_a_i_1i_callsum_test5, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_3f_callsum_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_3f_callsum_test6.name("sum_a_f_3f_callsum_test6");
  last_test = "sum_a_f_3f_callsum_test6";
  {  // f_3f_callsum_test6
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    try {
      if (test.run(sum_a_f_3f_callsum_test6, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_3f_callsum_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_3f_callsum_test7.name("sum_a_f_3f_callsum_test7");
  last_test = "sum_a_f_3f_callsum_test7";
  {  // f_3f_callsum_test7
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(sum_a_f_3f_callsum_test7, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_3f_callsum_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_3f_callsum_test8.name("sum_a_f_3f_callsum_test8");
  last_test = "sum_a_f_3f_callsum_test8";
  {  // f_3f_callsum_test8
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(-4.0));

    try {
      if (test.run(sum_a_f_3f_callsum_test8, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_3f_callsum_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_3f_callsum_test9.name("sum_a_f_3f_callsum_test9");
  last_test = "sum_a_f_3f_callsum_test9";
  {  // f_3f_callsum_test9
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(-6.0));

    try {
      if (test.run(sum_a_f_3f_callsum_test9, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_3f_callsum_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_3f_callsum_test10.name("sum_a_f_3f_callsum_test10");
  last_test = "sum_a_f_3f_callsum_test10";
  {  // f_3f_callsum_test10
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(sum_a_f_3f_callsum_test10, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_3f_callsum_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_3f_callsum_test11.name("sum_a_f_3f_callsum_test11");
  last_test = "sum_a_f_3f_callsum_test11";
  {  // f_3f_callsum_test11
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(4.0));

    try {
      if (test.run(sum_a_f_3f_callsum_test11, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_3f_callsum_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_3f_callsum_test12.name("sum_a_f_3f_callsum_test12");
  last_test = "sum_a_f_3f_callsum_test12";
  {  // f_3f_callsum_test12
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(6.13));

    try {
      if (test.run(sum_a_f_3f_callsum_test12, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_3f_callsum_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_3f_callsum_test13.name("sum_a_f_3f_callsum_test13");
  last_test = "sum_a_f_3f_callsum_test13";
  {  // f_3f_callsum_test13
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(-0.33));

    try {
      if (test.run(sum_a_f_3f_callsum_test13, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_3f_callsum_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_3f_callsum_test14.name("sum_a_f_3f_callsum_test14");
  last_test = "sum_a_f_3f_callsum_test14";
  {  // f_3f_callsum_test14
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(-5.73));

    try {
      if (test.run(sum_a_f_3f_callsum_test14, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_3f_callsum_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_3f_callsum_test15.name("sum_a_f_3f_callsum_test15");
  last_test = "sum_a_f_3f_callsum_test15";
  {  // f_3f_callsum_test15
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(-6.13));

    try {
      if (test.run(sum_a_f_3f_callsum_test15, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_3f_callsum_test16 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_3f_callsum_test16.name("sum_a_f_3f_callsum_test16");
  last_test = "sum_a_f_3f_callsum_test16";
  {  // f_3f_callsum_test16
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(0.33));

    try {
      if (test.run(sum_a_f_3f_callsum_test16, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_3f_callsum_test17 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_3f_callsum_test17.name("sum_a_f_3f_callsum_test17");
  last_test = "sum_a_f_3f_callsum_test17";
  {  // f_3f_callsum_test17
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(5.73));

    try {
      if (test.run(sum_a_f_3f_callsum_test17, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_1f_callsum_test18 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_1f_callsum_test18.name("sum_a_f_1f_callsum_test18");
  last_test = "sum_a_f_1f_callsum_test18";
  {  // f_1f_callsum_test18
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(sum_a_f_1f_callsum_test18, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_3f_callsum_test19 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_3f_callsum_test19.name("sum_a_f_3f_callsum_test19");
  last_test = "sum_a_f_3f_callsum_test19";
  {  // f_3f_callsum_test19
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(sum_a_f_3f_callsum_test19, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_4f_callsum_test20 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_4f_callsum_test20.name("sum_a_f_4f_callsum_test20");
  last_test = "sum_a_f_4f_callsum_test20";
  {  // f_4f_callsum_test20
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(sum_a_f_4f_callsum_test20, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_4f_callsum_test21 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_4f_callsum_test21.name("sum_a_f_4f_callsum_test21");
  last_test = "sum_a_f_4f_callsum_test21";
  {  // f_4f_callsum_test21
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(sum_a_f_4f_callsum_test21, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_1f_callsum_test22 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_1f_callsum_test22.name("sum_a_f_1f_callsum_test22");
  last_test = "sum_a_f_1f_callsum_test22";
  {  // f_1f_callsum_test22
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    try {
      if (test.run(sum_a_f_1f_callsum_test22, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_1f_callsum_test23 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_1f_callsum_test23.name("sum_a_f_1f_callsum_test23");
  last_test = "sum_a_f_1f_callsum_test23";
  {  // f_1f_callsum_test23
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> expected(float(-1.0));

    try {
      if (test.run(sum_a_f_1f_callsum_test23, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_1f_callsum_test24 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_1f_callsum_test24.name("sum_a_f_1f_callsum_test24");
  last_test = "sum_a_f_1f_callsum_test24";
  {  // f_1f_callsum_test24
    ShAttrib<1, SH_CONST, float> a(float(1000.0));
    ShAttrib<1, SH_CONST, float> expected(float(1000.0));

    try {
      if (test.run(sum_a_f_1f_callsum_test24, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_1f_callsum_test25 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_1f_callsum_test25.name("sum_a_f_1f_callsum_test25");
  last_test = "sum_a_f_1f_callsum_test25";
  {  // f_1f_callsum_test25
    ShAttrib<1, SH_CONST, float> a(float(-1000.0));
    ShAttrib<1, SH_CONST, float> expected(float(-1000.0));

    try {
      if (test.run(sum_a_f_1f_callsum_test25, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_1f_callsum_test26 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_1f_callsum_test26.name("sum_a_f_1f_callsum_test26");
  last_test = "sum_a_f_1f_callsum_test26";
  {  // f_1f_callsum_test26
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> expected(float(0.5));

    try {
      if (test.run(sum_a_f_1f_callsum_test26, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sum_a_f_1f_callsum_test27 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sum(a);
  } SH_END;

  sum_a_f_1f_callsum_test27.name("sum_a_f_1f_callsum_test27");
  last_test = "sum_a_f_1f_callsum_test27";
  {  // f_1f_callsum_test27
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<1, SH_CONST, float> expected(float(-0.5));

    try {
      if (test.run(sum_a_f_1f_callsum_test27, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_4f_callprod_test0
    last_test = "f_4f_callprod_test0";
    ShAttrib<4, SH_CONST, float> a(float(1.5), float(1.0), float(2.718), float(3.14));
    ShAttrib<1, SH_CONST, float> expected(float(12.80178));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_4f_callprod_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callprod_test1
    last_test = "f_1f_callprod_test1";
    ShAttrib<1, SH_CONST, float> a(float(1.5));
    ShAttrib<1, SH_CONST, float> expected(float(1.5));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_1f_callprod_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // d_4d_callprod_test2
    last_test = "d_4d_callprod_test2";
    ShAttrib<4, SH_CONST, double> a(double(1.5), double(1.0), double(2.718), double(3.14));
    ShAttrib<1, SH_CONST, double> expected(double(12.80178));

    ShAttrib<1, SH_TEMP, double> out;
    out = prod(a);

    try {
      if (test.check("d_4d_callprod_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // d_1d_callprod_test3
    last_test = "d_1d_callprod_test3";
    ShAttrib<1, SH_CONST, double> a(double(1.5));
    ShAttrib<1, SH_CONST, double> expected(double(1.5));

    ShAttrib<1, SH_TEMP, double> out;
    out = prod(a);

    try {
      if (test.check("d_1d_callprod_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_callprod_test4
    last_test = "i_4i_callprod_test4";
    ShAttrib<4, SH_CONST, int> a(int(1), int(2), int(3), int(4));
    ShAttrib<1, SH_CONST, int> expected(int(24));

    ShAttrib<1, SH_TEMP, int> out;
    out = prod(a);

    try {
      if (test.check("i_4i_callprod_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1i_callprod_test5
    last_test = "i_1i_callprod_test5";
    ShAttrib<1, SH_CONST, int> a(int(3));
    ShAttrib<1, SH_CONST, int> expected(int(3));

    ShAttrib<1, SH_TEMP, int> out;
    out = prod(a);

    try {
      if (test.check("i_1i_callprod_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callprod_test6
    last_test = "f_3f_callprod_test6";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_3f_callprod_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callprod_test7
    last_test = "f_3f_callprod_test7";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(-6.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_3f_callprod_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callprod_test8
    last_test = "f_3f_callprod_test8";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_3f_callprod_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callprod_test9
    last_test = "f_3f_callprod_test9";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(-6.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_3f_callprod_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callprod_test10
    last_test = "f_3f_callprod_test10";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_3f_callprod_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callprod_test11
    last_test = "f_3f_callprod_test11";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(-6.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_3f_callprod_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callprod_test12
    last_test = "f_3f_callprod_test12";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(1.7442));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_3f_callprod_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callprod_test13
    last_test = "f_3f_callprod_test13";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(-1.7442));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_3f_callprod_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callprod_test14
    last_test = "f_3f_callprod_test14";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(1.7442));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_3f_callprod_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callprod_test15
    last_test = "f_3f_callprod_test15";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(-1.7442));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_3f_callprod_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callprod_test16
    last_test = "f_3f_callprod_test16";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(1.7442));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_3f_callprod_test16", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callprod_test17
    last_test = "f_3f_callprod_test17";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(-1.7442));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_3f_callprod_test17", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callprod_test18
    last_test = "f_1f_callprod_test18";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_1f_callprod_test18", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callprod_test19
    last_test = "f_3f_callprod_test19";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_3f_callprod_test19", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callprod_test20
    last_test = "f_4f_callprod_test20";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_4f_callprod_test20", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callprod_test21
    last_test = "f_4f_callprod_test21";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_4f_callprod_test21", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callprod_test22
    last_test = "f_1f_callprod_test22";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_1f_callprod_test22", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callprod_test23
    last_test = "f_1f_callprod_test23";
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> expected(float(-1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_1f_callprod_test23", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callprod_test24
    last_test = "f_1f_callprod_test24";
    ShAttrib<1, SH_CONST, float> a(float(1000.0));
    ShAttrib<1, SH_CONST, float> expected(float(1000.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_1f_callprod_test24", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callprod_test25
    last_test = "f_1f_callprod_test25";
    ShAttrib<1, SH_CONST, float> a(float(-1000.0));
    ShAttrib<1, SH_CONST, float> expected(float(-1000.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_1f_callprod_test25", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callprod_test26
    last_test = "f_1f_callprod_test26";
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> expected(float(0.5));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_1f_callprod_test26", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callprod_test27
    last_test = "f_1f_callprod_test27";
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<1, SH_CONST, float> expected(float(-0.5));

    ShAttrib<1, SH_TEMP, float> out;
    out = prod(a);

    try {
      if (test.check("f_1f_callprod_test27", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callsum_test0
    last_test = "f_4f_callsum_test0";
    ShAttrib<4, SH_CONST, float> a(float(1.5), float(1.0), float(2.718), float(3.14));
    ShAttrib<1, SH_CONST, float> expected(float(8.358));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_4f_callsum_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callsum_test1
    last_test = "f_1f_callsum_test1";
    ShAttrib<1, SH_CONST, float> a(float(1.5));
    ShAttrib<1, SH_CONST, float> expected(float(1.5));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_1f_callsum_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // d_4d_callsum_test2
    last_test = "d_4d_callsum_test2";
    ShAttrib<4, SH_CONST, double> a(double(1.5), double(1.0), double(2.718), double(3.14));
    ShAttrib<1, SH_CONST, double> expected(double(8.358));

    ShAttrib<1, SH_TEMP, double> out;
    out = sum(a);

    try {
      if (test.check("d_4d_callsum_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // d_1d_callsum_test3
    last_test = "d_1d_callsum_test3";
    ShAttrib<1, SH_CONST, double> a(double(1.5));
    ShAttrib<1, SH_CONST, double> expected(double(1.5));

    ShAttrib<1, SH_TEMP, double> out;
    out = sum(a);

    try {
      if (test.check("d_1d_callsum_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_callsum_test4
    last_test = "i_4i_callsum_test4";
    ShAttrib<4, SH_CONST, int> a(int(1), int(2), int(3), int(4));
    ShAttrib<1, SH_CONST, int> expected(int(10));

    ShAttrib<1, SH_TEMP, int> out;
    out = sum(a);

    try {
      if (test.check("i_4i_callsum_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1i_callsum_test5
    last_test = "i_1i_callsum_test5";
    ShAttrib<1, SH_CONST, int> a(int(3));
    ShAttrib<1, SH_CONST, int> expected(int(3));

    ShAttrib<1, SH_TEMP, int> out;
    out = sum(a);

    try {
      if (test.check("i_1i_callsum_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callsum_test6
    last_test = "f_3f_callsum_test6";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_3f_callsum_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callsum_test7
    last_test = "f_3f_callsum_test7";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_3f_callsum_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callsum_test8
    last_test = "f_3f_callsum_test8";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(-4.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_3f_callsum_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callsum_test9
    last_test = "f_3f_callsum_test9";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(-6.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_3f_callsum_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callsum_test10
    last_test = "f_3f_callsum_test10";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_3f_callsum_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callsum_test11
    last_test = "f_3f_callsum_test11";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(4.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_3f_callsum_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callsum_test12
    last_test = "f_3f_callsum_test12";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(6.13));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_3f_callsum_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callsum_test13
    last_test = "f_3f_callsum_test13";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(-0.33));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_3f_callsum_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callsum_test14
    last_test = "f_3f_callsum_test14";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(-5.73));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_3f_callsum_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callsum_test15
    last_test = "f_3f_callsum_test15";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(-6.13));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_3f_callsum_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callsum_test16
    last_test = "f_3f_callsum_test16";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(0.33));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_3f_callsum_test16", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callsum_test17
    last_test = "f_3f_callsum_test17";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(5.73));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_3f_callsum_test17", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callsum_test18
    last_test = "f_1f_callsum_test18";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_1f_callsum_test18", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callsum_test19
    last_test = "f_3f_callsum_test19";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_3f_callsum_test19", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callsum_test20
    last_test = "f_4f_callsum_test20";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_4f_callsum_test20", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callsum_test21
    last_test = "f_4f_callsum_test21";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_4f_callsum_test21", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callsum_test22
    last_test = "f_1f_callsum_test22";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_1f_callsum_test22", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callsum_test23
    last_test = "f_1f_callsum_test23";
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> expected(float(-1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_1f_callsum_test23", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callsum_test24
    last_test = "f_1f_callsum_test24";
    ShAttrib<1, SH_CONST, float> a(float(1000.0));
    ShAttrib<1, SH_CONST, float> expected(float(1000.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_1f_callsum_test24", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callsum_test25
    last_test = "f_1f_callsum_test25";
    ShAttrib<1, SH_CONST, float> a(float(-1000.0));
    ShAttrib<1, SH_CONST, float> expected(float(-1000.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_1f_callsum_test25", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callsum_test26
    last_test = "f_1f_callsum_test26";
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> expected(float(0.5));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_1f_callsum_test26", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callsum_test27
    last_test = "f_1f_callsum_test27";
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<1, SH_CONST, float> expected(float(-0.5));

    ShAttrib<1, SH_TEMP, float> out;
    out = sum(a);

    try {
      if (test.check("f_1f_callsum_test27", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

