#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram round_a_f_4f_callround_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = round(a);
  } SH_END;

  round_a_f_4f_callround_test0.name("round_a_f_4f_callround_test0");
  last_test = "round_a_f_4f_callround_test0";
  {  // f_4f_callround_test0
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.1), float(0.5), float(0.8));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.0), float(1.0), float(1.0));

    try {
      if (test.run(round_a_f_4f_callround_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram round_a_f_3f_callround_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = round(a);
  } SH_END;

  round_a_f_3f_callround_test1.name("round_a_f_3f_callround_test1");
  last_test = "round_a_f_3f_callround_test1";
  {  // f_3f_callround_test1
    ShAttrib<3, SH_CONST, float> a(float(1001.5), float(1000.5), float(1.67));
    ShAttrib<3, SH_CONST, float> expected(float(1002.0), float(1001.0), float(2.0));

    try {
      if (test.run(round_a_f_3f_callround_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram round_a_f_4f_callround_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = round(a);
  } SH_END;

  round_a_f_4f_callround_test2.name("round_a_f_4f_callround_test2");
  last_test = "round_a_f_4f_callround_test2";
  {  // f_4f_callround_test2
    ShAttrib<4, SH_CONST, float> a(float(-1.51), float(-1.49), float(-1.1), float(-1.9));
    ShAttrib<4, SH_CONST, float> expected(float(-2.0), float(-1.0), float(-1.0), float(-2.0));

    try {
      if (test.run(round_a_f_4f_callround_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram round_a_f_4f_callround_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = round(a);
  } SH_END;

  round_a_f_4f_callround_test3.name("round_a_f_4f_callround_test3");
  last_test = "round_a_f_4f_callround_test3";
  {  // f_4f_callround_test3
    ShAttrib<4, SH_CONST, float> a(float(-0.0), float(-0.1), float(-0.6), float(-0.25));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(-0.0), float(-1.0), float(-0.0));

    try {
      if (test.run(round_a_f_4f_callround_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram round_a_f_1f_callround_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = round(a);
  } SH_END;

  round_a_f_1f_callround_test4.name("round_a_f_1f_callround_test4");
  last_test = "round_a_f_1f_callround_test4";
  {  // f_1f_callround_test4
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    try {
      if (test.run(round_a_f_1f_callround_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_4f_callround_test0
    last_test = "f_4f_callround_test0";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.1), float(0.5), float(0.8));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.0), float(1.0), float(1.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = round(a);

    try {
      if (test.check("f_4f_callround_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callround_test1
    last_test = "f_3f_callround_test1";
    ShAttrib<3, SH_CONST, float> a(float(1001.5), float(1000.5), float(1.67));
    ShAttrib<3, SH_CONST, float> expected(float(1002.0), float(1001.0), float(2.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = round(a);

    try {
      if (test.check("f_3f_callround_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callround_test2
    last_test = "f_4f_callround_test2";
    ShAttrib<4, SH_CONST, float> a(float(-1.51), float(-1.49), float(-1.1), float(-1.9));
    ShAttrib<4, SH_CONST, float> expected(float(-2.0), float(-1.0), float(-1.0), float(-2.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = round(a);

    try {
      if (test.check("f_4f_callround_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callround_test3
    last_test = "f_4f_callround_test3";
    ShAttrib<4, SH_CONST, float> a(float(-0.0), float(-0.1), float(-0.6), float(-0.25));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(-0.0), float(-1.0), float(-0.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = round(a);

    try {
      if (test.check("f_4f_callround_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callround_test4
    last_test = "f_1f_callround_test4";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = round(a);

    try {
      if (test.check("f_1f_callround_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

