#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram sub_a_f_3f_3f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a - b;
  } SH_END;

  sub_a_f_3f_3f_infix_test0.name("sub_a_f_3f_3f_infix_test0");
  last_test = "sub_a_f_3f_3f_infix_test0";
  {  // f_3f_3f_infix_test0
    ShAttrib<3, SH_CONST, float> a(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> b(float(0.0), float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(3.0), float(3.0), float(3.0));

    try {
      if (test.run(sub_a_f_3f_3f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sub_a_f_3f_1f_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a - b;
  } SH_END;

  sub_a_f_3f_1f_infix_test1.name("sub_a_f_3f_1f_infix_test1");
  last_test = "sub_a_f_3f_1f_infix_test1";
  {  // f_3f_1f_infix_test1
    ShAttrib<3, SH_CONST, float> a(float(3.0), float(4.0), float(5.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(2.0), float(3.0), float(4.0));

    try {
      if (test.run(sub_a_f_3f_1f_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sub_a_f_3f_3f_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a - b;
  } SH_END;

  sub_a_f_3f_3f_infix_test2.name("sub_a_f_3f_3f_infix_test2");
  last_test = "sub_a_f_3f_3f_infix_test2";
  {  // f_3f_3f_infix_test2
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<3, SH_CONST, float> expected(float(8.0), float(10.0), float(12.0));

    try {
      if (test.run(sub_a_f_3f_3f_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sub_a_f_3f_3f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a - b;
  } SH_END;

  sub_a_f_3f_3f_infix_test3.name("sub_a_f_3f_3f_infix_test3");
  last_test = "sub_a_f_3f_3f_infix_test3";
  {  // f_3f_3f_infix_test3
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    try {
      if (test.run(sub_a_f_3f_3f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sub_a_f_3f_f_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a - b;
  } SH_END;

  sub_a_f_3f_f_infix_test4.name("sub_a_f_3f_f_infix_test4");
  last_test = "sub_a_f_3f_f_infix_test4";
  {  // f_3f_f_infix_test4
    ShAttrib<3, SH_CONST, float> a(float(0.5), float(2.0), float(-3.3333));
    ShAttrib<1, SH_CONST, float> b(float(1000));
    ShAttrib<3, SH_CONST, float> expected(float(-999.5), float(-998.0), float(-1003.3333));

    try {
      if (test.run(sub_a_f_3f_f_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sub_a_f_1f_3f_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a - b;
  } SH_END;

  sub_a_f_1f_3f_infix_test5.name("sub_a_f_1f_3f_infix_test5");
  last_test = "sub_a_f_1f_3f_infix_test5";
  {  // f_1f_3f_infix_test5
    ShAttrib<1, SH_CONST, float> a(float(7.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(6.0), float(5.0), float(4.0));

    try {
      if (test.run(sub_a_f_1f_3f_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sub_a_f_1f_1f_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a - b;
  } SH_END;

  sub_a_f_1f_1f_infix_test6.name("sub_a_f_1f_1f_infix_test6");
  last_test = "sub_a_f_1f_1f_infix_test6";
  {  // f_1f_1f_infix_test6
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<1, SH_CONST, float> expected(float(-6.0));

    try {
      if (test.run(sub_a_f_1f_1f_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sub_a_f_f_3f_infix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a - b;
  } SH_END;

  sub_a_f_f_3f_infix_test7.name("sub_a_f_f_3f_infix_test7");
  last_test = "sub_a_f_f_3f_infix_test7";
  {  // f_f_3f_infix_test7
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<3, SH_CONST, float> b(float(0.5), float(2.0), float(-3.3333));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(-2.5), float(2.8333));

    try {
      if (test.run(sub_a_f_f_3f_infix_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram msub_a_f_3f_3f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a -= b;
  } SH_END;

  msub_a_f_3f_3f_infix_test0.name("msub_a_f_3f_3f_infix_test0");
  last_test = "msub_a_f_3f_3f_infix_test0";
  {  // f_3f_3f_infix_test0
    ShAttrib<3, SH_CONST, float> a(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> b(float(0.0), float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(3.0), float(3.0), float(3.0));

    try {
      if (test.run(msub_a_f_3f_3f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram msub_a_f_3f_1f_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a -= b;
  } SH_END;

  msub_a_f_3f_1f_infix_test1.name("msub_a_f_3f_1f_infix_test1");
  last_test = "msub_a_f_3f_1f_infix_test1";
  {  // f_3f_1f_infix_test1
    ShAttrib<3, SH_CONST, float> a(float(3.0), float(4.0), float(5.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(2.0), float(3.0), float(4.0));

    try {
      if (test.run(msub_a_f_3f_1f_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram msub_a_f_3f_3f_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a -= b;
  } SH_END;

  msub_a_f_3f_3f_infix_test2.name("msub_a_f_3f_3f_infix_test2");
  last_test = "msub_a_f_3f_3f_infix_test2";
  {  // f_3f_3f_infix_test2
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<3, SH_CONST, float> expected(float(8.0), float(10.0), float(12.0));

    try {
      if (test.run(msub_a_f_3f_3f_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram msub_a_f_3f_3f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a -= b;
  } SH_END;

  msub_a_f_3f_3f_infix_test3.name("msub_a_f_3f_3f_infix_test3");
  last_test = "msub_a_f_3f_3f_infix_test3";
  {  // f_3f_3f_infix_test3
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    try {
      if (test.run(msub_a_f_3f_3f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram msub_a_f_3f_f_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a -= b;
  } SH_END;

  msub_a_f_3f_f_infix_test4.name("msub_a_f_3f_f_infix_test4");
  last_test = "msub_a_f_3f_f_infix_test4";
  {  // f_3f_f_infix_test4
    ShAttrib<3, SH_CONST, float> a(float(0.5), float(2.0), float(-3.3333));
    ShAttrib<1, SH_CONST, float> b(float(1000));
    ShAttrib<3, SH_CONST, float> expected(float(-999.5), float(-998.0), float(-1003.3333));

    try {
      if (test.run(msub_a_f_3f_f_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sub_im_a_f_3f_3f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a - b;
  } SH_END;

  sub_im_a_f_3f_3f_infix_test0.name("sub_im_a_f_3f_3f_infix_test0");
  last_test = "sub_im_a_f_3f_3f_infix_test0";
  {  // f_3f_3f_infix_test0
    ShAttrib<3, SH_CONST, float> a(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> b(float(0.0), float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(3.0), float(3.0), float(3.0));

    try {
      if (test.run(sub_im_a_f_3f_3f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sub_im_a_f_3f_1f_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a - b;
  } SH_END;

  sub_im_a_f_3f_1f_infix_test1.name("sub_im_a_f_3f_1f_infix_test1");
  last_test = "sub_im_a_f_3f_1f_infix_test1";
  {  // f_3f_1f_infix_test1
    ShAttrib<3, SH_CONST, float> a(float(3.0), float(4.0), float(5.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(2.0), float(3.0), float(4.0));

    try {
      if (test.run(sub_im_a_f_3f_1f_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sub_im_a_f_3f_3f_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a - b;
  } SH_END;

  sub_im_a_f_3f_3f_infix_test2.name("sub_im_a_f_3f_3f_infix_test2");
  last_test = "sub_im_a_f_3f_3f_infix_test2";
  {  // f_3f_3f_infix_test2
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<3, SH_CONST, float> expected(float(8.0), float(10.0), float(12.0));

    try {
      if (test.run(sub_im_a_f_3f_3f_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sub_im_a_f_3f_3f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a - b;
  } SH_END;

  sub_im_a_f_3f_3f_infix_test3.name("sub_im_a_f_3f_3f_infix_test3");
  last_test = "sub_im_a_f_3f_3f_infix_test3";
  {  // f_3f_3f_infix_test3
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    try {
      if (test.run(sub_im_a_f_3f_3f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sub_im_a_f_3f_f_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a - b;
  } SH_END;

  sub_im_a_f_3f_f_infix_test4.name("sub_im_a_f_3f_f_infix_test4");
  last_test = "sub_im_a_f_3f_f_infix_test4";
  {  // f_3f_f_infix_test4
    ShAttrib<3, SH_CONST, float> a(float(0.5), float(2.0), float(-3.3333));
    ShAttrib<1, SH_CONST, float> b(float(1000));
    ShAttrib<3, SH_CONST, float> expected(float(-999.5), float(-998.0), float(-1003.3333));

    try {
      if (test.run(sub_im_a_f_3f_f_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sub_im_a_f_1f_3f_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a - b;
  } SH_END;

  sub_im_a_f_1f_3f_infix_test5.name("sub_im_a_f_1f_3f_infix_test5");
  last_test = "sub_im_a_f_1f_3f_infix_test5";
  {  // f_1f_3f_infix_test5
    ShAttrib<1, SH_CONST, float> a(float(7.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(6.0), float(5.0), float(4.0));

    try {
      if (test.run(sub_im_a_f_1f_3f_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sub_im_a_f_1f_1f_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a - b;
  } SH_END;

  sub_im_a_f_1f_1f_infix_test6.name("sub_im_a_f_1f_1f_infix_test6");
  last_test = "sub_im_a_f_1f_1f_infix_test6";
  {  // f_1f_1f_infix_test6
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<1, SH_CONST, float> expected(float(-6.0));

    try {
      if (test.run(sub_im_a_f_1f_1f_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sub_im_a_f_f_3f_infix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a - b;
  } SH_END;

  sub_im_a_f_f_3f_infix_test7.name("sub_im_a_f_f_3f_infix_test7");
  last_test = "sub_im_a_f_f_3f_infix_test7";
  {  // f_f_3f_infix_test7
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<3, SH_CONST, float> b(float(0.5), float(2.0), float(-3.3333));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(-2.5), float(2.8333));

    try {
      if (test.run(sub_im_a_f_f_3f_infix_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_3f_3f_infix_test0
    last_test = "f_3f_3f_infix_test0";
    ShAttrib<3, SH_CONST, float> a(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> b(float(0.0), float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(3.0), float(3.0), float(3.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a -= b;

    try {
      if (test.check("f_3f_3f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_1f_infix_test1
    last_test = "f_3f_1f_infix_test1";
    ShAttrib<3, SH_CONST, float> a(float(3.0), float(4.0), float(5.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(2.0), float(3.0), float(4.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a -= b;

    try {
      if (test.check("f_3f_1f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test2
    last_test = "f_3f_3f_infix_test2";
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<3, SH_CONST, float> expected(float(8.0), float(10.0), float(12.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a -= b;

    try {
      if (test.check("f_3f_3f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a -= b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test4
    last_test = "f_3f_f_infix_test4";
    ShAttrib<3, SH_CONST, float> a(float(0.5), float(2.0), float(-3.3333));
    ShAttrib<1, SH_CONST, float> b(float(1000));
    ShAttrib<3, SH_CONST, float> expected(float(-999.5), float(-998.0), float(-1003.3333));

    ShAttrib<3, SH_TEMP, float> out;
    out = a -= b;

    try {
      if (test.check("f_3f_f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

